SystemOrganization addCategory: #ConsCell!


Object subclass: #ConsCell
	instanceVariableNames: 'car cdr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConsCell'!

Object subclass: #ConsGenerator
	instanceVariableNames: 'cc'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConsCell'!

ConsGenerator class
	instanceVariableNames: ''!

ConsCell class
	instanceVariableNames: ''!


!ConsCell commentStamp: 'spfa 2/18/2014 19:55' prior: 0!
A Lisp cons cell, or a Prolog list

	It can be converted into an Array:
	(ConsCell car: 1 cdr: (ConsCell car: 2 cdr: nil)) arrayForm    "printIt"

	... or not:
	(ConsCell car: 1 cdr: 2) arrayForm     "doIt"

	It can be created from an Array:
	#('hello' 'world') asCons        "printIt"




!
]style[(290)!

!ConsCell methodsFor: 'testing' stamp: 'spfa 11/18/2009 18:08'!
= aConsCell

	self isCircular ifTrue: 
		[^ self withCut = aConsCell withCut].

	self species = aConsCell species
		ifTrue: [^ car = aConsCell car and: [cdr = aConsCell cdr]]
		ifFalse: [^false]! !

!ConsCell methodsFor: 'list operations' stamp: 'spfa 11/18/2009 18:08'!
addLast: anObject

	self lastCell cdr: (self tailClass car: anObject)! !

!ConsCell methodsFor: 'list operations' stamp: 'spfa 11/18/2009 18:08'!
append: aConsCell

	self lastCell cdr: aConsCell
	! !

!Array methodsFor: '*ConsCell' stamp: 'spfa 11/18/2009 18:07'!
arrayForm

	^ self! !

!ConsCell methodsFor: 'conversion' stamp: 'spfa 11/18/2009 18:08'!
arrayForm

	^ Array streamContents: [:stream | self inArray: stream]

! !

!UndefinedObject methodsFor: '*ConsCell' stamp: 'spfa 11/18/2009 18:17'!
arrayForm

	^ #()! !

!Array methodsFor: '*ConsCell' stamp: 'spfa 11/18/2009 18:07'!
asCons

	| cons |

	self size = 0 ifTrue: [^ nil].
	self size = 1 ifTrue: [^ ConsCell car: (self at: 1) asCons].

	self reverseDo: [:elt | 
		cons := ConsCell car: elt asCons cdr: cons].
	^ cons

! !

!Interval methodsFor: '*ConsCell' stamp: 'spfa 2/14/2012 13:26'!
asCons

	^ self asArray asCons! !

!Object methodsFor: '*ConsCell' stamp: 'spfa 11/18/2009 18:15'!
asCons

	^ self! !

!Array methodsFor: '*ConsCell' stamp: 'spfa 11/9/2012 17:42'!
asConsList

	^ ConsCell fromList: self! !

!Array methodsFor: '*ConsCell' stamp: 'spfa 9/13/2018 10:27'!
asCyclicCons

	^ self asCons in: [:cc | cc append: cc]

! !

!ConsGenerator methodsFor: 'as yet unclassified' stamp: 'spfa 9/13/2018 10:42'!
atEnd

	^ cc cdr isNil! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:08'!
caar

	^ car car! !

!ConsCell class methodsFor: 'instance creation' stamp: 'spfa 11/18/2009 18:08'!
caar: anObject

	^ self car: (self car: anObject) ! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:08'!
cadr

	^ cdr car! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:08'!
car

	^ car! !

!UndefinedObject methodsFor: '*ConsCell' stamp: 'spfa 11/18/2009 18:17'!
car

	^ nil! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:08'!
car: anObject

	car := anObject! !

!ConsCell class methodsFor: 'instance creation' stamp: 'spfa 11/18/2009 18:08'!
car: anObject

	^ self new car: anObject ! !

!ConsCell class methodsFor: 'instance creation' stamp: 'spfa 2/11/2014 12:13'!
car: anObject cdr: bObject

	^ self new car: anObject; cdr: bObject! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:08'!
cdar

	^ car cdr! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:08'!
cddr

	^ cdr cdr! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:08'!
cdr

	^ cdr! !

!Object methodsFor: '*ConsCell' stamp: 'spfa 11/18/2009 18:15'!
cdr

	self error: 'not a list'! !

!UndefinedObject methodsFor: '*ConsCell' stamp: 'spfa 11/18/2009 18:17'!
cdr

	^ nil! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:08'!
cdr: anObject

	cdr := anObject! !

!ConsCell methodsFor: 'list operations' stamp: 'spfa 11/18/2009 18:08'!
cells

	^ Array streamContents: [:str | 
		self cellsDo: [:cell | str nextPut: cell]]! !

!ConsCell methodsFor: 'list operations' stamp: 'spfa 11/18/2009 18:08'!
cellsDo: aBlock

	| cell |
	cell := self.
	[cell isConsCell] whileTrue: [aBlock value: cell. cell := cell cdr]

! !

!ConsCell methodsFor: 'list operations' stamp: 'spfa 11/18/2009 18:08'!
collect: aBlock

	^ self class car: (aBlock value: car)
		cdr: (cdr isConsCell ifTrue: [cdr collect: aBlock] ifFalse: [cdr])! !

!ConsGenerator methodsFor: 'as yet unclassified' stamp: 'spfa 9/13/2018 10:39'!
consCell

	^ cc ! !

!ConsGenerator methodsFor: 'as yet unclassified' stamp: 'spfa 9/13/2018 10:39'!
consCell: aConsCell

	cc := aConsCell! !

!Array methodsFor: '*ConsCell' stamp: 'spfa 11/18/2009 18:07'!
cycles

	^ self storeCycles: IdentityDictionary new with: IdentitySet new
! !

!ConsCell methodsFor: 'testing' stamp: 'spfa 11/18/2009 18:08'!
cycles

	^ self storeCycles: IdentityDictionary new with: IdentitySet new
! !

!ConsGenerator class methodsFor: 'as yet unclassified' stamp: 'spfa 6/14/2019 10:36'!
cyclicOn: anArray

	^ self new consCell: anArray asArray asCyclicCons! !

!ConsCell methodsFor: 'list operations' stamp: 'spfa 11/18/2009 18:08'!
detect: aBlock ifNone: bBlock

	| cell |
	cell := self.
	[cell isConsCell] whileTrue: [
		(aBlock value: cell car) ifTrue: [^ cell car]. 
		cell := cell cdr].

	^ bBlock value
! !

!ConsCell methodsFor: 'list operations' stamp: 'spfa 11/18/2009 18:08'!
do: aBlock

	| cell |
	cell := self.
	[cell isConsCell] whileTrue: [aBlock value: cell car. cell := cell cdr]

! !

!ConsCell methodsFor: 'list operations' stamp: 'spfa 11/18/2009 18:08'!
doWithCdr: aBlock

	| cell |
	cell := self.
	[cell isConsCell] whileTrue: [aBlock value: cell car value: (cell := cell cdr)]

! !

!ConsCell methodsFor: 'list operations' stamp: 'spfa 11/18/2009 18:08'!
doWithCell: aBlock

	| cell |
	cell := self.
	[cell isConsCell] whileTrue: [aBlock value: cell car value: cell . cell := cell cdr]
! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:08'!
first

	^ car! !

!ConsCell class methodsFor: 'instance creation' stamp: 'spfa 11/9/2012 17:41'!
fromList: anArray

	| cons |

	anArray size = 0 ifTrue: [^ nil].
	anArray size = 1 ifTrue: [^ self car: (anArray at: 1)].
	anArray size = 2 ifTrue: 
		[^ self car: (anArray at: 1) cdr: (self car: (anArray at: 2))].

	anArray size to: 1 by: -1 do: [:index | 
			cons := self car: (anArray at: index) cdr: cons].
		
	^ cons! !

!ConsCell methodsFor: 'printing' stamp: 'spfa 11/18/2009 18:08'!
fullPrintStringForLisp: aLisp

	^ String streamContents: [:s | self printOn: s forLisp: aLisp]
! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:08'!
get: anObject

	"low-level property list support"

	| cell |
	cell := self.
	[cell isConsCell] whileTrue: [
			cell car == anObject ifTrue: [^ cell cadr].
			cell := cell cdr cdr].
	^ nil

	! !

!ConsCell methodsFor: 'testing' stamp: 'spfa 11/18/2009 18:08'!
hash
	"Hash is reimplemented because = is implemented."

	self isCircular ifTrue: [^ self withCut hash].

	^ car hash bitXor: cdr hash.! !

!ConsCell methodsFor: 'list operations' stamp: 'spfa 10/13/2022 11:52'!
hyperTreeDo: aBlock

	| cell |
	cell := self.
	[cell isConsCell] whileTrue: [
		cell car isConsCell 
			ifTrue: [cell car hyperTreeDo: aBlock] 
			ifFalse: [aBlock value: cell car]. 
		aBlock value: (cell := cell cdr)].
	cell isConsCell 
		ifTrue: [cell hyperTreeDo: aBlock] 
		ifFalse: [aBlock value: cell]. 

! !

!ConsCell methodsFor: 'conversion' stamp: 'spfa 11/18/2009 18:08'!
inArray: aStream

	| k |

	k := car isConsCell ifTrue: [car arrayForm] ifFalse: [car].
	k ifNil: [k := #()].

	cdr isNil ifTrue: [^ aStream nextPut: k].
	cdr isConsCell ifTrue: [^ aStream nextPut: k; nextPutAll: cdr arrayForm].
	self error: 'Not a list'
! !

!Object methodsFor: '*ConsCell' stamp: 'spfa 11/18/2009 18:15'!
inCons

	^ ConsCell car: self! !

!Object methodsFor: '*ConsCell' stamp: 'spfa 11/18/2009 18:15'!
inQuotedCons

	^ (ConsCell car: #quote) addLast: self! !

!ConsCell methodsFor: 'testing' stamp: 'spfa 10/21/2022 14:08'!
isCircular

	^ self isCircular: IdentitySet new
! !

!ConsCell methodsFor: 'testing' stamp: 'spfa 11/18/2009 18:08'!
isCircular: anIdentitySet

	cdr isConsCell ifFalse: [^ false].
	(anIdentitySet includes: cdr) ifTrue: [^ true].

	anIdentitySet add: self.
	^ cdr isCircular: anIdentitySet ! !

!ConsCell methodsFor: 'testing' stamp: 'spfa 11/18/2009 18:08'!
isConsCell

	^ true! !

!Object methodsFor: '*ConsCell' stamp: 'spfa 11/18/2009 18:15'!
isConsCell

	^ false! !

!ConsCell methodsFor: 'testing' stamp: 'spfa 11/18/2009 18:08'!
isList

	^ self isList: (IdentitySet with: self)! !

!ConsCell methodsFor: 'testing' stamp: 'spfa 11/18/2009 18:08'!
isList: anIdentitySet

	(anIdentitySet includes: cdr) ifTrue: [^ false].
	anIdentitySet add: self.
	^ cdr isNil or: [cdr isConsCell and: [cdr isList: anIdentitySet]]! !

!ConsCell methodsFor: 'procedure protocol' stamp: 'spfa 11/18/2009 18:08'!
isMacro

	^ car == #macro! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:08'!
last

	^ cdr ifNil: [self] ifNotNil: [cdr last]! !

!ConsCell methodsFor: 'list operations' stamp: 'spfa 11/18/2009 18:08'!
lastCdr: anObject

	self lastCell cdr: anObject
	! !

!ConsCell methodsFor: 'list operations' stamp: 'spfa 11/18/2009 18:08'!
lastCell

	| cell |
	cell := self.
	[cell cdr notNil] whileTrue: [cell := cell cdr].
	^ cell 
	! !

!ConsCell methodsFor: 'testing' stamp: 'spfa 11/3/2011 22:12'!
length

	^ self length: 1 with: IdentitySet new
	! !

!ConsCell methodsFor: 'testing' stamp: 'spfa 11/3/2011 22:10'!
length: aNumber with: anIdentitySet 

	cdr isNil ifTrue: [^ aNumber].
	cdr isConsCell ifFalse: [self error: 'not a list'].
	(anIdentitySet includes: cdr) ifTrue: [^ Float infinity].

	anIdentitySet add: self.
	^ cdr length: aNumber + 1 with: anIdentitySet ! !

!ConsCell methodsFor: 'conversion' stamp: 'spfa 11/18/2009 18:08'!
listCopy

	^ self copy setcdr: (cdr isConsCell ifFalse: [cdr] ifTrue: [cdr listCopy])
! !

!ConsGenerator methodsFor: 'as yet unclassified' stamp: 'spfa 9/13/2018 10:40'!
next

	^ cc car in: [:v | 
		cc := cc cdr.
		^ v]! !

!ConsGenerator methodsFor: 'as yet unclassified' stamp: 'spfa 9/13/2018 10:41'!
next: anInteger 
	"Answer the next anInteger number of objects accessible by the receiver."

	| aCollection |
	aCollection := OrderedCollection new.
	anInteger timesRepeat: [aCollection addLast: self next].
	^aCollection! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:08'!
nth: n

	n isZero ifTrue: [^ car].
	cdr ifNil: [^ nil].
	n = 1 ifTrue: [^ cdr car].
	^ cdr nth: n - 1! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:08'!
nth: n ifAbsent: aBlock

	n isZero ifTrue: [^ car].
	cdr ifNil: [^ aBlock value].
	n = 1 ifTrue: [^ cdr car].
	^ cdr nth: n - 1ifAbsent: aBlock! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:08'!
nthCell: n

	n isZero ifTrue: [^ self].
	n = 1 ifTrue: [^ cdr].
	^ cdr nthCell: n - 1! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:08'!
nthCell: n ifAbsent: aBlock

	n isZero ifTrue: [^ self].
	n = 1 ifTrue: [^ cdr ifNil: [aBlock value]].
	^ cdr nthCell: n - 1 ifAbsent: aBlock! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:08'!
nthcdr: n

	n isZero ifTrue: [^ self].
	n = 1 ifTrue: [^ cdr].
	^ cdr nthcdr: n - 1! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:08'!
nthcdr: n ifAbsent: aBlock

	n isZero ifTrue: [^ self].
	cdr ifNil: [n = 1 ifTrue: [^ nil] ifFalse: [aBlock value]].
	n = 1 ifTrue: [^ cdr].
	^ cdr nthcdr: n - 1ifAbsent: aBlock! !

!ConsGenerator class methodsFor: 'as yet unclassified' stamp: 'spfa 9/13/2018 10:43'!
on: anArray

	^ self new consCell: anArray asCons! !

!ConsGenerator methodsFor: 'as yet unclassified' stamp: 'spfa 9/13/2018 10:44'!
peek

	self atEnd ifTrue: [^ nil].

	^ cc cadr! !

!ConsCell methodsFor: 'printing' stamp: 'spfa 11/18/2009 18:08'!
printOn: aStream

	self printOn: aStream forLisp: nil
! !

!Array methodsFor: '*ConsCell' stamp: 'spfa 11/18/2009 18:07'!
printOn: aStream depth: aNumber forLisp: aLisp level: cpl maxLevel: mpl length: len maxLength: mlen done: anIdentitySet cycles: anIdentityDictionary

	(anIdentityDictionary keys includes: self)
	ifTrue: 
	[
		aStream nextPut: $#; 
				nextPutAll: (anIdentityDictionary at: self) asString; 
				nextPut: $=.
		anIdentitySet add: self.
	].

	aStream nextPutAll: (aLisp ifNil: ['#(']
		ifNotNil: [aLisp class vectorOpeningString]).
	self do: [:element | 
		(anIdentitySet includes: element)
		ifTrue:
		[
			aStream nextPut: $#; 
				nextPutAll: (anIdentityDictionary at: element) asString; 
				nextPut: $#
		]
		ifFalse:
		[
			element printOn: aStream depth: aNumber forLisp: aLisp 
				level: cpl maxLevel: mpl length: len maxLength: mlen 
				done: anIdentitySet cycles: anIdentityDictionary
		].
		aStream space
	].
	self ifNotEmpty: [aStream skip: -1].
	aStream nextPut: (aLisp ifNil: [$)]
		ifNotNil: [aLisp class vectorClosingChar])! !

!ConsCell methodsFor: 'printing' stamp: 'spfa 3/9/2018 11:14'!
printOn: aStream depth: aNumber forLisp: aLisp level: cpl maxLevel: mpl length: len maxLength: mlen done: anIdentitySet cycles: anIdentityDictionary

	"the so-called 'level' controls the depth of nesting cons cells
	the 'length' controls the numbers of elements in a list to be printed
both refers to standard Common Lisp variables: respectively *print-level* and *print-length*

	see Common Lisp the Language,  2nd edition, chapter 22.1.6"

	| depth |

	depth := aNumber.

	(anIdentityDictionary identityIncludesKey: self)
	ifTrue: 
	[
		aStream nextPut: $#; 
				nextPutAll: (anIdentityDictionary at: self) asString; 
				nextPut: $=.
		anIdentitySet add: self.
	].

	depth isZero ifTrue: [aStream nextPut: $(].

	(car isConsCell | car isArray) ifTrue: 
	[
		(anIdentitySet includes: car) 
		ifTrue: 
		[
			aStream nextPut: $#; 
					nextPutAll: (anIdentityDictionary at: car) asString; 
					nextPut: $#
		]
		ifFalse:
		[
			(mpl notNil and: [cpl >= mpl]) 
				ifTrue: [aStream nextPut: $#]
				ifFalse: 
				[
					car printOn: aStream depth: 0 forLisp: aLisp 
						level: cpl + 1 maxLevel: mpl length: mlen maxLength: mlen
						done: anIdentitySet cycles: anIdentityDictionary
				]
		]
	]
	ifFalse: [car printOn: aStream depth: depth + 1 forLisp: aLisp 
						level: cpl + 1 maxLevel: mpl length: mlen maxLength: mlen
						done: anIdentitySet cycles: anIdentityDictionary].

	cdr ifNil: [^ aStream nextPut: $)].

	aStream space.

	(len notNil and: [len = 1]) ifTrue: [^ aStream nextPutAll: '...)'].

	(cdr isConsCell
		and: [(anIdentitySet includes: cdr) not]
		and: [(anIdentityDictionary identityIncludesKey: cdr) not]) ifTrue: 
	[
		^ cdr printOn: aStream depth: depth + 1 forLisp: aLisp 
			level: cpl maxLevel: mpl 
			length: (len ifNotNil: [len - 1]) maxLength: mlen
			done: anIdentitySet cycles: anIdentityDictionary
	].

	aStream nextPut: $.; space. 
	(anIdentitySet includes: cdr) 		
	ifTrue: 
	[
		aStream nextPut: $#; 
			nextPutAll: (anIdentityDictionary at: cdr) asString; 
			nextPut: $#
	]
	ifFalse: 
	[
		cdr printOn: aStream depth: 0 forLisp: aLisp 
			level: cpl maxLevel: mpl
			length: (len ifNotNil: [len - 1]) maxLength: mlen
		 	done: anIdentitySet cycles: anIdentityDictionary
	].
	aStream nextPut: $)
! !

!Object methodsFor: '*ConsCell' stamp: 'spfa 11/18/2009 18:15'!
printOn: aStream depth: aNumber forLisp: aLisp level: cpl maxLevel: mpl length: len maxLength: mlen done: anIdentitySet cycles: anIdentityDictionary

	^ self printOn: aStream forLisp: aLisp

! !

!Array methodsFor: '*ConsCell' stamp: 'spfa 11/18/2009 18:07'!
printOn: aStream forLisp: aLisp

	| mlen mlev |

	mlen := aLisp ifNil: [nil] ifNotNil: [aLisp printLength].
	mlev := aLisp ifNil: [nil] ifNotNil: [aLisp printLevel].

	(aLisp isNil or: [aLisp printCircle == aLisp trueValue])
	ifTrue:
	[
		^ self printOn: aStream depth: 0 forLisp: aLisp 
			level: 1 maxLevel: mlev length: mlen maxLength: mlen 
			done: IdentitySet new cycles: self cycles
	].

	self printOn: aStream depth: 0 forLisp: aLisp 
		level: 1 maxLevel: mlev length: mlen maxLength: mlen 
		done: IdentitySet new cycles: IdentityDictionary new
! !

!Character methodsFor: '*ConsCell' stamp: 'spfa 7/29/2015 16:41'!
printOn: aStream forLisp: aLisp

	aLisp ifNotNil: 
		[^ aStream nextPutAll: (aLisp class characterPrintString: self)].

	aStream nextPutAll: (self codePoint caseOf:
	{
		[10] -> ['#\newline'] .
		[9] -> ['#\tab'] .
		[32] -> ['#\space'] .			
		[8] -> ['#\backspace'] .			
		[27] -> ['#\escape'] .			
		[13] -> ['#\return'] .			
		[127] -> ['#\rubout'] .	
	} 
	otherwise: ['#\', self asString])! !

!ConsCell methodsFor: 'printing' stamp: 'spfa 11/18/2009 18:08'!
printOn: aStream forLisp: aLisp

	| mlen mlev |

	mlen := aLisp ifNil: [nil] ifNotNil: [aLisp printLength].
	mlev := aLisp ifNil: [nil] ifNotNil: [aLisp printLevel].

	(aLisp isNil or: [aLisp printCircle == aLisp trueValue])
	ifTrue:
	[
		^ self printOn: aStream depth: 0 forLisp: aLisp 
			level: 1 maxLevel: mlev length: mlen maxLength: mlen 
			done: IdentitySet new cycles: self cycles
	].

	self printOn: aStream depth: 0 forLisp: aLisp 
		level: 1 maxLevel: mlev length: mlen maxLength: mlen 
		done: IdentitySet new cycles: IdentityDictionary new
! !

!False methodsFor: '*ConsCell' stamp: 'spfa 11/18/2009 18:09'!
printOn: aStream forLisp: aLisp

	aLisp ifNil: [^ self printOn: aStream].
	aStream nextPutAll: (aLisp class falseValuePrintString)! !

!Number methodsFor: '*ConsCell' stamp: 'spfa 11/18/2009 18:15'!
printOn: aStream forLisp: aLisp

	self printOn: aStream.
! !

!Object methodsFor: '*ConsCell' stamp: 'spfa 11/18/2009 18:15'!
printOn: aStream forLisp: aLisp

	aStream nextPutAll: '#<'.
	self printOn: aStream.
	aStream nextPut: $>! !

!String methodsFor: '*ConsCell' stamp: 'spfa 11/18/2009 18:16'!
printOn: aStream forLisp: aLisp

	aStream nextPut: $".
	aStream nextPutAll: 
		(aLisp ifNil: [self] ifNotNil: [aLisp class representString: self]).
	aStream nextPut: $"! !

!Symbol methodsFor: '*ConsCell' stamp: 'spfa 11/18/2009 18:17'!
printOn: aStream forLisp: aLisp

	aLisp ifNotNil: [^ aLisp printSymbol: self on: aStream].
	aStream nextPutAll: self



! !

!True methodsFor: '*ConsCell' stamp: 'spfa 11/18/2009 18:17'!
printOn: aStream forLisp: aLisp

	aLisp ifNil: [^ self printOn: aStream].
	aStream nextPutAll: (aLisp class trueValuePrintString)! !

!UndefinedObject methodsFor: '*ConsCell' stamp: 'spfa 11/18/2009 18:17'!
printOn: aStream forLisp: aLisp

	aLisp ifNil: [^ self printOn: aStream].
	aStream nextPutAll: aLisp class nullPrintString
! !

!ConsCell methodsFor: 'list operations' stamp: 'spfa 11/18/2009 18:08'!
safeDo: aBlock

	^ self safeDo: aBlock done: IdentitySet new! !

!ConsCell methodsFor: 'list operations' stamp: 'spfa 11/18/2009 18:08'!
safeDo: aBlock done: anIdentitySet

	(anIdentitySet includes: car)
		ifFalse: [aBlock value: self car. anIdentitySet add: car].

	((anIdentitySet includes: cdr) 
		or: [cdr isConsCell not]) ifTrue: [^ self].

	cdr safeDo: aBlock done: anIdentitySet

! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:08'!
safeLength

	cdr isNil ifTrue: [^ 1].
	cdr isConsCell ifFalse: [^ 2].
	^ cdr safeLength + 1
! !

!ConsCell methodsFor: 'conversion' stamp: 'spfa 11/18/2009 18:08'!
safeStoreTopFormsIn: aStream

	aStream nextPut: car.
	cdr isConsCell ifTrue: [cdr safeStoreTopFormsIn: aStream] 

! !

!ConsCell methodsFor: 'conversion' stamp: 'spfa 11/18/2009 18:08'!
safeTopForms

	cdr ifNil: [^ {car}].
	cdr isConsCell ifTrue:
	[
		cdr cdr ifNil: [^ {car . cdr car}].
		cdr cdr isConsCell ifTrue:
			[cdr cdr cdr ifNil: [^ {car . cdr car . cdr cdr car}]]
	].

	^ Array streamContents: [:stream | self safeStoreTopFormsIn: stream]

! !

!UndefinedObject methodsFor: '*ConsCell' stamp: 'spfa 11/18/2009 18:17'!
safeTopForms

	^ #()! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:08'!
second

	^ cdr car! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:08'!
setcar: anObject

	self car: anObject! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:08'!
setcdr: anObject

	self cdr: anObject! !

!Array methodsFor: '*ConsCell' stamp: 'spfa 11/18/2009 18:07'!
storeCycles: anIdentityDictionary with: anIdentitySet

	(anIdentitySet includes: self)
	ifTrue: 
	[
		(anIdentityDictionary keys includes: self)
			ifFalse: [anIdentityDictionary add: self -> (anIdentityDictionary size + 1)].
		^ anIdentityDictionary
	]. 
	anIdentitySet add: self.

	self do: [:ea |
		(ea isConsCell | ea isArray) ifTrue:
			[ea storeCycles: anIdentityDictionary with: anIdentitySet]].

	^ anIdentityDictionary! !

!ConsCell methodsFor: 'testing' stamp: 'spfa 3/9/2018 11:14'!
storeCycles: anIdentityDictionary with: anIdentitySet

	(anIdentitySet includes: self)
	ifTrue: 
	[
		(anIdentityDictionary identityIncludesKey: self)
			ifFalse: [anIdentityDictionary add: self -> (anIdentityDictionary size + 1)].
		^ anIdentityDictionary
	]. 
	anIdentitySet add: self.

	(car isConsCell | car isArray) ifTrue: 
		[car storeCycles: anIdentityDictionary with: anIdentitySet].
	(cdr isConsCell | cdr isArray) ifTrue: 
		[cdr storeCycles: anIdentityDictionary with: anIdentitySet].

	^ anIdentityDictionary! !

!ConsCell methodsFor: 'printing' stamp: 'spfa 11/18/2009 18:08'!
storeOn: aStream

	aStream nextPutAll: '(ConsCell car: '.
	car storeOn: aStream.
	aStream nextPutAll: ' cdr: '.
	cdr storeOn: aStream.
	aStream nextPut: $)! !

!ConsCell methodsFor: 'conversion' stamp: 'spfa 11/18/2009 18:08'!
storeTopFormsIn: aStream

	aStream nextPut: car.
	cdr ifNil: [^ self].
	cdr storeTopFormsIn: aStream 

! !

!ConsCell methodsFor: 'conversion' stamp: 'spfa 11/18/2009 18:08'!
tailClass

	^ self class! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:08'!
third

	^ cdr cdr car! !

!ConsCell methodsFor: 'conversion' stamp: 'spfa 11/18/2009 18:08'!
topForms

	cdr ifNil: [^ {car}].
	cdr cdr ifNil: [^ {car . cdr car}].
	cdr cdr cdr ifNil: [^ {car . cdr car . cdr cdr car}].

	^ Array streamContents: [:stream | self storeTopFormsIn: stream]

! !

!UndefinedObject methodsFor: '*ConsCell' stamp: 'spfa 11/18/2009 18:17'!
topForms

	^ #()! !

!ConsCell methodsFor: 'list operations' stamp: 'spfa 10/13/2022 10:35'!
treeDo: aBlock

	| cell |
	cell := self.
	[cell isConsCell] whileTrue: [
		cell car isConsCell 
			ifTrue: [cell car treeDo: aBlock] 
			ifFalse: [aBlock value: cell car]. 
		cell := cell cdr]

! !

!ConsCell methodsFor: 'list operations' stamp: 'spfa 11/18/2009 18:08'!
with: aConsCell collect: aBlock

	^ self class car: (aBlock value: car value: aConsCell car)
		cdr: ((cdr isConsCell and: [aConsCell cdr isConsCell])
					ifTrue: [cdr with: aConsCell cdr collect: aBlock] ifFalse: [cdr])! !

!ConsCell methodsFor: 'testing' stamp: 'spfa 11/18/2009 18:08'!
withCut

	| cons c2 |
	cons := self veryDeepCopy.
	c2 := cons cdr.
	cons cdr: nil.		
	^ c2! !
