'From Squeak4.1 of 17 April 2010 [latest update: #9957] on 10 May 2011 at 2:22:05 pm'!

!Collection methodsFor: '*DHB Numerical' stamp: 'spfa 5/10/2011 14:16'!
asDhbVector
	"Convert the receiver to a vector. 
	(c) Copyrights Didier BESSET, 1999, all rights reserved. 
	Initial code: 11/2/99"

	| aVector index |
	aVector := DhbVector new: self size.
	index := 0.
	self do: [:each | aVector at: (index := index + 1) put: each].
	^aVector! !


!Number methodsFor: '*DHB Numerical' stamp: 'spfa 5/10/2011 14:16'!
addPolynomial: aPolynomial
		"(c) Copyrights Didier BESSET, 1999, all rights reserved.
		 Initial code: 19/4/99 "
	^aPolynomial addNumber: self! !

!Number methodsFor: '*DHB Numerical' stamp: 'spfa 5/10/2011 14:16'!
beta: aNumber
		"Computes the beta function of the receiver and aNumber
		 (c) Copyrights Didier BESSET, 1999, all rights reserved.
		 Initial code: 1/3/99 "
	^( self logBeta: aNumber) exp! !

!Number methodsFor: '*DHB Numerical' stamp: 'spfa 5/10/2011 14:16'!
dividingPolynomial: aPolynomial
		"(c) Copyrights Didier BESSET, 1999, all rights reserved.
		 Initial code: 17/4/99 "
	^aPolynomial timesNumber: (1 / self)! !

!Number methodsFor: '*DHB Numerical' stamp: 'spfa 5/10/2011 14:17'!
equalsTo: aNumber
		"(c) Copyrights Didier BESSET, 1999, all rights reserved.
		 Initial code: 21/4/99 "
	^self relativelyEqualsTo: aNumber upTo: DhbFloatingPointMachine new defaultNumericalPrecision! !

!Number methodsFor: '*DHB Numerical' stamp: 'spfa 5/10/2011 14:17'!
errorFunction
		"Answer the error function for the receiver.
		 (c) Copyrights Didier BESSET, 1999, all rights reserved.
		 Initial code: 11/2/99 "
	^DhbErfApproximation new value: self! !

!Number methodsFor: '*DHB Numerical' stamp: 'spfa 5/10/2011 14:17'!
gamma
	"Compute the Gamma function for the receiver. 
	(c) Copyrights Didier BESSET, 1999, all rights reserved. 
	Initial code: 11/2/99"

	^self > 1
		ifTrue: [^DhbLanczosFormula new gamma: self]
		ifFalse: [self < 0
				ifTrue: [Float pi / ((Float pi * self) sin * (1 - self) gamma)]
				ifFalse: [(DhbLanczosFormula new gamma: self + 1)
						/ self]]! !

!Number methodsFor: '*DHB Numerical' stamp: 'spfa 5/10/2011 14:17'!
logBeta: aNumber
		"Computes the logarithm of the beta function of the receiver and aNumber
		 (c) Copyrights Didier BESSET, 1999, all rights reserved.
		 Initial code: 1/3/99 "
	^self logGamma + aNumber logGamma - ( self + aNumber) logGamma! !

!Number methodsFor: '*DHB Numerical' stamp: 'spfa 5/10/2011 14:17'!
logGamma
		"Computes the log of the Gamma function (for positive numbers only)
		 (c) Copyrights Didier BESSET, 1999, all rights reserved.
		 Initial code: 1/3/99 "
	^self > 1
		ifTrue: [ DhbLanczosFormula new logGamma: self]
		ifFalse:[ self > 0
						ifTrue: [ ( DhbLanczosFormula new logGamma: ( self + 1) ) - self ln ]
						ifFalse: [ ^self error: 'Argument for the log gamma function must be positive']
					]! !

!Number methodsFor: '*DHB Numerical' stamp: 'spfa 5/10/2011 14:17'!
productWithMatrix: aMatrix
		"Answer a new matrix, product of aMatrix with the receiver.
		 (c) Copyrights Didier BESSET, 1999, all rights reserved.
		 Initial code: 11/2/99 "
	^aMatrix class rows: ( aMatrix rowsCollect: [ :each | each * self])! !

!Number methodsFor: '*DHB Numerical' stamp: 'spfa 5/10/2011 14:17'!
productWithVector: aVector
		"Answers a new vector product of the receiver with aVector.
		 (c) Copyrights Didier BESSET, 1999, all rights reserved.
		 Initial code: 11/2/99 "
	^aVector collect: [ :each | each * self]! !

!Number methodsFor: '*DHB Numerical' stamp: 'spfa 5/10/2011 14:17'!
random
		"Answers a random number distributed between 0 and the receiver.
		 (c) Copyrights Didier BESSET, 1999, all rights reserved.
		 Initial code: 17/2/99 "
	^self class random * self! !

!Number methodsFor: '*DHB Numerical' stamp: 'spfa 5/10/2011 14:17'!
relativelyEqualsTo: aNumber upTo: aSmallNumber
		"
		 (c) Copyrights Didier BESSET, 1999, all rights reserved.
		 Initial code: 21/4/99 "
	| norm |
	norm := self abs max: aNumber abs.
	^norm <= DhbFloatingPointMachine new defaultNumericalPrecision
		or: [ (self - aNumber) abs < ( aSmallNumber * norm)]! !

!Number methodsFor: '*DHB Numerical' stamp: 'spfa 5/10/2011 14:17'!
subtractToPolynomial: aPolynomial
		"(c) Copyrights Didier BESSET, 1999, all rights reserved.
		 Initial code: 19/4/99 "
	^aPolynomial addNumber: self negated! !

!Number methodsFor: '*DHB Numerical' stamp: 'spfa 5/10/2011 14:17'!
timesPolynomial: aPolynomial
		"(c) Copyrights Didier BESSET, 1999, all rights reserved.
		 Initial code: 17/4/99 "
	^aPolynomial timesNumber: self! !


!Integer methodsFor: '*DHB Numerical' stamp: 'spfa 5/10/2011 14:16'!
gamma
		"Compute the Gamma function for the receiver.
		 (c) Copyrights Didier BESSET, 1999, all rights reserved.
		 Initial code: 11/2/99 "
	self > 0
		ifFalse:[ ^self error: 'Attempt to compute the Gamma function of a non-positive integer'].
	^( self - 1) factorial! !

!Integer methodsFor: '*DHB Numerical' stamp: 'spfa 5/10/2011 14:16'!
random
		"Answer a random integer between 0 and the receiver.
		 (c) Copyrights Didier BESSET, 1999, all rights reserved.
		 Initial code: 15/2/99 "
	^DhbMitchellMooreGenerator new integerValue: self! !


!Number class methodsFor: '*DHB Numerical' stamp: 'spfa 5/10/2011 14:21'!
random
		"Answers a random number between 0 and the receiver
		 (c) Copyrights Didier BESSET, 1999, all rights reserved.
		 Initial code: 17/2/99 "
	^DhbMitchellMooreGenerator new floatValue! !


!UndefinedObject methodsFor: '*DHB Numerical' stamp: 'spfa 5/10/2011 14:17'!
size
	^0! !

