SystemOrganization addCategory: #MStream!
SystemOrganization addCategory: #'MStream-Tests'!


Object subclass: #MacroExpander
	instanceVariableNames: 'dictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MStream'!

MacroExpander class
	instanceVariableNames: ''!

PositionableStream subclass: #MReadStream
	instanceVariableNames: 'macroStream expander'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MStream'!

MReadStream class
	instanceVariableNames: ''!

TestCase subclass: #MReadStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MStream-Tests'!

MReadStreamTest class
	instanceVariableNames: ''!


!MReadStream methodsFor: 'as yet unclassified' stamp: 'spfa 1/22/2012 22:02'!
atEnd

	self inMacro ifFalse: [^ super atEnd].
	^ false! !

!MReadStream methodsFor: 'as yet unclassified' stamp: 'spfa 1/22/2012 23:46'!
back

	self skipBack.
	^ self peek
	
	! !

!MReadStream methodsFor: 'as yet unclassified' stamp: 'spfa 1/22/2012 23:20'!
contents

	self reset.
	
	^ [
		String streamContents: [:str |
			[self atEnd] whileFalse: [str nextPut: self next]]
	] 
	ensure: [self reset]! !

!MacroExpander methodsFor: 'as yet unclassified' stamp: 'spfa 1/23/2012 13:39'!
dictionary

	^ dictionary! !

!MacroExpander methodsFor: 'as yet unclassified' stamp: 'spfa 1/23/2012 14:08'!
dictionary: aDictionary

	dictionary := aDictionary! !

!MacroExpander class methodsFor: 'as yet unclassified' stamp: 'spfa 1/23/2012 14:17'!
expand: aString

	^ self new expand: aString! !

!MacroExpander methodsFor: 'as yet unclassified' stamp: 'spfa 1/23/2012 14:25'!
expand: aString

	^ (self readStream on: aString) contents! !

!MReadStream methodsFor: 'as yet unclassified' stamp: 'spfa 1/23/2012 14:00'!
expand: aString withArguments: anArray

	anArray isEmpty ifTrue: [
		^ expander dictionary at: aString ifAbsent: [aString]].
	
	^ expander perform: ('macro', aString, ':') asSymbol
		with: anArray

! !

!MReadStream methodsFor: 'as yet unclassified' stamp: 'spfa 1/23/2012 15:02'!
expander

	^ expander ! !

!MReadStream methodsFor: 'as yet unclassified' stamp: 'spfa 1/23/2012 14:15'!
expander: aMacroExpander

	expander := aMacroExpander! !

!MReadStream methodsFor: 'as yet unclassified' stamp: 'spfa 1/22/2012 21:02'!
inMacro

	^ macroStream notNil and: [macroStream atEnd not]! !

!MReadStream methodsFor: 'as yet unclassified' stamp: 'spfa 1/23/2012 15:00'!
initialize

	super initialize.
	expander := MacroExpander new! !

!MacroExpander methodsFor: 'as yet unclassified' stamp: 'spfa 1/23/2012 15:02'!
initialize

	self dictionary: Dictionary new! !

!MReadStream methodsFor: 'as yet unclassified' stamp: 'spfa 1/22/2012 21:01'!
localName
	^'MReadStream'! !

!MacroExpander methodsFor: 'as yet unclassified' stamp: 'spfa 1/23/2012 14:11'!
macroREP: args

	| str |

	str := ''.
	args first asInteger timesRepeat: [str := str, args second].
	
	args size = 3 ifTrue: [^ str allButLast: args third asInteger].
	
	^ str! !

!MacroExpander methodsFor: 'as yet unclassified' stamp: 'spfa 1/23/2012 15:01'!
macroREV: args

	^ args first reversed! !

!MReadStream methodsFor: 'as yet unclassified' stamp: 'spfa 1/23/2012 14:07'!
next

	| nc macro args |

	self inMacro ifTrue: [^ macroStream next].
	
	macroStream := nil.
	
	(nc := self primNext) isUppercase ifFalse: [^ nc].
	self skipBack.

	macro := String streamContents: [:str |
		[self atEnd not and: [(nc := self primNext) isUppercase]] 
			whileTrue: [str nextPut: nc]].

	(nc notNil and: [nc isUppercase not]) ifTrue: [self skipBack].
	
	args := Array streamContents: [:astr |	
		[self atEnd not and: [(nc := self primNext) == $`]] whileTrue: [
			astr nextPut: (String streamContents: [:str |
							[self atEnd not and: [(nc := self primNext) ~~ $`]] 
							whileTrue: [str nextPut: nc]])]].
		
	(nc notNil and: [nc isUppercase not]) ifTrue: [self skipBack].
	macroStream := (self expand: macro withArguments: args) readStream.

	
	^ self next! !

!MReadStream class methodsFor: 'as yet unclassified' stamp: 'spfa 1/22/2012 21:29'!
on: aCollection 
	"Answer an instance of me, streaming over the elements of aCollection."

	^self basicNew initialize on: aCollection! !

!MReadStream methodsFor: 'as yet unclassified' stamp: 'spfa 1/22/2012 23:44'!
peek
	"Answer what would be returned if the message next were sent to the 
	receiver. If the receiver is at the end, answer nil."

	| nextObject |
	self atEnd ifTrue: [^nil].
	nextObject := self next.
	self skipBack.
	^nextObject! !

!MReadStream methodsFor: 'as yet unclassified' stamp: 'spfa 1/22/2012 23:45'!
peekFor: anObject 
	"Answer false and do not move over the next element if it is not equal to 
	the argument, anObject, or if the receiver is at the end. Answer true 
	and increment the position for accessing elements, if the next element is 
	equal to anObject."

	| nextObject |
	self atEnd ifTrue: [^false].
	nextObject := self next.
	"peek for matching element"
	anObject = nextObject ifTrue: [^true].
	"gobble it if found"
	self skipBack.
	^false! !

!MReadStream methodsFor: 'as yet unclassified' stamp: 'spfa 1/22/2012 21:17'!
primNext
	"Primitive. Answer the next object in the Stream represented by the
	receiver. Fail if the collection of this stream is not an Array or a String.
	Fail if the stream is positioned at its end, or if the position is out of
	bounds in the collection. Optional. See Object documentation
	whatIsAPrimitive."

	<primitive: 65>
	position >= readLimit
		ifTrue: [^nil]
		ifFalse: [^collection at: (position := position + 1)]! !

!MacroExpander methodsFor: 'as yet unclassified' stamp: 'spfa 1/23/2012 14:24'!
readStream

	^ MReadStream basicNew expander: self! !

!MReadStream methodsFor: 'as yet unclassified' stamp: 'spfa 1/22/2012 23:19'!
reset

	position := 0.
	macroStream := nil.
	! !

!MReadStream methodsFor: 'as yet unclassified' stamp: 'spfa 1/22/2012 22:19'!
resetContents

	macroStream := nil.
	super resetContents! !

!MReadStream methodsFor: 'as yet unclassified' stamp: 'spfa 1/22/2012 21:19'!
size

	self error: 'size is unknown'! !

!MReadStream methodsFor: 'as yet unclassified' stamp: 'spfa 1/22/2012 23:43'!
skip: anInteger

	anInteger >= 0 ifTrue: [^ anInteger timesRepeat: [self next]].

	anInteger timesRepeat: [self skipBack].
! !

!MReadStream methodsFor: 'as yet unclassified' stamp: 'spfa 1/22/2012 23:44'!
skipBack

	(macroStream notNil and: [macroStream position > 0]) 
		ifTrue: [^ macroStream skip: -1].
		
	macroStream := nil.
	super skip: -1.

	
	! !

!MReadStreamTest methodsFor: 'as yet unclassified' stamp: 'spfa 1/23/2012 15:01'!
testBasic

	| stream |

	stream := MReadStream on: 'teREV`gloup`st'. 

	self assert: stream contents = 'tepuolgst'.
	self deny: stream atEnd.
	self assert: stream upToEnd = 'tepuolgst'.
	
	stream reset.

	self assert: (stream peekFor: $t).
	self assert: (stream back == $t).
	self assert: (stream peekFor: $t).
	self assert: (stream peekFor: $e).
	self assert: (stream back == $e).
	self assert: (stream peekFor: $e).
	
	self deny: (stream peekFor: $h).
		
	self assert: (stream peekFor: $p).
	self assert: (stream back == $p).
	self assert: (stream peekFor: $p).
	self assert: (stream peekFor: $u). 
		
	self assert: (stream peek == $o).
	self assert: (stream peek == $o).
	self assert: (stream peekFor: $o).
	self assert: (stream back == $o).! !

!MReadStreamTest methodsFor: 'as yet unclassified' stamp: 'spfa 1/23/2012 15:03'!
testBasic2

	| stream |

	stream := MReadStream on: 'teYOst'. 
	
	self assert: stream contents = 'teYOst'.
	
	stream expander dictionary at: 'YO' put: 'yoyo'.

	self assert: stream contents = 'teyoyost'.
! !

!MReadStreamTest methodsFor: 'as yet unclassified' stamp: 'spfa 1/23/2012 14:11'!
testBasic3

	| stream |

	stream := MReadStream on: 'a, b, {REP`12``e,f,`} {/r12/ c, d}'.

	self assert: stream contents = 'a, b, {e,f,e,f,e,f,e,f,e,f,e,f,e,f,e,f,e,f,e,f,e,f,e,f,} {/r12/ c, d}'.
	
	stream := MReadStream on: 'a, b, {REP`12``e,f,``1`} {/r12/ c, d}'.

	self assert: stream contents = 'a, b, {e,f,e,f,e,f,e,f,e,f,e,f,e,f,e,f,e,f,e,f,e,f,e,f} {/r12/ c, d}'

! !

!MReadStreamTest methodsFor: 'as yet unclassified' stamp: 'spfa 1/23/2012 14:14'!
testBasic4

	| stream |

	stream := MReadStream on: 'a, b, {BEUH`12``e,f,`} {/r12/ c, d}'.

	self should: [stream contents] raise: Error.
	
	stream := MReadStream on: 'a, b, {BEUH} {/r12/ c, d}'.

	self assert: stream contents = 'a, b, {BEUH} {/r12/ c, d}'.

! !

!MReadStreamTest methodsFor: 'as yet unclassified' stamp: 'spfa 1/23/2012 15:00'!
testBasic5

	self assert: (MusicalPhraseMacroExpander expand:  'a, b, {REP`4``e, f, ``2`} {/r12/ c, d}')
		= 'a, b, {e, f, e, f, e, f, e, f} {/r12/ c, d}'

! !
