SystemOrganization addCategory: #MuODeployement!


Object subclass: #MuODeployer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MuODeployement'!

MuODeployer class
	instanceVariableNames: ''!

Object subclass: #SurmulotWidgetWindowEventHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MuODeployement'!

TextEditor subclass: #TextMorphEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MuODeployement'!

SurmulotWidgetWindowEventHandler class
	instanceVariableNames: ''!

TextMorphEditor class
	instanceVariableNames: ''!

Morph subclass: #MenuLineMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MuODeployement'!

MenuLineMorph class
	instanceVariableNames: ''!


!MuODeployer commentStamp: 'spfa 5/11/2017 13:45' prior: 0!
Responsible for the deployement of muO

- generation of a *.sar archive from a development image
- installation from *.sar into a fresh image
- saving of a public image from a development image
- transformation of a public image into a TCP/IP-driven widget
!
]style[(257)!

!TextMorphEditor commentStamp: 'dtl 1/21/2012 18:02' prior: 0!
This is a stub class to replace the original implementation of a ParagraphEditor for TextMorphs, which has since been replaced by TextEditor. This implementation is retained for the benefit of external packages such as Connectors and FreeType that may have dependencies on TextMorphEditor.

The comment below is from the class comment of the original TextMorphEditor.
-----
In the past, BookMorphs had the ability to have each page be on the server as a .sp SqueakPage file.  The index of the book was a .bo file.  In text, Cmd-6 had a LinkTo option that linked to a page by its name, or created a new page of that name.  It assumed the book was on a server with a file per page.  Ted removed that code, and kept a copy on his disk in 'TME-ChngEmphasis.st for .bo .sp'!
]style[(768)!

!MuODeployer class methodsFor: 'welcoming' stamp: 'spfa 11/18/2009 18:14'!
aboutToEnterMuOWorld

	(World hasProperty: #wasEntered)
		ifTrue: [^ self].

	self firstTimeActions ifTrue: [World getProperty: #wasEntered]! !

!MuODeployer class methodsFor: 'muO SAR release' stamp: 'spfa 1/18/2022 17:49'!
additionalFiles

	"MuODeployer additionalFiles"

	| flist |

	flist := Set new.

	Preferences includeBooksInMuORelease 
		ifTrue: [flist addAll: (MuO booksForRelease 
									select: [:d | d fileExists]
									thenCollect: [:d | d file])].

	flist addAll: self tablaFiles.
"	flist addAll: self guitarFiles." "a bit heavy"

	^ flist! !

!TwoWayScrollPane methodsFor: '*MuODeployement-fixes' stamp: 'spfa 5/11/2015 11:57'!
colorForInsets
	"My submorphs use the surrounding color"

	(owner notNil and: [owner color isColor]) ifTrue:[^ owner color].
	^ Color white! !

!MuODeployer class methodsFor: 'ancilliary packages' stamp: 'spfa 11/18/2009 18:14'!
fileOutFunctionalTalk

	ChangeSetPackageExporter fileOutPackageNamed: 'FunctionalTalk'.! !

!MuODeployer class methodsFor: 'ancilliary packages' stamp: 'spfa 11/18/2009 18:14'!
fileOutMuOMaths

	SARPackageDumper fileOutPackage: MuOMathsInfo new 
		as: ('muOmaths.%s.sar' sformat: MuOMathsInfo version) ! !

!MuODeployer class methodsFor: 'welcoming' stamp: 'spfa 12/28/2019 17:56'!
firstTimeActions

	| menu book |

	"clean up"
	(FileDirectory default fileExists: 'muO welcome.pr')
		ifTrue: ['muO welcome.pr' asFileReference kill].

	menu _ MuO mainMenu stayUp: true. 
	menu openInWorld; bottomRight: World center.

	book _  (FileDirectory default 
				fullNameFor: 'muo books\DocBook entry points.morph').
	(FileDirectory default fileExists: book)
		ifTrue: [Morph fromLocalFileName: book].

	self inform: 'Welcome to muO !!
-
This is the first time you enter this project.
For a start please read the ''Entry points to muO'' book, then play with 
the ''muO'' menu (see notably the ''live documentation'' submenu).
-'.

	^ true! !

!MuODeployer class methodsFor: 'fresh image installation' stamp: 'spfa 7/21/2022 22:56'!
fixRequiredPackages

	FixUnderscores fixPackagesSilently: #(
		'Connectors'
		'ConnectorsBasicDistro-Info'
		'ConnectorsDemo'
		'ConnectorsGraphLayout'
		'ConnectorsShapes'
		'ConnectorsText'
		'ConnectorsTools'
		'BroomMorphs'
		'FSM'
		'OSC'
		'HTML'
"		'Scamper'"
		'PackageInfo'
		'SARBuilder'
	)! !

!MuODeployer class methodsFor: 'muO SAR release' stamp: 'spfa 1/17/2022 23:53'!
guitarFiles

	| dir |

	dir := 'wav' , FileDirectory slash, 'guitar'.

	^ (FileDirectory default directoryNamed: dir) fileNames 
		collect: [:ea | dir, FileDirectory slash,ea]! !

!MuODeployer class methodsFor: 'muO SAR release' stamp: 'spfa 2/7/2014 16:32'!
handleInstallationFiles

	MuOInfo new installationFiles do: [:ea |
		ea asFileReference exists ifFalse: [self error: 'Missing file: ', ea].
		ea asFileReference copyAs: 
			('ifiles', FileDirectory pathNameDelimiter, ea) asFileReference]! !

!MuODeployer class methodsFor: 'fresh image installation' stamp: 'spfa 5/8/2018 23:46'!
imagePreparationChangeSets

	^ #(
		'BorderedMorph-borderInitialize.st'
		'Morph-color.st'
	)! !

!MuODeployer class methodsFor: 'fresh image installation' stamp: 'spfa 5/9/2018 14:42'!
imageRestorationChangeSets

	^ #(
		'NCLineMorph-borderInitialize.st'
		'NCAAConnectorMorph-borderStyle.st'
		'Context-stackUpToDoIt.st'
	)! !

!MuODeployer class methodsFor: 'snippets' stamp: 'spfa 12/28/2019 17:50'!
incrementMuOVersion

	"MuODeployer incrementMuOVersion"

	(self confirm: ('muO version jump to %s ?' sformat: MuOInfo version + 1))
		ifFalse: [^ self].

	MuOInfo class compile: ((
'
version

	^ %s
'
					) sformat: (MuOInfo version + 1))! !

!MenuLineMorph methodsFor: 'initialization' stamp: 'ar 11/8/2000 23:09'!
initialize
	super initialize.
	self hResizing: #spaceFill; vResizing: #spaceFill.! !

!MuODeployer class methodsFor: 'fresh image installation' stamp: 'spfa 5/8/2018 23:28'!
installAll: anArray

	| wmorphs |

	wmorphs _ World submorphs.

	anArray do: [:packageName |
			| dir fname |
			dir _ self packagesCacheDirectory.
			dir assureExistence.
			(dir fileExists: packageName)
				ifFalse:[self error: 'missing package ', packageName].
			fname _ dir fullNameFor: packageName.
			[
				(fname findTokens: '.') last asUppercase caseOf:
				{	
					['MCZ'] -> [MczInstaller installFileNamed: fname].
					['SAR'] -> [SARInstaller installSAR: fname].
					['CS'] -> [(FileStream readOnlyFileNamed: fname) fileIn].
					['ST'] -> [(FileStream readOnlyFileNamed: fname) fileIn]
				}
			] on: Error
			do: 
			[
				(self confirm: 'Installation of ', fname, ' failed. Proceed anyway ?')
					ifFalse: [self error:  'Installation of ', fname, ' failed']
			]
		].

	 World submorphs do: [:m | 
		(wmorphs identityIncludes: m) ifFalse: [m delete]].
! !

!MuODeployer class methodsFor: 'fresh image installation' stamp: 'spfa 5/9/2018 14:03'!
installRequiredPackages

	self installAll: self requiredPackages! !

!MuODeployer class methodsFor: 'muO image release' stamp: 'spfa 9/11/2011 20:55'!
makeImageRelease

	self releaseImageAs: 'muO.image'
			enable: {
						#enableMuOManagers .
						#stickToManager .
						#surmulotComponent . 

						#editFilesWithEmacs .
						#editTextsWithEmacs .
						#emacsSocketIsADaemon .
	"					#listenToEmacsAtStartup ."
						#silentlyIgnoreErrorsFromEmacs .

						#enableCsoundInteraction .
	"					#enableLowkeyInteraction ."
						#enableSoundEditorInteraction .
						#enableSoundPlayerInteraction .
						#enableMF2TInteraction .
						#enableT2MFInteraction .
						#enableTimidityInteraction .

	"					#duplicateControlAndAltKeys ."
					}
			disable: {
						#enableLowkeyInteraction .
						#enableMIDIEditorInteraction .

						#logEmacsSession.

						#warnIfNoSourcesFile .
						#warnIfNoChangesFile .

						#preserveTrash .
						#slideDismissalsToTrash . 						#syntaxHighlightingAsYouTypeAnsiAssignment .
												
						#menuKeyboardControl
					}! !

!MuODeployer class methodsFor: 'widget image setup' stamp: 'spfa 10/13/2017 14:50'!
makeWidget: aMorph extent: aPoint port: aNumber

	| bbox |

	"Transform the current image into an emacs widget listening to a local port"

	Preferences disable: #surmulotComponent.
	Preferences disable: #enableMuOManagers.
	Preferences disable: #stickToManager.
	SurmulotManager disconnect.

	Preferences enable: #listenToEmacsAtStartup.
	Preferences enable: #accessShellViaEmacs.

	Preferences disable: #higherPerformance.

	SmalltalkImage current closeSourceFiles.
	SmalltalkImage current primImageName: ('widget %s' sformat: aNumber) .

	World submorphs do: [:m | m privateDelete].

	SmalltalkImage current platformName = 'Win32' ifTrue: [
		| p |
		p := aPoint isZero ifTrue: [aMorph extent] ifFalse: [aPoint].
		DisplayScreen depth: 32 width: p x height: p y fullscreen: false].
	Flaps disableGlobalFlaps: false.

	World layoutPolicy: ProportionalLayout new.
	World windowEventHandler: SurmulotWidgetWindowEventHandler.

	World doOneCycle.

	ChangeSet newChanges:
		(ChangeSorter basicNewChangeSet: 'widget changeset'). 

	aMorph behaveAsSurmulotWidget.
	
	EmacsInteraction startOnPort: aNumber.		
	
	(aMorph hasProperty: #smallWidget) ifFalse: [^ self].

	(bbox := aMorph boundingBoxOfSubmorphs) = aMorph bounds
		ifTrue: [^ self].

	bbox := bbox extendBy: 10. "heuristic"

	DisplayScreen depth: 32 
		width: bbox width height: bbox height fullscreen: false.
		
	
! !

!MuODeployer class methodsFor: 'widget image setup' stamp: 'spfa 11/18/2009 18:14'!
makeWidgetImage

	self makeWidgetImage: 'widget.image' extent: 650@450 
! !

!MuODeployer class methodsFor: 'widget image setup' stamp: 'spfa 11/18/2009 18:14'!
makeWidgetImage: aString extent: aPoint 

	Preferences disable: #surmulotComponent.
	Preferences disable: #enableMuOManagers.
	Preferences disable: #stickToManager.

	SmalltalkImage current closeSourceFiles.
	SmalltalkImage current primImageName: aString .

	DisplayScreen depth: 32 width: aPoint x height: aPoint y fullscreen: false.

	Flaps globalFlapTabsIfAny
		do: [:ft | Flaps removeFlapTab: ft keepInList: false].

	World removeAllMorphs.
	MuO logo openInWorld.

	SmalltalkImage current snapshot: true andQuit: true! !

!MenuLineMorph methodsFor: 'layout' stamp: 'dgd 9/1/2004 19:20'!
minHeight
	"answer the receiver's minHeight"
	^ self isInDockingBar
		ifTrue: [owner isVertical
				ifTrue: [2]
				ifFalse: [10]]
		ifFalse: [2]! !

!MenuLineMorph methodsFor: 'layout' stamp: 'dgd 9/1/2004 19:21'!
minWidth
	"answer the receiver's minWidth"
	^ self isInDockingBar
		ifTrue: [owner isVertical
				ifTrue: [10]
				ifFalse: [2]]
		ifFalse: [10]! !

!MenuLineMorph methodsFor: 'submorphs-accessing' stamp: 'dgd 9/1/2004 19:12'!
noteNewOwner: aMorph 
	"I have just been added as a submorph of aMorph"
	super noteNewOwner: aMorph.
	self updateLayoutInDockingBar! !

!MenuLineMorph methodsFor: 'change reporting' stamp: 'dgd 9/1/2004 19:12'!
ownerChanged
	"The receiver's owner, some kind of a pasteup, has changed its 
	layout."
	super ownerChanged.
	self updateLayoutInDockingBar! !

!MuODeployer class methodsFor: 'fresh image installation' stamp: 'spfa 11/18/2009 18:14'!
packagesCacheDirectory

	^	FileDirectory default directoryNamed:  'muo-cache'! !

!MuODeployer class methodsFor: 'fresh image installation' stamp: 'spfa 8/2/2022 18:41'!
prepareImageBeforeRequiredPackages
	
	Smalltalk at: #Float32Array ifAbsent: [
		FloatArray variableWordSubclass: #Float32Array
			instanceVariableNames: ''
			classVariableNames: ''
			poolDictionaries: ''
			category: 'Collections-Arrayed'].

	Color initialize.
	Utilities initializeCommonRequestStrings.	
	Deprecation showDeprecationWarnings: false.
	
	"The following allows Connectors for 3.8 to load fine".
	Scanner prefAllowUnderscoreSelectors: false.
	Smalltalk at: #EmptyArray put: #().
	(Smalltalk bindingOf: #BlockContext) ifNil: [
		Object subclass: #BlockContext
			instanceVariableNames: '' classVariableNames: ''
			poolDictionaries: '' category: 'MuODeployement'].	! !

!MuODeployer class methodsFor: 'fresh image installation' stamp: 'spfa 10/14/2018 11:51'!
properImageRestorationChangeSets

	self versionAbove52 ifTrue: [
		^ #(
			'NCLineMorph-borderInitialize.st'
			'NCAAConnectorMorph-borderStyle.st'
			'Context-stackUpToDoIt.st'
		)].

	^ #(
		'NCLineMorph-borderInitialize.st'
		'NCAAConnectorMorph-borderStyle.st'
	)! !

!MuODeployer class methodsFor: 'muO image release' stamp: 'spfa 9/24/2019 11:38'!
releaseImageAs: releaseName enable: truePrefs disable: falsePrefs

"... voir ReleaseBuilder>>makeSqueaklandRelease pour inspiration"

	SmalltalkImage current saveAs: releaseName. 

	Project current setParent: Project current.
	Project removeAll: (Project allSubInstances copyWithout: Project current).
	Project current changeSet name: 'muO'.

	MuO cleanUp.
	MIDIOutputRecord reset.

	"Launcher initialization"
	ProjectLauncher deactivate.
	MuOLauncher activate.

	"Morphic references hide there:"
	WorldState deferredUIMessages flush.
	SurmulotManager killEmacsFlap; killKeykitFlap.
	HandMorph allInstances do: [:h | h pasteBuffer: nil].
	SketchEditorMorph allInstances do: [:m | m clearEnclosingPasteUpMorph].

	PluggableTextMorph allSubInstancesDo: 
		[:ptm | ptm hasUnacceptedEdits: false].

	ZoomableFieldMorph allSubInstancesDo: [:m | m releaseCachedState].
	MGraphElementMorph allSubInstancesDo: [:m | m releaseCachedState].
	MGraphBook allSubInstancesDo: [:m | m releaseCachedState].
	Notebook allSubInstancesDo: [:m | m releaseCachedState].
	SketchMorph allSubInstancesDo: [:m | m releaseCachedState].
	ThumbnailMorph allSubInstancesDo: [:m | m releaseCachedState].

	Player freeUnreferencedSubclasses.
	Smalltalk cleanOutUndeclared.
	Behavior flushObsoleteSubclasses.
	Smalltalk garbageCollect; garbageCollect.
	DataStream initialize.
	CommandHistory resetAllHistory.

	MCWorkingCopy allManagers do: [:wc | wc unregister]. "clean-up"

	Smalltalk garbageCollect.
	
	truePrefs	do: [:pref | Preferences enable:  pref].
	falsePrefs	do: [:pref | Preferences disable:  pref].

	SurmulotManager defineExternalEnvironment.
	Utilities initializeCommonRequestStrings.
	#(
		'-'
		'Color displayNamedColors' 
		'World allMorphsDo: #resumeAfterDrawError'
	) do: [:s | Utilities appendToCommonRequests: s].	

	Smalltalk garbageCollect.
"	Smalltalk forgetDoIts."
	Smalltalk cleanOutUndeclared.
	Smalltalk garbageCollect.

	Smalltalk flushClassNameCache.
	3 timesRepeat: 
			[Smalltalk garbageCollect.
			Symbol condenseNewSymbols].

	MuO cleanUp.
"
	(self confirm: 'condense changes files ?')
		ifTrue: [Smalltalk condenseChanges].
"

	Utilities authorInitialsPerSe ifEmpty:
		[Utilities setAuthorInitials: 'muOuser'].

	SmalltalkImage current snapshot: true andQuit: true! !

!MuODeployer class methodsFor: 'muO SAR release' stamp: 'spfa 7/22/2022 15:21'!
releaseMuOPackage

	"MuODeployer releaseMuOPackage"

	(self confirm: ('release muO.%s.sar ?' sformat: MuOInfo version))
		ifFalse: [^ self].

	self handleInstallationFiles.

	MuO cleanUp.

	Preferences saveBooksUponMuORelease 
		ifTrue: [self saveAllBooks].

	MuO compileReleaseBooks.
	MuO compileTools.
	
	MuOInfo encodeMonkeyPackagesDevelVersions.

	MuOInfo new installationFiles do: [:sf | 
		sf asFileReference exists ifFalse: [self error: 'missing file: ', sf]].

	MusicalElementRepository compileRepositories.
	CsoundSynthesizer compileLibrary.

	[
		ChangeSetPackageExporter fileOutPackageNamed: 'MuODeployement'.
		SARPackageDumper fileOutPackage: MuOInfo new 
			as: ('muO.%s.sar' sformat: MuOInfo version) 
	] 
	ensure: [
		MusicalElementRepository allSubclasses do: [:c | c initialize].
		CsoundSynthesizer initialize
	]! !

!MuODeployer class methodsFor: 'fresh image installation' stamp: 'spfa 7/21/2022 22:56'!
requiredPackages

	^ #(
		'ConnectorsFor38-185.sar'
		'OSProcess-dtl.59.mcz'
		'OSC-SimonHolland.14.mcz'
		'HTML-md.1.mcz'
"		'Scamper-kfr.12.mcz'"
		'TestBrowser-tbn.119.mcz'
	"	'VB-Regex-nice.18.mcz' " "now in Squeak"
		'SophiePort-SeanDeNigris.1.mcz'
		'PackageInfo-Exporters-avi.7.mcz'
		'SARBuilder.8.sar'
		'People-spfa-sarbuilder.sar'
	)! !

!MuODeployer class methodsFor: 'snippets' stamp: 'spfa 11/18/2009 18:14'!
resetStrikeFontsEmphasis

	"fix a weird problem in my development image - spfa"

	(StrikeFont allInstances select: [:f | 
		f name last isDigit and: [f emphasis isZero not]] )
	do: [:f | f emphasis: 0]! !

!MuODeployer class methodsFor: 'fresh image installation' stamp: 'spfa 5/9/2018 15:10'!
restoreImageAfterRequiredPackages
	
	"restore methods that were changed in order to load the connectors package"
	(BorderedMorph changeRecordsAt: #borderInitialize) second fileIn.
	(Morph changeRecordsAt: #color:) second fileIn.

	! !

!MuODeployer class methodsFor: 'snippets' stamp: 'spfa 11/28/2016 14:35'!
saveAllBooks

	"MuODeployer saveAllBooks"

	self resetStrikeFontsEmphasis.

	
	"Tweaks for upward compatibility (to Squeak 4.6)"
	(TransformMorph allInstances 
		select: [:ea | ea owner class == MGraphPluggableTextMorph]) 
	do: [:ea | ea clipSubmorphs: true].
	(TransformMorph allInstances select: [:ea | ea owner isKindOf: REPLMorph]) 
		do: [:ea | ea layoutChanged].


	Utilities informUserDuring:[:blah |
		(MGraphBook allInstances 
			select: MuO booksForReleaseSelector)
			do: [:book |
					| n p psbv |
					n _ book pageNumber.
					p _ book position.				
					(book pages allSatisfy: [:page |
						(page externalName beginsWith: 'page') not
							and: [page externalName first isDigit not]
							and: [page knownName notNil]])
						ifTrue: [book pagesControls]
						ifFalse: [book fewerPageControls].
					book center:  400@300.
					book goToPage: 1.
					psbv _ book pages collect: [:ea |
						ea -> ((ea isKindOf: MGraphPluggableTextMorph)
							ifTrue: [ea scrollBar value] ifFalse: [nil])].
					psbv do: [:assoc |
						assoc value ifNotNil: [assoc key scrollBar setValue: 0].
						assoc key getProperty: #refuseDroppedMorphs].						
					blah value: book externalName.
					book saveOnUsualFile.
					psbv do: [:assoc |
						assoc value ifNotNil: [assoc key scrollBar setValue: assoc value].
						assoc key removeProperty: #refuseDroppedMorphs].
					book goToPage: n.
					book position: p]].

	Utilities informUserDuring:[:blah |
		(SystemWindow allInstances 
			select: MuO booksForReleaseSelector)
			do: [:sw |
					| p cp nb sbv |
					p _ sw position.
					cp _ sw isCollapsed.
					sw expand.
					sw center:  400@300.
					nb _ sw submorphs detect: [:m | m isKindOf: Notebook] ifNone: [nil].
					nb ifNotNil: [sbv _ nb scrollBar value. nb scrollBar setValue: 0].
					blah value: sw externalName.
					sw saveOnUsualFile.
					sw position: p.
					nb ifNotNil: [nb scrollBar setValue: sbv].					
					cp ifTrue: [sw collapse]]]! !

!TextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 7/21/2022 18:53'!
select
	"Ignore selection redraw requests."! !

!TextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 7/21/2022 18:52'!
selectionInterval: anInterval
	"Make my selection span the indicated interval.  If the interval extends outside the range of characters of the current text, force it within."

	| mySize |
	mySize := paragraph text string size.
	self selectFrom: (anInterval start min: mySize)
		to:	(anInterval stop min: mySize)! !

!MuODeployer class methodsFor: 'fresh image installation' stamp: 'spfa 11/18/2009 18:14'!
smInstallAll: aListOfIds

	[SMSqueakMap default reload] on: Error
		do: [SMSqueakMap default loadFull].

	^	aListOfIds do: [:id | SMSqueakMap default installPackageReleaseWithId: id]
! !

!MuODeployer class methodsFor: 'muO SAR release' stamp: 'spfa 1/17/2022 21:49'!
tablaFiles

	| dir |

	dir := 'wav' , FileDirectory slash, 'tabla'.

	^ (FileDirectory default directoryNamed: dir) fileNames 
		collect: [:ea | dir, FileDirectory slash,ea]! !

!MenuLineMorph methodsFor: 'private' stamp: 'dgd 9/1/2004 19:20'!
updateLayoutInDockingBar
	self isInDockingBar
		ifFalse: [^ self].
	""
	owner isVertical
		ifFalse: [""
			self hResizing: #shrinkWrap.
			self vResizing: #spaceFill]
		ifTrue: [""
			self hResizing: #spaceFill.
			self vResizing: #shrinkWrap].
	self extent: self minWidth @ self minHeight! !

!MuODeployer class methodsFor: 'fresh image installation' stamp: 'spfa 10/14/2018 11:50'!
versionAbove52

	^ (Smalltalk bindingOf: #Context) notNil! !

!SurmulotWidgetWindowEventHandler class methodsFor: 'as yet unclassified' stamp: 'spfa 11/26/2010 09:56'!
windowEvent: anEvent

	anEvent type == #windowClose ifFalse: [^ World layoutChanged].
	
	[
		EmacsInteraction evalElisp: 
			('(run-with-timer 0.1 nil (lambda () (surmulot-widget-close %s)))' 
				sformat: EmacsInteraction port)
	] on: Error 
	do: [MuO closeWidget]! !
