SystemOrganization addCategory: #MuSprites!
SystemOrganization addCategory: #'MuSprites-Bouncing'!


Sprite subclass: #BBSprite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MuSprites-Bouncing'!

BBSprite subclass: #BBPaddle
	instanceVariableNames: 'previousPosition previousTime instantSpeed instantSpeeds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MuSprites-Bouncing'!

BBSprite subclass: #CircularBouncingArena
	instanceVariableNames: 'contactAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MuSprites-Bouncing'!

SpriteGameEvent subclass: #BBContactEvent
	instanceVariableNames: 'impacter impactee'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MuSprites-Bouncing'!

SpriteGameAudioEngine subclass: #BreakOutAudio
	instanceVariableNames: 'sounds lastUtterance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MuSprites-Bouncing'!

BBContactEvent class
	instanceVariableNames: ''!

BBSprite class
	instanceVariableNames: ''!

BBPaddle class
	instanceVariableNames: ''!

CircularBouncingArena class
	instanceVariableNames: ''!

BreakOutAudio class
	instanceVariableNames: ''!

BBSprite subclass: #DiffusingBBSprite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MuSprites-Bouncing'!

DiffusingBBSprite subclass: #DiffusingDisk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MuSprites-Bouncing'!

DiffusingDisk subclass: #DiffusingPaddle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MuSprites-Bouncing'!

DiffusingDisk subclass: #BouncingBall
	instanceVariableNames: 'speed gravity mover arena'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MuSprites-Bouncing'!

DiffusingBBSprite class
	instanceVariableNames: ''!

SpriteGameEventListener subclass: #BreakOutEventListener
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MuSprites-Bouncing'!

BreakOutEventListener class
	instanceVariableNames: ''!

DiffusingDisk class
	instanceVariableNames: ''!

DiffusingPaddle class
	instanceVariableNames: ''!

BouncingBall class
	instanceVariableNames: ''!

BBSprite subclass: #BouncingArena
	instanceVariableNames: 'bottomContactAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MuSprites-Bouncing'!

BouncingArena class
	instanceVariableNames: ''!

DiffusingBBSprite subclass: #DiffusingPolygon
	instanceVariableNames: 'sides vertices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MuSprites-Bouncing'!

DiffusingPolygon class
	instanceVariableNames: ''!

BBSprite subclass: #BreakOutTile
	instanceVariableNames: 'lives breakAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MuSprites-Bouncing'!

BreakOutTile class
	instanceVariableNames: ''!


!BBPaddle methodsFor: 'as yet unclassified' stamp: 'spfa 9/25/2019 14:06'!
activate

	self action: [:s :t | 
		| x |.
		s center: (x := World currentHand position x) @ s center y.
		s left < (s owner left -4) ifTrue: [s left: s owner left -4].
		s right > (s owner right + 4) ifTrue: [s right: (s owner right + 4)].
		(previousTime notNil and: [previousTime < t]) ifTrue: [
			instantSpeeds add: ((x - previousPosition) /// (t - previousTime)) @ 0.
			instantSpeeds removeFirst.
			instantSpeed := instantSpeeds average].
		previousPosition := x.
		previousTime := t].
! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 9/24/2019 16:38'!
activate

	self speed: self speed.

	self action: [:s :t |
		mover ifNotNil: [

			s position: (mover value: t).
			self moved.

			(speed y > 0 and: [s checkBottomContact or: [s checkBottomBorder]])
				or: [speed y < 0 and: [s checkTopContact or: [s checkTopBorder]]]
				or: [speed x > 0 and: [s checkRightContact or: [s checkRightBorder]]]
				or: [speed x < 0 and: [s checkLeftContact or: [s checkLeftBorder]]]  .

			self gravity isZero ifFalse: [self speed: speed + self gravity]]]! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 11/26/2017 17:49'!
arena

	^ arena ifNil: [arena := World]
! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 11/26/2017 17:49'!
arena: aMorph

	arena := aMorph
! !

!BBSprite class methodsFor: 'forms library' stamp: 'spfa 3/8/2017 09:55'!
attribution

	^ 'All forms in this class are the (public domain) work of Kenney (http://www.kenney.nl/)'! !

!BreakOutEventListener methodsFor: 'as yet unclassified' stamp: 'spfa 4/18/2020 14:08'!
audioEngine

	^ self currentWorld spriteGamePresenter audioEngine! !

!BBSprite class methodsFor: 'forms library' stamp: 'spfa 11/27/2017 13:28'!
bigBlueBall

	^ Form new readResourceFrom: 
		(ReadStream on: 
			'Rk9STQAAADsAAAA7AAAAIAAACx7tmV0AEyssV2pvLVhrl1iv079bsdYW31ux1hfPW7HWr1qw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' base64Decoded asByteArray)! !

!DiffusingDisk class methodsFor: 'as yet unclassified' stamp: 'spfa 11/24/2017 00:16'!
bigTarget

	^ self new form: self target3! !

!BBPaddle class methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 23:53'!
blue

	^ self new form: BBSprite bluePaddle! !

!BreakOutTile class methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 18:15'!
blue

	^ self new form: self blueTile! !

!BBSprite class methodsFor: 'forms library' stamp: 'spfa 3/7/2017 18:09'!
blueBall

	^ Form new readResourceFrom: 
		(ReadStream on: 
			'Rk9STQAAABYAAAAWAAAAIAAAA8Dh5BkADx8YrO5fGqvsrxuq6hK/HKzpD68bqupfGqvsHxis
7ikADw8Rqu6fG63q7xqq6CL/Ha3rD+8aquifG63qDxGq7h0ACy8bre7fG6vqCv8dresP/06/
7/9fxfH/cMvyCv+A0fQP/3DL8v9fxfH/PrnuCv8dresL3xur6i8bre4VABcPEaru3xur6v8d
rev/Rrzu/5HX9SL/ot33F/+A0fT/Nbbt/x2t698bq+oPEaruEQAPzxys6v8drev/X8XxMv+i
3fcP/z657v8drevPHKzqDQAPfxys6v8drev/PrnuIv+i3fcL/6Pd9/+v4vgK/7jm+Sv/pd73
/5na9v81tu3/Ha3rfxys6gAAAAAPEaru7xqq6P8drev/kdf1Iv+i3fcH/7Hj+A7/wOn6J/+4
5vn/ot33/4nU9P8drevvGqroDxGq7m8brOr/Ha3r/06/7yb/ot33B/++6PkS/8Dp+gr/ot33
G/9Ov+//Ha3rbxus6r8crOn/Ha3r/3jO8yb/ot33B/+85/kO/8Dp+gf/vOf5Cv+i3fcb/3jO
8/8dreu/HKzp7xqq6P8drev/dMzyJv+i3fcX/6ff9/+65vn/wOn6/7rm+f+n3/cK/6Ld9w//
dMzy/x2t6+8aqugK/x2t6wv/es/z/5PX9Tr/ot33C/+Q1vX/es/zEv8dresK/3rP8wv/idT0
/5jZ9ir/ot33C/+V2PX/hNL0Cv96z/MK/x2t6w/vGqro/x2t6/90zPIO/3rP8w//htP0/5PX
9f+d2/YS/6Ld9w//ndv2/5PX9f+E0vQO/3rP8xv/dMzy/x2t6+8aqui/HKzp/x2t6/9cxPBC
/3rP8xv/XMTw/x2t678crOlvG6zq/x2t6/8/ue5C/3rP8x//P7nu/x2t628brOofGKzu/x2t
6/8ir+v/dMzyOv96z/MH/2jI8Qr/Ha3rFx8YrO4AAAAAnxut6v8drev/NLXtNv96z/MT/3TM
8v8osez/Ha3rnxut6gkAFw8Rqu7fG6vq/x2t6/86t+3/dMzyKv96z/MX/2jI8f8us+z/Ha3r
3xur6g8Rqu4NABcvG63u7xqq6P8drev/LrPs/3TM8iL/es/zF/9oyPH/Iq/r/x2t6+8aqugv
G63uFQALDxGq7s8crOoK/x2t6wv/P7nu/2jI8RL/es/zC/9oyPH/P7nuCv8dresLzxys6g8R
qu4dAAsPEarurxuq6ir/Ha3rC48cq+sPEaruKQAPLxut7p8brervGqroEv8dresP7xqq6I8c
q+sfGKzuGQA=' base64Decoded asByteArray)! !

!BBSprite class methodsFor: 'forms library' stamp: 'spfa 3/7/2017 18:03'!
bluePaddle

	^ Form new readResourceFrom: 
		(ReadStream on: 
			'Rk9STQAAAGgAAAAYAAAAIAAABnvpwB0AFx8Qe6w/EH2pfxB8qq8QeqrPEHynJv8QfasH/zaI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' base64Decoded asByteArray)! !

!BBSprite class methodsFor: 'forms library' stamp: 'spfa 3/7/2017 18:05'!
blueTile

	^ Form new readResourceFrom: 
		(ReadStream on: 
			'Rk9STQAAAEAAAAAgAAAAIAAAAunoAAs/EH2prxB6quDy/xB9qw+vEHqqPxB9qc8QfKfg+v8Q
fasHzxB8pwr/EH2rB/9fxfDg6v96z/MH/1/F8BL/EH2rC/80tu3/X8Xw4OL/es/zC/9fxfD/
NLbtEv8QfasK/zS27Qf/X8Xw2v96z/MH/1/F8Ar/NLbtEv8QfasO/zS27Qf/X8Xw0v96z/MH
/1/F8A7/NLbtEv8QfasS/zS27Qf/X8Xwyv96z/MH/1/F8BL/NLbtEv8QfasW/zS27Qf/X8Xw
wv96z/MH/1/F8Bb/NLbtEv8Qfasa/zS27cL/Sr/wGv80tu0S/xB9qxr/NLbtwv9Kv/Aa/zS2
7RL/EH2rGv80tu3C/0q/8Br/NLbtEv8Qfasa/zS27cL/Sr/wGv80tu0S/xB9qxr/NLbtwv9K
v/Aa/zS27RL/EH2rGv80tu3C/0q/8Br/NLbtEv8Qfasa/zS27cL/Sr/wGv80tu0S/xB9qxr/
NLbtwv9Kv/Aa/zS27RL/EH2rGv80tu3C/0q/8Br/NLbtEv8Qfasa/zS27cL/Sr/wGv80tu0S
/xB9qxr/NLbtwv9Kv/Aa/zS27RL/EH2rGv80tu3C/0q/8Br/NLbtEv8Qfasa/zS27cL/Sr/w
Gv80tu0S/xB9qxr/NLbtwv9Kv/Aa/zS27RL/EH2rGv80tu3C/0q/8Br/NLbtEv8Qfasa/zS2
7cL/Sr/wGv80tu0S/xB9qxb/NLbtB/8or+jC/xSl4gf/KK/oFv80tu0S/xB9qxL/NLbtB/8o
r+jK/xSl4gf/KK/oEv80tu0S/xB9qw7/NLbtB/8or+jS/xSl4gf/KK/oDv80tu0S/xB9qwr/
NLbtB/8or+ja/xSl4gf/KK/oCv80tu0S/xB9qwv/NLbt/yiv6ODi/xSl4gv/KK/o/zS27RL/
EH2rB/8or+jg6v8UpeIH/yiv6Ar/EH2rB98Qe6rg+v8QfasP3xB7qm8QfKnvEHqo4PL/EH2r
C+8QeqhvEHyp' base64Decoded asByteArray)! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 11/26/2017 17:45'!
bottomContact

	^ self arena submorphs detect: [:m |
		({self . self valueOfProperty: #lastContact} identityIncludes: m) not
			and: [self hasBottomContactWith: m]] ifNone: [nil]! !

!BouncingBall methodsFor: 'old pinball' stamp: 'spfa 9/23/2019 10:28'!
bounceAt: normal

	self bounceAt: normal from: nil! !

!BouncingBall methodsFor: 'old pinball' stamp: 'spfa 9/23/2019 10:28'!
bounceAt: normal from: aSprite

	self speed: (Point r: self speed r theta: (self speed theta - Float pi + (2 * (normal - self speed theta)))) + (aSprite ifNil: [BBSprite]) speedNoise.

	aSprite ifNotNil: [self speed: self speed + aSprite impactSpeed]! !

!BBPaddle methodsFor: 'as yet unclassified' stamp: 'spfa 9/24/2019 15:48'!
bouncingBallBottomContact: aBouncingBall

	aBouncingBall center x < self leftO x ifTrue: 
		[^ self bouncingBallLeftContact: aBouncingBall].

	aBouncingBall center x > self rightO ifTrue: 
		[^ self bouncingBallRightContact: aBouncingBall].

	aBouncingBall bounceAt: Float halfPi negated from: self! !

!BBSprite methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 22:17'!
bouncingBallBottomContact: aBouncingBall
	
	aBouncingBall top: self bottom. 
	aBouncingBall speed: (aBouncingBall speed x @  aBouncingBall speed y negated) 
		+ self class speedNoise! !

!BouncingArena methodsFor: 'as yet unclassified' stamp: 'spfa 9/23/2019 10:28'!
bouncingBallBottomContact: aBouncingBall

	aBouncingBall top: self top. 
	aBouncingBall speed: (aBouncingBall speed x @  aBouncingBall speed y negated) 
		+ (self class speedNoise x @ 0)! !

!CircularBouncingArena methodsFor: 'as yet unclassified' stamp: 'spfa 11/27/2017 14:06'!
bouncingBallBottomContact: aBouncingBall

	self handleContactFrom: aBouncingBall! !

!DiffusingBBSprite methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 22:00'!
bouncingBallBottomContact: aBouncingBall

	aBouncingBall bounceAt:
		(self normalAt: aBouncingBall topCenter for: aBouncingBall)! !

!DiffusingDisk methodsFor: 'as yet unclassified' stamp: 'spfa 11/27/2017 14:06'!
bouncingBallBottomContact: aBouncingBall

	self handleContactFrom: aBouncingBall! !

!BBPaddle methodsFor: 'as yet unclassified' stamp: 'spfa 9/24/2019 15:44'!
bouncingBallLeftContact: aBouncingBall

	| leftO rd theta |

	leftO := self leftCenter.
	self instantSpeed x < 0 "??" ifFalse: [leftO := self leftO].

	rd := (self height * 0.5) + aBouncingBall contactDepth + 1.
	theta := (aBouncingBall center - leftO) theta.
	aBouncingBall center: (leftO + (Point r: rd theta: theta)).

	aBouncingBall bounceAt: (aBouncingBall center - leftO) theta from: self

! !

!BBSprite methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 22:17'!
bouncingBallLeftContact: aBouncingBall
	
	aBouncingBall right: self left. 
	aBouncingBall speed: (aBouncingBall speed x negated @  aBouncingBall speed y) 
		+ self class speedNoise! !

!BouncingArena methodsFor: 'as yet unclassified' stamp: 'spfa 9/23/2019 10:28'!
bouncingBallLeftContact: aBouncingBall

	aBouncingBall right: self right. 
	aBouncingBall speed: (aBouncingBall speed x negated @  aBouncingBall speed y) 
		+ (0 @ self class speedNoise y)! !

!CircularBouncingArena methodsFor: 'as yet unclassified' stamp: 'spfa 11/27/2017 14:06'!
bouncingBallLeftContact: aBouncingBall

	self handleContactFrom: aBouncingBall! !

!DiffusingBBSprite methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 22:05'!
bouncingBallLeftContact: aBouncingBall

	aBouncingBall bounceAt: 
		(self normalAt: aBouncingBall rightCenter for: aBouncingBall)! !

!DiffusingDisk methodsFor: 'as yet unclassified' stamp: 'spfa 11/27/2017 14:06'!
bouncingBallLeftContact: aBouncingBall

	self handleContactFrom: aBouncingBall! !

!BBPaddle methodsFor: 'as yet unclassified' stamp: 'spfa 9/24/2019 15:44'!
bouncingBallRightContact: aBouncingBall

	| rightO rd theta |

	rightO := self rightCenter.
	self instantSpeed x > 0 "??" ifFalse: [rightO := self rightO].

	rd := (self height * 0.5) + aBouncingBall contactDepth + 1.
	theta := (aBouncingBall center - rightO) theta.
	aBouncingBall center: (rightO + (Point r: rd theta: theta)).

	aBouncingBall bounceAt: (aBouncingBall center - rightO) theta from: self! !

!BBSprite methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 22:17'!
bouncingBallRightContact: aBouncingBall
	
	aBouncingBall left: self right. 
	aBouncingBall speed: (aBouncingBall speed x negated @  aBouncingBall speed y)
		+ self class speedNoise! !

!BouncingArena methodsFor: 'as yet unclassified' stamp: 'spfa 9/23/2019 10:28'!
bouncingBallRightContact: aBouncingBall

	aBouncingBall left: self left. 
	aBouncingBall speed: (aBouncingBall speed x negated @  aBouncingBall speed y) 
		+ (0 @ self class speedNoise y)! !

!CircularBouncingArena methodsFor: 'as yet unclassified' stamp: 'spfa 11/27/2017 14:06'!
bouncingBallRightContact: aBouncingBall

	self handleContactFrom: aBouncingBall! !

!DiffusingBBSprite methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 22:04'!
bouncingBallRightContact: aBouncingBall

	aBouncingBall bounceAt: 
		(self normalAt: aBouncingBall leftCenter for: aBouncingBall)! !

!DiffusingDisk methodsFor: 'as yet unclassified' stamp: 'spfa 11/27/2017 14:06'!
bouncingBallRightContact: aBouncingBall

	self handleContactFrom: aBouncingBall! !

!BBPaddle methodsFor: 'as yet unclassified' stamp: 'spfa 9/24/2019 15:54'!
bouncingBallTopContact: aBouncingBall

	(aBouncingBall center x < self leftO x
			and: [(aBouncingBall speed x * self instantSpeed x) >= 0]) ifTrue: 
		[^ self bouncingBallLeftContact: aBouncingBall].

	(aBouncingBall center x > self rightO x
			and: [(aBouncingBall speed x * self instantSpeed x) >= 0]) ifTrue: 
		[^ self bouncingBallRightContact: aBouncingBall].
	
	aBouncingBall bounceAt: Float halfPi from: self! !

!BBSprite methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 22:17'!
bouncingBallTopContact: aBouncingBall
	
	aBouncingBall bottom: self top. 
	aBouncingBall speed: (aBouncingBall speed x @  aBouncingBall speed y negated) 
		+ self class speedNoise! !

!BouncingArena methodsFor: 'as yet unclassified' stamp: 'spfa 9/23/2019 10:28'!
bouncingBallTopContact: aBouncingBall

	bottomContactAction ifNotNil: [
		^ bottomContactAction valueWithEnoughArguments: {aBouncingBall}].

	aBouncingBall bottom: self bottom. 
	aBouncingBall speed: (aBouncingBall speed x @  aBouncingBall speed y negated) 
		+ (self class speedNoise x @ 0)! !

!CircularBouncingArena methodsFor: 'as yet unclassified' stamp: 'spfa 11/27/2017 14:06'!
bouncingBallTopContact: aBouncingBall

	self handleContactFrom: aBouncingBall! !

!DiffusingBBSprite methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 22:01'!
bouncingBallTopContact: aBouncingBall
	
	aBouncingBall bounceAt: 
		(self normalAt: aBouncingBall bottomCenter for: aBouncingBall)! !

!DiffusingDisk methodsFor: 'as yet unclassified' stamp: 'spfa 11/27/2017 14:06'!
bouncingBallTopContact: aBouncingBall

	self handleContactFrom: aBouncingBall! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 9/24/2019 16:35'!
checkBottomBorder

	self arena isSprite 
		ifTrue: [(self arena hasTopContactFrom: self) ifFalse: [^ false]]
		ifFalse: [(self bottom >= self arena bottom) ifFalse: [^ false]].

	self registerContactWith: self arena.
	self arena isSprite ifTrue: [self arena bouncingBallTopContact: self.. ^ true].

	self bottom: self arena bottom.
	self speed: (self speed x @ self speed y negated) + BBSprite speedNoise..

	^ true
! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 9/24/2019 16:39'!
checkBottomContact

	| m proxy |

	(proxy := m := self bottomContact) ifNil: [^ false].

	(m isSprite and: [m isBBSprite]) ifFalse: [proxy := BBSprite new bounds: m bounds].

	proxy bouncingBallTopContact: self.
	self registerContactWith: m.

	^ true
! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 9/24/2019 16:34'!
checkLeftBorder

	self arena isSprite 
		ifTrue: [(self arena hasRightContactFrom: self) ifFalse: [^ false]]
		ifFalse: [(self left <= self arena left) ifFalse: [^ false]].

	self registerContactWith: self arena.
	self arena isSprite ifTrue: [self arena bouncingBallRightContact: self.. ^ true].

	self left: self arena left. .
	self speed: (self speed x negated @ self speed y) + BBSprite speedNoise.

	^ true! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 22:03'!
checkLeftContact

	| m proxy |

	(proxy := m := self leftContact) ifNil: [^ false].

	(m isSprite and: [m isBBSprite]) ifFalse: [proxy := BBSprite new bounds: m bounds].

	proxy bouncingBallRightContact: self.
	self registerContactWith: m.

	^ true! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 9/24/2019 16:35'!
checkRightBorder

	self arena isSprite 
		ifTrue: [(self arena hasLeftContactFrom: self) ifFalse: [^ false]]
		ifFalse: [(self right >= self arena right) ifFalse: [^ false]].

	self registerContactWith: self arena.
	self arena isSprite ifTrue: [self arena bouncingBallLeftContact: self.. ^ true].

	self right: self arena right. 
	self speed: (self speed x negated @ self speed y) + BBSprite speedNoise.

	^ true! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 22:04'!
checkRightContact

	| m proxy |

	(proxy := m := self rightContact) ifNil: [^ false].

	(m isSprite and: [m isBBSprite]) ifFalse: [proxy := BBSprite new bounds: m bounds].

	proxy bouncingBallLeftContact: self.
	self registerContactWith: m.

	^ true! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 9/24/2019 16:35'!
checkTopBorder

	self arena isSprite 
		ifTrue: [(self arena hasBottomContactFrom: self) ifFalse: [^ false]]
		ifFalse: [(self top <= self arena top) ifFalse: [^ false]].

	self registerContactWith: self arena.
	self arena isSprite ifTrue: [self arena bouncingBallBottomContact: self.. ^ true].

	self top: self arena top. 
	self speed: (self speed x @ self speed y negated) + BBSprite speedNoise.

	^ true! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 9/24/2019 16:39'!
checkTopContact

	| m proxy |

	(proxy := m := self topContact) ifNil: [^ false].

	(m isSprite and: [m isBBSprite]) ifFalse: [proxy := BBSprite new bounds: m bounds].

	proxy bouncingBallBottomContact: self.
	self registerContactWith: m.

	^ true! !

!DiffusingPolygon methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 14:37'!
computeVertices

	| angle phase |

	phase := Float halfPi negated.

	^ vertices :=  (1 to: sides) collect: [:n | 
		angle := n *  (Float twoPi / self sides)  + phase.
		self center + (Point new setR: (self width * 0.5) radians: angle)]! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 15:39'!
contactDepth

	^ (self width * 0.5) ceiling! !

!BBSprite methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 18:21'!
deactivate

	self action: nil! !

!DiffusingPolygon class methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 18:13'!
diamond

	^ self new 
		form: self yellowDiamond;
		sides: 4! !

!BouncingArena methodsFor: 'as yet unclassified' stamp: 'spfa 11/26/2017 17:54'!
drawsRegularly

	^ true! !

!CircularBouncingArena methodsFor: 'as yet unclassified' stamp: 'spfa 11/27/2017 11:07'!
drawsRegularly

	^ true!
]style[(14 9)b,! !

!BBSprite class methodsFor: 'examples' stamp: 'spfa 11/24/2017 00:21'!
example1

	"
BBSprite example1
World spritesDo: #delete
"

	| paddle |

	(paddle := BBPaddle new position: World bottomCenter - (0@50)) openInWorld.
	(BouncingBall new speed: 10@15; position: paddle topCenter) activate openInWorld.! !

!BBSprite class methodsFor: 'examples' stamp: 'spfa 9/26/2019 10:36'!
example2

	"
BBSprite example2
World spritesDo: #delete
"

	| tile enclosure arena paddle colors ball checkForEnd n levels setUp gameOver |

	tile := BreakOutTile red.

	arena := BouncingArena new 
				extent: (tile width * (n := 8)) @ (tile height * 13);
				color: (Color gray: 0.95).

	arena center: World center.

	arena clipSubmorphs: true.

	enclosure := Morph new extent: arena extent + (14@5).
	enclosure center: World center - (0@5).
	enclosure addMorph: arena.
	enclosure openInWorld.

	enclosure beSticky.

	paddle := BBPaddle new position: arena bottomCenter - (0@50).
	arena addMorph: paddle.
	ball := BouncingBall new speed: 0@ -18; arena: arena; bottomCenter: paddle topCenter.
	arena addMorph: ball.

	arena addMorph: (DiffusingDisk bigTarget 
						center: arena leftCenter + (-20 @ 20); 
						action: [:s :t | 
							(ball action notNil 
									and: [arena containsPoint: ActiveHand cursorPoint])
								ifTrue: [Cursor blank show]]).
	arena addMorph: (DiffusingDisk bigTarget center: arena rightCenter + (20 @ 20)).
	arena addMorph: (DiffusingDisk bigTarget center: arena topCenter - (0 @ 30)).
	arena addMorph: (DiffusingDisk bigTarget center: arena topLeft - (30 @ 30)).
	arena addMorph: (DiffusingDisk bigTarget center: arena topRight - (-30 @ 30)).

	enclosure color: (DiffusingDisk bigTarget  colorAt: #center).

	colors := #(grey violet red green blue grey).

	gameOver := [
		ball experienced: #failure.
		ball deactivate; delete. Cursor normal show. 
		arena inform: 'Game over!!'. enclosure delete].

	arena onBottomContactDo: gameOver.
	arena action: [:s :t | (arena containsPoint: ball center) ifFalse: gameOver].

	levels := {

'mmmmmmmm
-mm--mm-
mmmmmmmm'.

'mmmmmmmm
mm-mm-mm
-mmmmmm-
--mmmm--
---mm---'.

'--mmmm--
-m-mm-m-
-mm--mm-
--m--m--
---mm---
--mmmm--'.

'--mmmm--
mmmmmmmm
-mm--mm-
mmmmmmmm
---mm---
mmmmmmmm'.

'mm-mm-mm
m-d--d-m
mm-mm-mm
-mmmmmm-'.

	} generator.

	checkForEnd := [:brick |
		(arena findA: brick class) ifNil: [
			levels atEnd ifTrue: [
					ball experienced: #victory.
					ball deactivate; delete. Cursor normal show. 
					arena inform: 'Well done.'. enclosure delete]
				ifFalse: [setUp value: levels next]]].

	setUp := [:spec |
		arena submorphsDo: [:m | (m hasProperty: #hard) ifTrue: [m delete]].
	 	spec lines doWithIndex: [:tiles :line |
			tiles doWithIndex: [:ea :col |
				ea = $d ifTrue: [
					arena addMorph: 
						(DiffusingPolygon diamond
							getProperty: #hard;
							center: arena position + (tile extent * 0.5) +
								(((col - 1) * tile width) @ ((line + 1) * tile height)))].
				ea = $m ifTrue: [
					arena addMorph: 
						((BreakOutTile perform: (colors at: line) )
							lives: (line = 2 ifTrue: [2] ifFalse: [1]);
							onDeletionDo: checkForEnd;
							position: arena position +
								(((col - 1) * tile width) @ ((line + 1) * tile height)))]]]].

	setUp value: levels next.

	World spriteGamePresenter 
		gameEventListener: BreakOutEventListener new;
		audioEngine: BreakOutAudio new. 

	arena inform: 'Ready!!'.
	ball activate! !

!BBSprite class methodsFor: 'examples' stamp: 'spfa 9/24/2019 16:43'!
example3

	"
BBSprite example3.
World spritesDo: #delete
"

	| arena ball |

	arena := BouncingArena new extent: 400 @ 400; color: (Color gray: 0.9).
	arena center: World center.
	arena openInWorld.

	arena addMorph: (DiffusingDisk bigTarget center: arena center).

	10 timesRepeat: [
		ball := BouncingBall new speed: 6@ -12; position: World topCenter.
		ball openInWorld.
		ball activate]! !

!BBSprite class methodsFor: 'examples' stamp: 'spfa 9/26/2019 21:26'!
example4

	"
BBSprite example4
"

	| game arena paddle ball checkForEnd n levels setUp bColor singer gameOver |

	World spriteGamePresenter 
		gameEventListener: BreakOutEventListener new;
		audioEngine: BreakOutAudio new. 

	singer := World spriteGamePresenter audioEngine newSinger.
	singer experienced: #loonyMood.

	bColor := Color gray: 0.85.

	game := (EllipseMorph new 
			borderWidth: 7; borderColor: bColor; color: (Color gray: 0.95); 
			extent: 400@400; center: World center) openInWorld.

	arena := CircularBouncingArena new 
				extent: 400@400; center: game center; color: Color transparent.
	game addMorph: arena.

	paddle := (DiffusingPaddle new form: BBSprite bigBlueBall)
				 action: [:sprite :t |
					sprite center: (ActiveHand cursorPoint atRadius: 200 from: game center)].
	arena addMorph: paddle.

	ball := BouncingBall new arena: arena.
	game addMorph: ball.

	levels := {
		#(yellow violet green) -> {1@90. 2@90. 3@90}.
		#(yellow violet green red) -> {1@90.  3@45. 3@135. 3@90}.
		#(yellow violet green red) -> {3@180.  3@0. 2@135. 2@45}.
		#(yellow grey green green grey yellow) 
			-> {3@240.  3@115. 2@135. 3@65. 2@45. 3@300}.
		#(yellow violet violet grey grey yellow red red) 
			-> {3@220.  3.4@115. 3@135. 3.4@65. 3@45. 3@320. 3.5@0 .3.5@180}.
	} generator.

	setUp := [:level |
		ball deactivate; center: game center + (0@40); speed: 0.2@5.
		game borderColor: bColor.
		n = 1 ifTrue: [singer experienced: #relief]. 
		n := 2.
		level key with: level value do: [:color :pos |
			arena addMorph: 
				((BreakOutTile perform: color)
					onDeletionDo: checkForEnd;
					center: arena center - 
						(Point r: (pos x * 1.3 * BreakOutTile red height) degrees: pos y))]].

	checkForEnd := [
		arena submorphs size = 1 ifTrue: [	
			levels atEnd 
				ifTrue: [		
					ball experienced: #victory.
					self inform: 'Not bad.'. game delete. Display restore]
				ifFalse: [
					setUp value: levels next]]].

	setUp value: levels next.

	gameOver := [
		singer stopSinging.
		ball experienced: #failure.
		ball delete. paddle delete. 
		self inform: 'Game over!!'. 
		game delete. 
		Display restore].

	n := 2.
	arena onContactDo: [
		(n := n - 1) isZero 
			ifFalse: [singer experienced: #restlessness.
					game borderColor: game borderColor muchLighter.] 
			ifTrue: gameOver].

	arena action: [:s :t | (arena containsPoint: ball center) ifFalse: gameOver].

	singer startSinging.

	game on: #mouseDown send: #value to: ball lambda activate
! !

!BreakOutAudio methodsFor: 'as yet unclassified' stamp: 'spfa 7/11/2021 16:11'!
giveLoonySongTo: aSinger

	aSinger phrase: ('co1!!!!""""::sus4,eo1::h7' kphrase last: 5) at0 legato.
	aSinger mutator: [:singer | singer phraseDo: [:ph | ph shuffle disturb legato]].
! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 21:24'!
gravity

	^ gravity ifNil: [gravity := 0@0]! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 3/5/2017 00:06'!
gravity: aPoint

	gravity := aPoint! !

!BreakOutTile class methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 18:15'!
green

	^ self new form: self greenTile! !

!BBSprite class methodsFor: 'forms library' stamp: 'spfa 3/7/2017 18:04'!
greenTile

	^ Form new readResourceFrom: 
		(ReadStream on: 
			'Rk9STQAAAEAAAAAgAAAAIAAAAunoAAs/aYkgr2eHIODy/2qJIQ+vZ4cgP2mJIM9nhyDg+v9q
iSEHz2eHIAr/aokhB/+nz0ng6v+z2FoH/6fPSRL/aokhC/+VwC7/p89J4OL/s9haC/+nz0n/
lcAuEv9qiSEK/5XALgf/p89J2v+z2FoH/6fPSQr/lcAuEv9qiSEO/5XALgf/p89J0v+z2FoH
/6fPSQ7/lcAuEv9qiSES/5XALgf/p89Jyv+z2FoH/6fPSRL/lcAuEv9qiSEW/5XALgf/p89J
wv+z2FoH/6fPSRb/lcAuEv9qiSEa/5XALsL/n84xGv+VwC4S/2qJIRr/lcAuwv+fzjEa/5XA
LhL/aokhGv+VwC7C/5/OMRr/lcAuEv9qiSEa/5XALsL/n84xGv+VwC4S/2qJIRr/lcAuwv+f
zjEa/5XALhL/aokhGv+VwC7C/5/OMRr/lcAuEv9qiSEa/5XALsL/n84xGv+VwC4S/2qJIRr/
lcAuwv+fzjEa/5XALhL/aokhGv+VwC7C/5/OMRr/lcAuEv9qiSEa/5XALsL/n84xGv+VwC4S
/2qJIRr/lcAuwv+fzjEa/5XALhL/aokhGv+VwC7C/5/OMRr/lcAuEv9qiSEa/5XALsL/n84x
Gv+VwC4S/2qJIRr/lcAuwv+fzjEa/5XALhL/aokhGv+VwC7C/5/OMRr/lcAuEv9qiSEa/5XA
LsL/n84xGv+VwC4S/2qJIRb/lcAuB/+PuCvC/4WsKAf/j7grFv+VwC4S/2qJIRL/lcAuB/+P
uCvK/4WsKAf/j7grEv+VwC4S/2qJIQ7/lcAuB/+PuCvS/4WsKAf/j7grDv+VwC4S/2qJIQr/
lcAuB/+PuCva/4WsKAf/j7grCv+VwC4S/2qJIQv/lcAu/4+4K+Di/4WsKAv/j7gr/5XALhL/
aokhB/+PuCvg6v+FrCgH/4+4Kwr/aokhB99piCDg+v9qiSEP32mIIG9phyDvZ4cg4PL/aokh
C+9nhyBvaYcg' base64Decoded asByteArray)! !

!BreakOutTile class methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 18:15'!
grey

	^ self new form: self greyTile! !

!BBSprite class methodsFor: 'forms library' stamp: 'spfa 3/7/2017 18:10'!
greyBall

	^ Form new readResourceFrom: 
		(ReadStream on: 
			'Rk9STQAAABYAAAAWAAAAIAAAA7zh5BkADx+UlJRfk5OTr5SUlBK/lJSUD6+UlJRfk5OTH5SU
lCkADw+ZmZmflZWV75SUlCL/lZWVD++UlJSflZWVD5mZmR0ACy+SkpLfk5OTCv+VlZUP/7S0
tP+/v7//ysrKCv/U1NQP/8rKyv+/v7//qqqqCv+VlZUL35OTky+SkpIVABcPmZmZ35OTk/+V
lZX/r6+v/9/f3yL/6urqF//U1NT/pKSk/5WVld+Tk5MPmZmZEQAPz5WVlf+VlZX/v7+/Mv/q
6uoP/6qqqv+VlZXPlZWVDQAPf5SUlP+VlZX/qqqqJv/q6uoH/+/v7wr/8/PzK//r6+v/5OTk
/6SkpP+VlZV/lJSUAAAAAA+ZmZnvlJSU/5WVlf/f398i/+rq6gf/8PDwDv/39/cn//Pz8//q
6ur/2tra/5WVle+UlJQPmZmZb5WVlf+VlZX/tLS0Jv/q6uoH//b29hL/9/f3Cv/q6uob/7S0
tP+VlZVvlZWVv5SUlP+VlZX/z8/PJv/q6uoH//X19Q7/9/f3B//19fUK/+rq6hv/z8/P/5WV
lb+UlJTvlJSU/5WVlf/Pz88m/+rq6hf/7Ozs//T09P/39/f/9PT0/+zs7Ar/6urqD//Pz8//
lZWV75SUlAr/lZWVC//Z2dn/4+PjOv/q6uoL/+Li4v/Z2dkS/5WVlQr/2dnZC//f39//5eXl
Kv/q6uoL/+Tk5P/d3d0K/9nZ2Qr/lZWVD++UlJT/lZWV/9TU1A7/2dnZD//e3t7/4+Pj/+fn
5xL/6urqD//n5+f/4+Pj/93d3Q7/2dnZG//U1NT/lZWV75SUlL+UlJT/lZWV/8PDw0L/2dnZ
G//Dw8P/lZWVv5SUlG+VlZX/lZWV/66urkL/2dnZH/+urq7/lZWVb5WVlR+UlJT/lZWV/5mZ
mf/U1NQ6/9nZ2Qf/zMzMCv+VlZUXH5SUlAAAAACflZWV/5WVlf+mpqY2/9nZ2RP/1NTU/52d
nf+VlZWflZWVCQAXD5mZmd+Tk5P/lZWV/6qqqv/U1NQq/9nZ2Rf/zMzM/6Ghof+VlZXfk5OT
D5mZmQ0AFy+SkpLvlJSU/5WVlf+hoaH/1NTUIv/Z2dkX/8zMzP+ZmZn/lZWV75SUlC+SkpIV
AAsPmZmZz5WVlQr/lZWVC/+urq7/zMzMEv/Z2dkL/8zMzP+urq4K/5WVlQvPlZWVD5mZmR0A
Cw+ZmZmvlJSUKv+VlZULj5SUlA+ZmZkpAA8vkpKSn5WVle+UlJQS/5WVlQ/vlJSUj5SUlB+U
lJQZAA==' base64Decoded asByteArray)! !

!BBSprite class methodsFor: 'forms library' stamp: 'spfa 3/7/2017 18:05'!
greyTile

	^ Form new readResourceFrom: 
		(ReadStream on: 
			'Rk9STQAAAEAAAAAgAAAAIAAAAunoAAs/dXV1r3Z2duDy/3d3dw+vdnZ2P3V1dc92dnbg+v93
d3cHz3Z2dgr/d3d3B//Q0NDg6v/d3d0H/9DQ0BL/d3d3C/+7u7v/0NDQ4OL/3d3dC//Q0ND/
u7u7Ev93d3cK/7u7uwf/0NDQ2v/d3d0H/9DQ0Ar/u7u7Ev93d3cO/7u7uwf/0NDQ0v/d3d0H
/9DQ0A7/u7u7Ev93d3cS/7u7uwf/0NDQyv/d3d0H/9DQ0BL/u7u7Ev93d3cW/7u7uwf/0NDQ
wv/d3d0H/9DQ0Bb/u7u7Ev93d3ca/7u7u8L/zMzMGv+7u7sS/3d3dxr/u7u7wv/MzMwa/7u7
uxL/d3d3Gv+7u7vC/8zMzBr/u7u7Ev93d3ca/7u7u8L/zMzMGv+7u7sS/3d3dxr/u7u7wv/M
zMwa/7u7uxL/d3d3Gv+7u7vC/8zMzBr/u7u7Ev93d3ca/7u7u8L/zMzMGv+7u7sS/3d3dxr/
u7u7wv/MzMwa/7u7uxL/d3d3Gv+7u7vC/8zMzBr/u7u7Ev93d3ca/7u7u8L/zMzMGv+7u7sS
/3d3dxr/u7u7wv/MzMwa/7u7uxL/d3d3Gv+7u7vC/8zMzBr/u7u7Ev93d3ca/7u7u8L/zMzM
Gv+7u7sS/3d3dxr/u7u7wv/MzMwa/7u7uxL/d3d3Gv+7u7vC/8zMzBr/u7u7Ev93d3ca/7u7
u8L/zMzMGv+7u7sS/3d3dxb/u7u7B/+zs7PC/6ampgf/s7OzFv+7u7sS/3d3dxL/u7u7B/+z
s7PK/6ampgf/s7OzEv+7u7sS/3d3dw7/u7u7B/+zs7PS/6ampgf/s7OzDv+7u7sS/3d3dwr/
u7u7B/+zs7Pa/6ampgf/s7OzCv+7u7sS/3d3dwv/u7u7/7Ozs+Di/6ampgv/s7Oz/7u7uxL/
d3d3B/+zs7Pg6v+mpqYH/7Ozswr/d3d3B990dHTg+v93d3cP33R0dG93d3fvdnZ24PL/d3d3
C+92dnZvd3d3' base64Decoded asByteArray)! !

!CircularBouncingArena methodsFor: 'as yet unclassified' stamp: 'spfa 9/25/2019 23:30'!
handleContactFrom: aBouncingBall

	contactAction ifNotNil: [
		contactAction valueWithEnoughArguments: {aBouncingBall}].

	aBouncingBall bounceAt: 
		(self normalAt: aBouncingBall center for: aBouncingBall).

	aBouncingBall center: (aBouncingBall center 
		atRadius: (self width * 0.5) - aBouncingBall contactDepth - self borderWidth - 1 
		from: self center).
! !

!DiffusingDisk methodsFor: 'as yet unclassified' stamp: 'spfa 9/25/2019 23:19'!
handleContactFrom: aBouncingBall

	aBouncingBall center: (aBouncingBall center 
		atRadius: (self width * 0.5) + aBouncingBall contactDepth + 1 
		from: self center).

	aBouncingBall bounceAt: 
		(self normalAt: aBouncingBall center for: aBouncingBall).
! !

!BreakOutEventListener methodsFor: 'as yet unclassified' stamp: 'spfa 9/26/2019 21:30'!
handleGameEvent: aGameEvent

	aGameEvent isStateChange ifTrue: [
		aGameEvent newState caseOf: {
			[#failure] ->  [
		"		Speaker whispery say: 'ooooh, too bad'."
				^ self audioEngine play: 'ao0!!!!!!""",a&&^' kphrase].
			[#victory] ->  [^" Speaker kid say: 'yes'" self].
			[#loonyMood] ->  [^ self audioEngine giveLoonySongTo: aGameEvent gamePart].
			[#restlessness] ->  [^ aGameEvent gamePart phraseDo: #octaveUp].
			[#relief] ->  [^ aGameEvent gamePart phraseDo: #octaveDown].
		} otherwise: [^ self]].

	aGameEvent isContact ifFalse: [^ self].
	self audioEngine playSoundTagged: aGameEvent impactee soundTag! !

!BreakOutEventListener methodsFor: 'as yet unclassified' stamp: 'spfa 11/25/2019 14:44'!
handleGameEvent: aGameEvent from: anObject

	self handleGameEvent: aGameEvent! !

!BBSprite methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 14:42'!
hasBottomContactFrom: aBouncingBall

	^ aBouncingBall bottom >= self bottom
		and: [self left < aBouncingBall right]
		and: [self right > aBouncingBall left]
		and: [(aBouncingBall center y - self bottom) <= aBouncingBall contactDepth]! !

!BouncingArena methodsFor: 'as yet unclassified' stamp: 'spfa 11/26/2017 18:08'!
hasBottomContactFrom: aBouncingBall

	^ super hasTopContactFrom: aBouncingBall! !

!CircularBouncingArena methodsFor: 'as yet unclassified' stamp: 'spfa 11/27/2017 11:08'!
hasBottomContactFrom: aBouncingBall

	^ self hasContactFrom: aBouncingBall
! !

!DiffusingDisk methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 23:20'!
hasBottomContactFrom: aBouncingBall

	^ self hasContactFrom: aBouncingBall
! !

!DiffusingPolygon methodsFor: 'as yet unclassified' stamp: 'spfa 11/26/2017 00:57'!
hasBottomContactFrom: aBouncingBall

	^ (self normalAt: aBouncingBall topCenter for: aBouncingBall) notNil! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 22:08'!
hasBottomContactWith: m

	(m isSprite 	and: [m isBBSprite]) ifTrue: [^ m hasTopContactFrom: self].

	^ self hasBottomContactWith: (BBSprite new bounds: m bounds)! !

!CircularBouncingArena methodsFor: 'as yet unclassified' stamp: 'spfa 11/27/2017 11:50'!
hasContactFrom: aBouncingBall

	(aBouncingBall center dist: self center) < ((self width) * 0.5) ifFalse: [^ false].

	^ (aBouncingBall center dist: self center) >= ((self width) * 0.5 - aBouncingBall contactDepth)! !

!DiffusingDisk methodsFor: 'as yet unclassified' stamp: 'spfa 10/17/2019 23:46'!
hasContactFrom: aBouncingBall

	^ (aBouncingBall center dist: self center) <= (self width * 0.5 + aBouncingBall contactDepth)! !

!BBPaddle methodsFor: 'as yet unclassified' stamp: 'spfa 9/24/2019 15:33'!
hasLeftContactFrom: aBouncingBall

	^ aBouncingBall left <= self left
		and: [self top < aBouncingBall bottom]
		and: [self bottom > aBouncingBall top]
		and: [(self leftO dist: aBouncingBall center) < aBouncingBall contactDepth]! !

!BBSprite methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 17:05'!
hasLeftContactFrom: aBouncingBall

	^ aBouncingBall left <= self left
		and: [self top < aBouncingBall bottom]
		and: [self bottom > aBouncingBall top]
		and: [(self left - aBouncingBall center x) <= aBouncingBall contactDepth]! !

!BouncingArena methodsFor: 'as yet unclassified' stamp: 'spfa 11/26/2017 22:07'!
hasLeftContactFrom: aBouncingBall

	^ super hasRightContactFrom: aBouncingBall! !

!CircularBouncingArena methodsFor: 'as yet unclassified' stamp: 'spfa 11/27/2017 11:08'!
hasLeftContactFrom: aBouncingBall

	^ self hasContactFrom: aBouncingBall
! !

!DiffusingDisk methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 23:21'!
hasLeftContactFrom: aBouncingBall

	^ self hasContactFrom: aBouncingBall
! !

!DiffusingPolygon methodsFor: 'as yet unclassified' stamp: 'spfa 11/26/2017 00:57'!
hasLeftContactFrom: aBouncingBall

	^ (self normalAt: aBouncingBall rightCenter for: aBouncingBall) notNil! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 22:08'!
hasLeftContactWith: m

	(m isSprite 	and: [m isBBSprite]) ifTrue: [^ m hasRightContactFrom: self].

	^ self hasLeftContactWith: (BBSprite new bounds: m bounds)! !

!BBPaddle methodsFor: 'as yet unclassified' stamp: 'spfa 9/24/2019 15:34'!
hasRightContactFrom: aBouncingBall

	^ aBouncingBall right >= self right
		and: [self top < aBouncingBall bottom]
		and: [self bottom > aBouncingBall top]
		and: [(self rightO dist: aBouncingBall center) < aBouncingBall contactDepth]! !

!BBSprite methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 17:05'!
hasRightContactFrom: aBouncingBall

	^ aBouncingBall right >= self right
		and: [self top < aBouncingBall bottom]
		and: [self bottom > aBouncingBall top]
		and: [(aBouncingBall center x - self right) <= aBouncingBall contactDepth]! !

!BouncingArena methodsFor: 'as yet unclassified' stamp: 'spfa 11/26/2017 22:07'!
hasRightContactFrom: aBouncingBall

	^ super hasLeftContactFrom: aBouncingBall! !

!CircularBouncingArena methodsFor: 'as yet unclassified' stamp: 'spfa 11/27/2017 11:08'!
hasRightContactFrom: aBouncingBall

	^ self hasContactFrom: aBouncingBall
! !

!DiffusingDisk methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 23:21'!
hasRightContactFrom: aBouncingBall

	^ self hasContactFrom: aBouncingBall
! !

!DiffusingPolygon methodsFor: 'as yet unclassified' stamp: 'spfa 11/26/2017 00:57'!
hasRightContactFrom: aBouncingBall

	^ (self normalAt: aBouncingBall leftCenter for: aBouncingBall) notNil! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 22:08'!
hasRightContactWith: m

	(m isSprite 	and: [m isBBSprite]) ifTrue: [^ m hasLeftContactFrom: self].

	^ self hasRightContactWith: (BBSprite new bounds: m bounds)! !

!BBPaddle methodsFor: 'as yet unclassified' stamp: 'spfa 9/25/2019 14:06'!
hasTopContactFrom: aBouncingBall

	^ aBouncingBall top <= self top  
		and: [aBouncingBall speed y >= 0]
		and: [(self left min: (self left + instantSpeed x)) < aBouncingBall right]
		and: [(self right max: (self right + instantSpeed x)) > aBouncingBall left]
		and: [(self top - aBouncingBall center y) <= aBouncingBall contactDepth]! !

!BBSprite methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 14:42'!
hasTopContactFrom: aBouncingBall

	^ aBouncingBall top <= self top  
		and: [self left < aBouncingBall right]
		and: [self right > aBouncingBall left]
		and: [(self top - aBouncingBall center y) <= aBouncingBall contactDepth]! !

!BouncingArena methodsFor: 'as yet unclassified' stamp: 'spfa 11/26/2017 22:07'!
hasTopContactFrom: aBouncingBall

	^ super hasBottomContactFrom: aBouncingBall! !

!CircularBouncingArena methodsFor: 'as yet unclassified' stamp: 'spfa 11/27/2017 11:08'!
hasTopContactFrom: aBouncingBall

	^ self hasContactFrom: aBouncingBall
! !

!DiffusingDisk methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 23:20'!
hasTopContactFrom: aBouncingBall

	^ self hasContactFrom: aBouncingBall
! !

!DiffusingPolygon methodsFor: 'as yet unclassified' stamp: 'spfa 11/26/2017 00:57'!
hasTopContactFrom: aBouncingBall

	^ (self normalAt: aBouncingBall bottomCenter for: aBouncingBall) notNil! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 22:08'!
hasTopContactWith: m

	(m isSprite 	and: [m isBBSprite]) ifTrue: [^ m hasBottomContactFrom: self].

	^ self hasTopContactWith: (BBSprite new bounds: m bounds)! !

!BBPaddle methodsFor: 'as yet unclassified' stamp: 'spfa 9/25/2019 14:06'!
impactSpeed

	^ (self instantSpeed * 0.02 max: -10 @ -2) min: 10 @ 2! !

!BBContactEvent methodsFor: 'as yet unclassified' stamp: 'spfa 9/23/2019 10:28'!
impactee

	^ impactee! !

!BBContactEvent methodsFor: 'as yet unclassified' stamp: 'spfa 9/23/2019 10:28'!
impactee: aSprite

	impactee := aSprite! !

!BBContactEvent methodsFor: 'as yet unclassified' stamp: 'spfa 9/23/2019 10:28'!
impacter

	^ impacter! !

!BBContactEvent methodsFor: 'as yet unclassified' stamp: 'spfa 9/23/2019 10:28'!
impacter: aSprite

	impacter := aSprite! !

!BBPaddle methodsFor: 'as yet unclassified' stamp: 'spfa 9/24/2019 15:49'!
initialize

	super initialize.
	self activate.

	self form: BBSprite bluePaddle.
	instantSpeeds := LinkedList new.
	8 timesRepeat: (instantSpeeds add: 0).! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 18:17'!
initialize

	super initialize.
	self form: BBSprite blueBall.
	self speed: 5@5! !

!BreakOutAudio methodsFor: 'as yet unclassified' stamp: 'spfa 9/23/2019 10:28'!
initialize

	sounds := {
		#tile -> 'eo1!!!!"""' knote.
		#strongTile -> 'f+o6&&""' knote.
		#arena -> 'co1!!"""' knote.
		#paddle -> 'ao1!!"""' knote.
		#polygon -> 'ao4""' knote.
		#disk -> 'go1!!!!""' knote.
	} as: IdentityDictionary.

	self synth
	! !

!BreakOutAudio class methodsFor: 'as yet unclassified' stamp: 'spfa 9/26/2019 10:08'!
initializeSynth

	^ Synthesizer := 
		((MuOSampler sampling: Vibraphone new onMIDIKeys: #(36 50 65 80 90 105))
					gain: 1.0)
			asSqueakSynthesizer gain: 0.5

! !

!BBPaddle methodsFor: 'as yet unclassified' stamp: 'spfa 9/23/2019 10:28'!
instantSpeed

	^ instantSpeed ifNil: [0@0].
	! !

!BBSprite methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 21:48'!
isBBSprite
	
	^ true! !

!BBContactEvent methodsFor: 'as yet unclassified' stamp: 'spfa 9/23/2019 10:28'!
isContact

	^ true! !

!BBPaddle methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 17:15'!
isInteractiveForBouncingBall

	^ true! !

!BBPaddle methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 22:12'!
isMoving
	
	^ true! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 23:29'!
isMoving

	^ false "???" "true"! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 11/26/2017 17:47'!
leftContact

	^ self arena submorphs detect: [:m |
		({self . self valueOfProperty: #lastContact} identityIncludes: m) not
			and: [self hasLeftContactWith: m]] ifNone: [nil]! !

!BBPaddle methodsFor: 'as yet unclassified' stamp: 'spfa 9/24/2019 15:33'!
leftO

	^ self leftCenter + (self height * 0.5 @ 0)! !

!BreakOutTile methodsFor: 'as yet unclassified' stamp: 'spfa 11/24/2017 00:07'!
lives

	^ lives ifNil: [lives := 1]! !

!BreakOutTile methodsFor: 'as yet unclassified' stamp: 'spfa 11/24/2017 00:07'!
lives: anInteger

	lives := anInteger! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 9/25/2019 14:06'!
maxSpeed

	^ 9.0! !

!BBPaddle methodsFor: 'as yet unclassified' stamp: 'spfa 9/24/2019 15:46'!
mayHaveConsecutiveContacts
	
	^ true! !

!BBSprite methodsFor: 'as yet unclassified' stamp: 'spfa 11/24/2017 00:04'!
mayHaveConsecutiveContacts
	
	^ false! !

!BouncingArena methodsFor: 'as yet unclassified' stamp: 'spfa 11/24/2017 00:05'!
mayHaveConsecutiveContacts

	^ true! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 11/24/2017 00:04'!
mayHaveConsecutiveContacts

	^ false "???" "true"! !

!CircularBouncingArena methodsFor: 'as yet unclassified' stamp: 'spfa 11/27/2017 13:05'!
mayHaveConsecutiveContacts

	^ true! !

!DiffusingPaddle methodsFor: 'as yet unclassified' stamp: 'spfa 11/27/2017 11:56'!
mayHaveConsecutiveContacts
	
	^ true! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 9/25/2019 14:06'!
minSpeed

	^ 6.0! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 2/22/2019 13:01'!
moved! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 3/6/2017 14:22'!
mover

	^ mover! !

!DiffusingBBSprite methodsFor: 'as yet unclassified' stamp: 'spfa 3/5/2017 14:33'!
normalAt: aPoint

	^ (self normalVectorAt: aPoint) theta! !

!CircularBouncingArena methodsFor: 'as yet unclassified' stamp: 'spfa 11/27/2017 13:03'!
normalAt: aPoint for: aBouncingBall

	^ (self center - aPoint) theta! !

!DiffusingBBSprite methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 22:52'!
normalAt: aPoint for: aBouncingBall

	^ (self normalVectorAt: aPoint) theta! !

!DiffusingPolygon methodsFor: 'as yet unclassified' stamp: 'spfa 11/26/2017 17:02'!
normalAt: aPoint for: aBouncingBall

	"ignoring aPoint"

	| bbc bbr normals |

	bbc := aBouncingBall center.
	bbr := aBouncingBall contactDepth.

	(bbc dist: self center) > (bbr + (0.5 * self width)) ifTrue: [^ nil].

	normals := Set new.

	self vertices cyclicSegmentsDo: [:v1 :v2 |
		| c dx dy p d |
		dx := v2 x asFloat - v1 x.
		dy := v2 y asFloat - v1 y.
	
		(dx closeTo: 0.0) ifTrue: [c := (bbc y - v1 y) / dy].
		(dy closeTo: 0.0) ifTrue: [c := (bbc x - v1 x) / dx].		
		c ifNil: [
			c := ((bbc y asFloat - v1 y / dx) + (bbc x asFloat - v1 x / dy))
					/ ((dx / dy) + (dy / dx))].

		p := (v1 x + (c * dx)) @ (v1 y + (c * dy)).

		(c >= 0.0 and: [c <= 1.0]) 
			ifTrue: [
				d := bbc dist: p.
				(d lessOrCloseTo: bbr)
					ifTrue: [normals add: d -> (bbc - p) theta]]
			ifFalse: [		
				^ (bbc - self center) theta]].

		normals ifEmpty: [^ nil].

		^ (normals detectMin: [:ea | ea key]) value! !

!DiffusingBBSprite methodsFor: 'as yet unclassified' stamp: 'spfa 3/5/2017 14:33'!
normalVectorAt: aPoint
	! !

!DiffusingDisk methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 22:57'!
normalVectorAt: aPoint

	^ aPoint - self center! !

!BBContactEvent class methodsFor: 'as yet unclassified' stamp: 'spfa 9/23/2019 10:28'!
of: aSprite by: bSprite

	^ self new impacter: bSprite; impactee: aSprite! !

!BouncingArena methodsFor: 'as yet unclassified' stamp: 'spfa 11/26/2017 22:23'!
onBottomContactDo: aBlock

	bottomContactAction := aBlock! !

!CircularBouncingArena methodsFor: 'as yet unclassified' stamp: 'spfa 11/27/2017 13:53'!
onContactDo: aBlock

	contactAction := aBlock! !

!BreakOutTile methodsFor: 'as yet unclassified' stamp: 'spfa 11/26/2017 22:24'!
onDeletionDo: aBlock

	breakAction := aBlock! !

!DiffusingPolygon class methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 18:13'!
pentagon

	^ self new 
		form: self yellowPentagon;
		sides: 5! !

!BreakOutAudio methodsFor: 'as yet unclassified' stamp: 'spfa 9/26/2019 10:57'!
play: musicOrSound

	| ph dt | 

	ph := musicOrSound.
	ph isMusicalElement ifFalse: [^ super play: musicOrSound].

	(lastUtterance notNil and: [(dt := Time millisecondClockValue - lastUtterance) < 100])
		ifTrue: [ph := ph cc delay: 0.1 - (dt / 1000.0)].

	self synth play: ph disturbed.

	lastUtterance := Time millisecondClockValue.! !

!BreakOutAudio methodsFor: 'as yet unclassified' stamp: 'spfa 9/26/2019 10:21'!
playSoundTagged: aSymbol

	self play: (sounds at: aSymbol ifAbsent: [^ self])! !

!BBPaddle class methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 23:53'!
red

	^ self new form: BBSprite redPaddle! !

!BreakOutTile class methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 18:08'!
red

	^ self new form: self redTile! !

!BBSprite class methodsFor: 'forms library' stamp: 'spfa 3/7/2017 18:05'!
redPaddle

	^ Form new readResourceFrom: 
		(ReadStream on: 
			'Rk9STQAAAGgAAAAYAAAAIAAABVvpwB0AFx+cCAg/nQwMf5wMDK+aCwvPnAwMJv+dDQ0H/6A0
NODy/6qqqir/nQ0NDr+cDAwLr5oLCx+cCAgxAAs/nQwMz5wMDDr/nQ0NB/+gNDTg8v+qqqo+
/50NDQu/nAwML50KCiUAB2+cCwsK/50NDRf/oQ0N/7kODv/JDw//0hkZ/94nJwr/7S0tHv/y
NzcH/+tfX+Dy/9nZ2SL/8jc3Cv/tLS0X/9onJ//SGRn/yQ8P/7UODv+hDQ0K/50NDQdvnAsL
HQAHb5wLCwr/nQ0NE//BDg7/3hAQ/+EXF//vMjIu//I3Nwf/619f4PL/2dnZMv/yNzcT/+0t
Lf/fEhL/2Q8P/7UODgr/nQ0NB2+cCwsVABtfmwoK/50NDf+hDQ3/0Q8P/94QEP/lHh42//I3
Nwf/619f4PL/2dnZNv/yNzcT//A0NP/hFxf/3hAQ/8UODgr/nQ0NB1+bCgoNAB8vnQoK75oK
Cv+dDQ3/xQ4O/94QEP/hFxf/8DQ0Nv/yNzcH/+tfX+Dy/9nZ2Tr/8jc3H//uLy//3xIS/94Q
EP+1Dg7/nQ0N75oKCh+cCAgJABu/nAwM/50NDf+5Dg7/3hAQ/98SEv/vMjI6//I3Nwf/619f
4PL/2dnZPv/yNzcH/+4vLwr/3hAQK/+xDQ3/nQ0Nr5oLCwAAAAAvnQoK/50NDf+hDQ3/2Q8P
/94QEP/oIyM+//I3Nwf/619f4PL/2dnZQv/yNzcn/+YhIf/eEBD/1Q8P/6ENDf+dDQ0vnQoK
j5sMDP+dDQ3/uQ4OCv/eEBAH//A0ND7/8jc3B//rX1/g8v/Z2dlC//I3Nwf/8DQ0Cv/eEBAj
/7kODv+dDQ2PmwwMv5wMDP+dDQ3/zQ8P/94QEP/jGRlC//I3Nwf/619f4PL/2dnZRv/yNzcX
/+EXF//eEBD/yQ8P/50NDb+cDAwK/50NDQr/3hAQB//oIyNC//I3Nwf/619f4PL/2dnZRv/y
NzcH/+gjIwr/3hAQEv+dDQ0K/94QEAf/6CMjQv/yNzcH/+tfX+Dy/9nZ2Ub/8jc3B//oIyMK
/94QEBL/nQ0NTv/eEBAH/9pAQODy/9DQ0FL/3hAQEv+dDQ1O/94QEAf/2kBA4PL/0NDQTv/e
EBAH/9kPDwr/nQ0ND7+cDAz/nQ0N/80PD0r/3hAQB//aQEDg8v/Q0NBO/94QEBv/zQ8P/50N
Db+cDAyPmwwM/50NDf+9Dg5K/94QEAf/2kBA4PL/0NDQTv/eEBAb/7kODv+dDQ2PmwwMP50M
DP+dDQ3/pQ0NSv/eEBAH/9pAQODy/9DQ0Er/3hAQI//ZDw//oQ0N/50NDT+dDAwAAAAAz5wM
DP+dDQ3/wQ4ORv/eEBAH/9pAQODy/9DQ0Er/3hAQD/+5Dg7/nQ0Nz5wMDAkABz+dDAwK/50N
DQf/0Q8PQv/eEBAH/9pAQODy/9DQ0Eb/3hAQB//FDg4K/50NDQc/nQwMDQATf5wMDP+dDQ3/
oQ0N/8UODj7/3hAQB//aQEDg8v/Q0NBC/94QEAf/uQ4OCv+dDQ0Hf5wMDBUAB4+bDAwK/50N
DQf/wQ4OOv/eEBAH/9pAQODy/9DQ0Dr/3hAQC//ZDw//tQ4OCv+dDQ0Hj5sMDB0AB1+bCgoK
/50NDQ//pQ0N/8UODv/VDw8u/94QEAf/2kBA4PL/0NDQMv/eEBAP/9UPD//BDg7/pQ0NCv+d
DQ0HX5sKCiUACz+dDAzPnAwMOv+dDQ0H/6A0NODy/6qqqj7/nQ0NC8+cDAwvnQoKMQALX5sK
Cq+aCwsy/50NDQf/oDQ04PL/qqqqMv+dDQ0P75oKCq+aCwtPngwMHQA=' base64Decoded asByteArray)! !

!BBSprite class methodsFor: 'forms library' stamp: 'spfa 3/7/2017 18:12'!
redSquare

	^ Form new readResourceFrom: 
		(ReadStream on: 
			'Rk9STQAAACAAAAAgAAAAIAAAAuHkAAs/jQgIr40KCnL/jgsLD6+NCgo/jQgIz4wHB3r/jgsL
B8+MBwcK/44LCwf/60xMav/0cXEH/+tMTBL/jgsLC//eEBD/60xMYv/0cXEL/+tMTP/eEBAS
/44LCwr/3hAQB//rTExa//RxcQf/60xMCv/eEBAS/44LCw7/3hAQB//rTExS//RxcQf/60xM
Dv/eEBAS/44LCxL/3hAQB//rTExK//RxcQf/60xMEv/eEBAS/44LCxb/3hAQB//rTExC//Rx
cQf/60xMFv/eEBAS/44LCxr/3hAQQv/yNzca/94QEBL/jgsLGv/eEBBC//I3Nxr/3hAQEv+O
Cwsa/94QEEL/8jc3Gv/eEBAS/44LCxr/3hAQQv/yNzca/94QEBL/jgsLGv/eEBBC//I3Nxr/
3hAQEv+OCwsa/94QEEL/8jc3Gv/eEBAS/44LCxr/3hAQQv/yNzca/94QEBL/jgsLGv/eEBBC
//I3Nxr/3hAQEv+OCwsa/94QEEL/8jc3Gv/eEBAS/44LCxr/3hAQQv/yNzca/94QEBL/jgsL
Gv/eEBBC//I3Nxr/3hAQEv+OCwsa/94QEEL/8jc3Gv/eEBAS/44LCxr/3hAQQv/yNzca/94Q
EBL/jgsLGv/eEBBC//I3Nxr/3hAQEv+OCwsa/94QEEL/8jc3Gv/eEBAS/44LCxr/3hAQQv/y
Nzca/94QEBL/jgsLFv/eEBAH/9IPD0L/vg4OB//SDw8W/94QEBL/jgsLEv/eEBAH/9IPD0r/
vg4OB//SDw8S/94QEBL/jgsLDv/eEBAH/9IPD1L/vg4OB//SDw8O/94QEBL/jgsLCv/eEBAH
/9IPD1r/vg4OB//SDw8K/94QEBL/jgsLC//eEBD/0g8PYv++Dg4L/9IPD//eEBAS/44LCwf/
0g8Pav++Dg4H/9IPDwr/jgsLB9+LCgp6/44LCw/fiwoKb44JCe+LCAhy/44LCwvviwgIb44J
CQ==' base64Decoded asByteArray)! !

!BBSprite class methodsFor: 'forms library' stamp: 'spfa 3/7/2017 18:00'!
redTile

	^ Form new readResourceFrom: 
		(ReadStream on: 
			'Rk9STQAAAEAAAAAgAAAAIAAAAunoAAs/jQgIr40KCuDy/44LCw+vjQoKP40ICM+MBwfg+v+O
CwsHz4wHBwr/jgsLB//rTEzg6v/0cXEH/+tMTBL/jgsLC//eEBD/60xM4OL/9HFxC//rTEz/
3hAQEv+OCwsK/94QEAf/60xM2v/0cXEH/+tMTAr/3hAQEv+OCwsO/94QEAf/60xM0v/0cXEH
/+tMTA7/3hAQEv+OCwsS/94QEAf/60xMyv/0cXEH/+tMTBL/3hAQEv+OCwsW/94QEAf/60xM
wv/0cXEH/+tMTBb/3hAQEv+OCwsa/94QEML/8jc3Gv/eEBAS/44LCxr/3hAQwv/yNzca/94Q
EBL/jgsLGv/eEBDC//I3Nxr/3hAQEv+OCwsa/94QEML/8jc3Gv/eEBAS/44LCxr/3hAQwv/y
Nzca/94QEBL/jgsLGv/eEBDC//I3Nxr/3hAQEv+OCwsa/94QEML/8jc3Gv/eEBAS/44LCxr/
3hAQwv/yNzca/94QEBL/jgsLGv/eEBDC//I3Nxr/3hAQEv+OCwsa/94QEML/8jc3Gv/eEBAS
/44LCxr/3hAQwv/yNzca/94QEBL/jgsLGv/eEBDC//I3Nxr/3hAQEv+OCwsa/94QEML/8jc3
Gv/eEBAS/44LCxr/3hAQwv/yNzca/94QEBL/jgsLGv/eEBDC//I3Nxr/3hAQEv+OCwsa/94Q
EML/8jc3Gv/eEBAS/44LCxb/3hAQB//SDw/C/74ODgf/0g8PFv/eEBAS/44LCxL/3hAQB//S
Dw/K/74ODgf/0g8PEv/eEBAS/44LCw7/3hAQB//SDw/S/74ODgf/0g8PDv/eEBAS/44LCwr/
3hAQB//SDw/a/74ODgf/0g8PCv/eEBAS/44LCwv/3hAQ/9IPD+Di/74ODgv/0g8P/94QEBL/
jgsLB//SDw/g6v++Dg4H/9IPDwr/jgsLB9+LCgrg+v+OCwsP34sKCm+OCQnviwgI4PL/jgsL
C++LCAhvjgkJ' base64Decoded asByteArray)! !

!BBSprite methodsFor: 'as yet unclassified' stamp: 'spfa 9/23/2019 10:28'!
registerContactFrom: aBouncingBall

	self experienced: (BBContactEvent of: self by: aBouncingBall)! !

!BouncingArena methodsFor: 'as yet unclassified' stamp: 'spfa 9/24/2019 16:07'!
registerContactFrom: aBouncingBall

	aBouncingBall arena == self ifFalse: [
		aBouncingBall arena: self. "capture"
		self addMorph: aBouncingBall].

	super registerContactFrom: aBouncingBall
! !

!BreakOutTile methodsFor: 'as yet unclassified' stamp: 'spfa 9/23/2019 10:28'!
registerContactFrom: aBouncingBall

	super registerContactFrom: aBouncingBall.

	self lives: self lives - 1.
	self lives isZero ifTrue: [
		self delete.
		breakAction ifNotNil: [breakAction valueWithEnoughArguments: {self . aBouncingBall}]]! !

!CircularBouncingArena methodsFor: 'as yet unclassified' stamp: 'spfa 9/24/2019 16:07'!
registerContactFrom: aBouncingBall

	aBouncingBall arena == self ifFalse: [
		aBouncingBall arena: self. "capture"
		self addMorph: aBouncingBall].

	super registerContactFrom: aBouncingBall
! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 7/25/2022 21:39'!
registerContactWith: aMorph

	aMorph isSprite ifTrue: [aMorph registerContactFrom: self].

	(aMorph isSprite 
			and: [aMorph isBBSprite] 
			and: [aMorph mayHaveConsecutiveContacts])
		ifTrue: [self setProperty: #lastContact toValue: nil]
		ifFalse: [self setProperty: #lastContact toValue: aMorph]! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 11/26/2017 17:47'!
rightContact

	^ self arena submorphs detect: [:m |
		({self . self valueOfProperty: #lastContact} identityIncludes: m) not
			and: [self hasRightContactWith: m]] ifNone: [nil]! !

!BBPaddle methodsFor: 'as yet unclassified' stamp: 'spfa 9/24/2019 15:33'!
rightO

	^ self rightCenter - (self height * 0.5 @ 0)! !

!DiffusingPolygon methodsFor: 'as yet unclassified' stamp: 'spfa 3/5/2017 14:49'!
sides

	^ sides! !

!DiffusingPolygon methodsFor: 'as yet unclassified' stamp: 'spfa 11/26/2017 00:18'!
sides: anInteger

	sides := anInteger.
	self computeVertices! !

!BBPaddle methodsFor: 'as yet unclassified' stamp: 'spfa 9/23/2019 10:28'!
soundTag

	^ #paddle! !

!BBSprite methodsFor: 'as yet unclassified' stamp: 'spfa 9/23/2019 10:28'!
soundTag

	^ #none! !

!BouncingArena methodsFor: 'as yet unclassified' stamp: 'spfa 9/23/2019 10:28'!
soundTag

	^ #arena! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 9/19/2019 16:12'!
soundTag

	^ #ball! !

!BreakOutTile methodsFor: 'as yet unclassified' stamp: 'spfa 9/23/2019 10:28'!
soundTag

	^ self lives > 1 ifTrue: [#strongTile] ifFalse: [#tile]! !

!DiffusingDisk methodsFor: 'as yet unclassified' stamp: 'spfa 9/23/2019 10:28'!
soundTag

	^ #disk! !

!DiffusingPolygon methodsFor: 'as yet unclassified' stamp: 'spfa 9/19/2019 16:08'!
soundTag

	^ #polygon! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 3/6/2017 14:19'!
speed

	^ speed ifNil: [self speed: 5@5]! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 11/26/2017 23:09'!
speed: aPoint

	| p0 t0 |

	speed := aPoint.

	speed r > self maxSpeed ifTrue: [speed setR: self maxSpeed radians: speed theta].
	speed r < self minSpeed ifTrue: [speed setR: self minSpeed radians: speed theta].

	p0 := self position.
	t0 := self timeNow.

	mover := [:t | p0 + (1000.0 * speed /// self stepTime * (t - t0))]! !

!BBPaddle methodsFor: 'as yet unclassified' stamp: 'spfa 9/23/2019 10:28'!
speedNoise

	^ 0@0! !

!BBSprite methodsFor: 'as yet unclassified' stamp: 'spfa 9/23/2019 10:28'!
speedNoise

	^ self class speedNoise! !

!BBSprite class methodsFor: 'as yet unclassified' stamp: 'spfa 9/24/2019 16:43'!
speedNoise

	^ ((50 atRandom -25) @ (40 atRandom + 20) negated) / 200.0! !

!DiffusingPolygon class methodsFor: 'as yet unclassified' stamp: 'spfa 11/24/2017 00:12'!
square

	^ self new 
		form: self yellowSquare;
		sides: 4! !

!BBSprite class methodsFor: 'forms library' stamp: 'spfa 3/7/2017 23:17'!
target3

	^ Form new readResourceFrom: 
		(ReadStream on: 
			'Rk9STQAAAIAAAACAAAAAIAAAJsb/AABAANUAFy/kYhY/52UQb+ZnFX/naBSP5mcUMr/laBcX
j+ZnFH/naBRv5mcVP+dlEC/kYhbhlQATL+RiFl/nZhOf52gVz+ZpFWL/6GoXE8/maRWf52gV
X+dmEy/kYhbhcQATD91VAG/mZxWv5mcW7+ZpFYL/6GoXE+/maRWv5mcWb+ZnFQ/dVQDhVQAP
H+ZjCG/mZxXP5mkVov/oahcPz+ZpFW/mZxUf5mMI4UEAC0/lahev5mcWuv/oahcLr+ZnFk/l
ahfhLQAPD91VAG/mZxXf5WgXyv/oahcP3+VoF2/mZxUP3VUA4RkADw/dVQCP5mcU7+ZpFdr/
6GoXD+/maRWP5mcUD91VAOENAAd/52gU4PL/6GoXB3/naBThAQALX+dmE+/maRXg+v/oahcL
7+ZpFV/nZhPg8QALL+RiFq/mZxZu/+hqFwf/7IVCKv/tj1EH/+yFQm7/6GoXC6/mZxYv5GIW
4OUAB2/mZxVa/+hqFxf/6nw0/++YX//ztIv/99C2//rj00H/F//649P/99C2//O0i//vmF//
6nw0Wv/oahcHb+ZnFdkACx/mYwjP5mkVTv/oahcT/+lzJf/vmF//9seo//zs4mn/E//87OL/
9seo/++YX//pcyVO/+hqFwvP5mkVH+ZjCM0ACz/nZRDv5mkVRv/oahcP/+p8NP/woW7/+dnF
if8P//nZxf/woW7/6nw0Rv/oahcL7+ZpFT/nZRDFAAd/52gURv/oahcL/+2PUf/2x6ih/wv/
9seo/+2PUUb/6GoXB3/naBS5AAsP3VUAz+ZpFUL/6GoXC//vmF///Ozisf8L//zs4v/vmF9C
/+hqFwvP5mkVD91VAK0ACw/dVQDP5mkVPv/oahcL/++YX//87OLB/wv//Ozi/++YXz7/6GoX
C8/maRUP3VUApQALL+RiFu/maRU6/+hqFwv/7IVC//rj09H/C//649P/7IVCOv/oahcL7+Zp
FS/kYhadAAsv5GIW7+ZpFTb/6GoXC//pcyX/99C24OH/C//30Lb/6XMlNv/oahcL7+ZpFS/k
YhaVAAsf5mMI7+ZpFTb/6GoXC//woW7//Ozi4On/C//87OL/8KFuNv/oahcL7+ZpFR/mYwiN
AAsP3VUAz+ZpFTb/6GoXB//2x6hZ/xP/+uPT//bHqP/ztIv/8KFuKv/tj1ET//Chbv/ztIv/
9seo//rj01n/B//2x6g2/+hqFwvP5mkVD91VAIUACw/dVQDP5mkVMv/oahcL/+p8NP/649NJ
/xP//fXw//bHqP/woW7/7IVCUv/oahcT/+yFQv/woW7/9seo//318En/C//649P/6nw0Mv/o
ahcLz+ZpFQ/dVQB9AAsP3VUAz+ZpFTL/6GoXB//woW5F/w///fXw//bHqP/tj1Fy/+hqFw//
7Y9R//bHqP/99fBF/wf/8KFuMv/oahcLz+ZpFQ/dVQB5AAef52gVMv/oahcH//ChbkH/D//8
7OL/8qt8/+lzJYL/6GoXD//pcyX/8qt8//zs4kH/B//woW4y/+hqFwef52gVdQAHn+doFTL/
6GoXB//2x6g9/wv/+uPT/++YX5r/6GoXC//vmF//+uPTPf8H//bHqDL/6GoXB5/naBVtAAdf
52YTMv/oahcH//bHqDn/C//87OL/7Y9Rqv/oahcL/+2PUf/87OI5/wf/9seoMv/oahcHX+dm
E2UACy/kYhbv5mkVLv/oahcH//O0izX/D//99fD/8qt8/+lzJbL/6GoXD//pcyX/8qt8//31
8DX/B//ztIsu/+hqFwvv5mkVL+RiFl0ACw/dVQDf5WgXLv/oahcH//ChbjX/C//649P/7IVC
wv/oahcL/+yFQv/649M1/wf/8KFuLv/oahcL3+VoFw/dVQBZAAef52gVLv/oahcH//ChbjX/
B//yq3zS/+hqFwf/8qt8Nf8H//Chbi7/6GoXB5/naBVVAAdP5WoXLv/oahcH/++YXzH/C//9
9fD/7Y9RWv/oahcH/+yFQib/7Y9RWv/oahcL/+2PUf/99fAx/wf/75hfLv/oahcHT+VqF00A
Cw/dVQDv5mkVKv/oahcL/+yFQv/99fAt/wv//fXw/+yFQkr/6GoXE//tj1H/87SL//fQtv/8
7OIx/xf//Ozi//nZxf/ztIv/75hf/+lzJUb/6GoXC//shUL//fXwLf8L//318P/shUIq/+hq
Fwvv5mkVD91VAEkAB6/mZxYq/+hqFwv/6XMl//zs4i3/C//649P/6XMlQv/oahcL//Chbv/2
x6hV/w///fXw//fQtv/woW5C/+hqFwv/6XMl//rj0y3/C//87OL/6XMlKv/oahcHr+ZnFkUA
Bz/nZRAu/+hqFwf/+dnFLf8L//rj0//pcyU6/+hqFw//6nw0//O0i//99fBp/w///fXw//O0
i//qfDQ6/+hqFwv/6XMl//rj0y3/B//52cUu/+hqFwc/52UQQQAH3+VoFyr/6GoXB//ztIst
/wv//fXw/+p8NDb/6GoXD//pcyX/87SL//318H3/C//30Lb/6nw0Nv/oahcL/+p8NP/99fAt
/wf/87SLKv/oahcH3+VoFz0AB3/naBQq/+hqFwf/7IVCLf8L//318P/shUI2/+hqFwv/75hf
//318In/D//99fD/87SL/+lzJTL/6GoXC//shUL//fXwLf8H/+yFQir/6GoXB3/naBQ1AAsP
3VUA7+ZpFSb/6GoXC//pcyX/+uPTKf8L//318P/shUIy/+hqFwv/6nw0//nZxZn/C//649P/
7IVCMv/oahcL/+yFQv/99fAp/wv/+uPT/+lzJSb/6GoXC+/maRUP3VUAMQAHf+doFCr/6GoX
B//ztIst/wf/75hfMv/oahcL/++YX//99fCh/wv//fXw//S9mTL/6GoXB//vmF8t/wf/87SL
Kv/oahcHf+doFC0ACw/dVQDv5mkVJv/oahcH/+p8NC3/B//yq3wy/+hqFwf/8KFusf8L//bH
qP/pcyUu/+hqFwf/8qt8Lf8H/+p8NCb/6GoXC+/maRUP3VUAKQAHf+doFCr/6GoXB//52cUp
/wf/9seoMv/oahcH//bHqLn/C//649P/6XMlLv/oahcH//bHqCn/B//52cUq/+hqFwd/52gU
KQAH3+VoFyb/6GoXB//tj1Ep/wv//Ozi/+lzJS7/6GoXB//2x6hF/w//+uPT//bHqP/yq3wi
/+2PUQ//8qt8//bHqP/649NF/wf/+uPTLv/oahcL/+lzJf/87OIp/wf/7Y9RJv/oahcH3+Vo
FyUAB1/nZhMq/+hqFwf/+dnFKf8H/+2PUS7/6GoXB//woW49/w//9seo//Chbv/pcyU6/+hq
Fw//6XMl//Chbv/2x6g9/wf/9seoLv/oahcH/+2PUSn/B//52cUq/+hqFwdf52YTIQAHv+Vo
Fyb/6GoXB//tj1Ep/wf/9L2ZLv/oahcH//ChbjX/D//99fD/87SL/+lzJVL/6GoXD//pcyX/
87SL//318DX/B//2x6gu/+hqFwf/9L2ZKf8H/+2PUSb/6GoXB7/laBcdAAcf5mMIKv/oahcH
//nZxSX/C//87OL/6XMlKv/oahcH//ChbjX/C//2x6j/6XMlYv/oahcL/+lzJf/2x6g1/wf/
8qt8Kv/oahcL/+lzJf/87OIl/wf/+dnFKv/oahcHH+ZjCBkAB3/naBQm/+hqFwf/7Y9RKf8H
//Chbir/6GoXC//shUL//fXwLf8L//zs4v/shUJy/+hqFwv/7IVC//zs4jH/B//tj1Eq/+hq
Fwf/8KFuKf8H/+2PUSb/6GoXB3/naBQZAAff5WgXJv/oahcH//fQtiX/B//52cUq/+hqFwv/
6XMl//rj0y3/B//0vZmC/+hqFwf/9L2ZLf8L//318P/pcyUq/+hqFwf/+dnFJf8H//fQtib/
6GoXB9/laBcVAAcf5mMIJv/oahcH/+p8NCn/B//tj1Eq/+hqFwf/9seoLf8H//Chbor/6GoX
B//woW4t/wf/+dnFKv/oahcH/+2PUSn/B//qfDQm/+hqFwcf5mMIEQAHb+ZnFSb/6GoXB//w
oW4l/wf//OziKv/oahcH/+2PUS3/B//ztIuS/+hqFwf/87SLLf8H/++YXyr/6GoXB//87OIl
/wf/8KFuJv/oahcHb+ZnFREAB7/laBcm/+hqFwf/+uPTJf8H//Chbib/6GoXC//pcyX//Ozi
Kf8H//bHqJr/6GoXB//2x6gp/wv//fXw/+lzJSb/6GoXB//woW4l/wf/+uPTJv/oahcHv+Vo
FxEAJv/oahcH/+p8NCX/C//99fD/6XMlJv/oahcH//O0iyn/B//52cVC/+hqFwf/6nw0Gv/t
j1EH/+p8NEL/6GoXB//52cUp/wf/9L2ZJv/oahcL/+lzJf/99fAl/wf/6nw0Jv/oahcNAAc/
52UQJv/oahcH//KrfCX/B//2x6gm/+hqFwv/6XMl//318CX/C//99fD/6XMlNv/oahcP/+yF
Qv/2x6j//OziIf8P//zs4v/2x6j/7IVCNv/oahcL/+lzJf/99fAp/wf/6XMlJv/oahcH//bH
qCX/B//yq3wm/+hqFwc/52UQCQAHf+doFCb/6GoXB//30LYl/wf/7IVCJv/oahcH//O0iyn/
B//tj1Ey/+hqFwv/75hf//nZxTn/C//52cX/75hfMv/oahcH/+2PUSn/B//ztIsm/+hqFwf/
7IVCJf8H//fQtib/6GoXB3/naBQJAAe/5WgXJv/oahcH//318CH/B//99fAq/+hqFwf//fXw
Jf8H//fQti7/6GoXC//pcyX/99C2Sf8L//fQtv/pcyUu/+hqFwf/99C2Jf8H//318Cr/6GoX
B//99fAh/wf//fXwJv/oahcHv+VoFwkAB+/maRUi/+hqFwf/7IVCJf8H//bHqCb/6GoXB//w
oW4p/wf/6nw0Kv/oahcL/+yFQv/99fBR/wv//fXw/+yFQir/6GoXB//qfDQp/wf/8KFuJv/o
ahcH//bHqCX/B//shUIi/+hqFw/v5mkVAAAAAA/dVQAm/+hqFwf/8qt8Jf8H//Chbib/6GoX
B//30LYl/wf/9seoKv/oahcL/+lzJf/87OJZ/wv//Ozi/+lzJSr/6GoXB//2x6gl/wf/99C2
Jv/oahcH//ChbiX/B//yq3wm/+hqFwsP3VUAP+dlECb/6GoXB//0vZkl/wf/6nw0Iv/oahcH
/+lzJSn/B//pcyUq/+hqFwf/+uPTYf8H//rj0yr/6GoXB//pcyUp/yb/6GoXB//qfDQl/wf/
9L2ZJv/oahcLP+dlEG/mZxUm/+hqFwf/+dnFIf8H//zs4ib/6GoXB//vmF8l/wf/9seoKv/o
ahcH//S9mWn/B//0vZkq/+hqFwf/9seoJf8H/++YXyb/6GoXB//87OIh/wf/+dnFJv/oahcL
b+ZnFX/naBQm/+hqFwf//fXwIf8H//nZxSb/6GoXB//0vZkl/wf/75hfJv/oahcH/+yFQnH/
B//tj1Em/+hqFwf/75hfJf8H//S9mSb/6GoXB//52cUh/wf//fXwJv/oahcLf+doFK/mZxYm
/+hqFyX/B//ztIsm/+hqFwf/+dnFJf8q/+hqFwf/+dnFcf8H//nZxSr/6GoXJf8H//nZxSb/
6GoXB//ztIsl/yb/6GoXC6/mZxa/5WgXIv/oahcH/+2PUSX/B//woW4m/+hqFyX/B//52cUm
/+hqFwf/7Y9RLf8L//rj0//woW4S/+2PUQv/8KFu//rj0y3/B//vmF8m/+hqFwf/+dnFJf8m
/+hqFwf/8KFuJf8H/+2PUSL/6GoXCr/laBci/+hqFwf/7Y9RJf8H/+2PUSL/6GoXB//qfDQl
/wf/87SLJv/oahcH//bHqCn/B//yq3wi/+hqFwf/8qt8Kf8H//fQtib/6GoXB//ztIsl/wf/
7IVCIv/oahcH/+2PUSX/B//tj1Ei/+hqFwe/5WgXJv/oahcH//ChbiX/B//tj1Ei/+hqFwf/
7Y9RJf8H/++YXyb/6GoXB//99fAl/wf/9seoKv/oahcH//rj0yX/B//99fAm/+hqFwf/75hf
Jf8H/+2PUSL/6GoXB//tj1El/wf/8KFuSv/oahcH//O0iyX/Jv/oahcH//KrfCX/B//shUIi
/+hqFwf/7IVCJf8H//zs4i7/6GoXC//pcyX//fXwJf8H/+yFQiL/6GoXB//shUIl/wf/8KFu
Jv/oahcl/wf/87SLSv/oahcH//O0iyX/Jv/oahcH//O0iyX/Jv/oahcH//ChbiX/B//woW4y
/+hqFwf/87SLJf8H//Chbib/6GoXJf8H//O0iyb/6GoXJf8H//O0i0r/6GoXB//ztIsl/yb/
6GoXB//ztIsl/yb/6GoXB//ztIsl/wf/6nw0Mv/oahcH/+p8NCX/B//ztIsm/+hqFyX/B//z
tIsm/+hqFyX/B//ztItK/+hqFwf/87SLJf8m/+hqFwf/87SLJf8m/+hqFwf/87SLJf86/+hq
FyX/B//ztIsm/+hqFyX/B//ztIsm/+hqFyX/B//ztItK/+hqFwf/87SLJf8m/+hqFwf/87SL
Jf8m/+hqFwf/87SLJf86/+hqFyX/B//ztIsm/+hqFyX/B//ztIsm/+hqFyX/B//ztItK/+hq
Fwf/87SLJf8m/+hqFwf/87SLJf8m/+hqFwf/87SLJf8H/+p8NDL/6GoXB//qfDQl/wf/87SL
Jv/oahcl/wf/87SLJv/oahcl/wf/87SLSv/oahcH//O0iyX/Jv/oahcH//O0iyX/B//pcyUi
/+hqFwf/75hfJf8H//ChbjL/6GoXB//yq3wl/wf/75hfIv/oahcH/+lzJSX/B//ztIsm/+hq
FyX/B//ztItK/+hqFwf/87SLJf8H/+lzJSL/6GoXB//vmF8l/wf/7Y9RIv/oahcH/+yFQiX/
B//649My/+hqFwf//OziJf8H/+yFQiL/6GoXB//tj1El/wf/75hfIv/oahcH/+lzJSX/B//z
tIsm/+hqFwff5WgXIv/oahcH/+2PUSX/B//tj1Ei/+hqFwf/7Y9RJf8H/++YXyb/6GoXB//9
9fAl/wf/8qt8Kv/oahcH//bHqCX/B//99fAm/+hqFwf/75hfJf8H/+2PUSL/6GoXB//tj1El
/wf/7Y9RIv/oahcL3+VoF7/laBci/+hqFwf/7Y9RJf8H/+2PUSL/6GoXB//qfDQl/wf/87SL
Jv/oahcH//bHqCn/C//ztIv/6XMlGv/oahcL/+lzJf/ztIsp/wf/9seoJv/oahcH//O0iyX/
B//qfDQi/+hqFwf/7Y9RJf8H/+2PUSL/6GoXCr/laBci/+hqFwf/7IVCJf8H//KrfCb/6GoX
Jf8H//nZxSb/6GoXB//vmF8t/wv/+uPT/++YXxL/6GoXC//vmF//+uPTLf8H/++YXyb/6GoX
B//52cUl/yb/6GoXB//yq3wl/wf/7IVCIv/oahcLv+VoF5/naBUm/+hqFyX/B//ztIsm/+hq
Fwf/+dnFJf8q/+hqFwf//Ozicf8H//nZxSr/6GoXJf8H//nZxSb/6GoXB//ztIsl/yb/6GoX
C5/naBV/52gUJv/oahcH//318CH/B//52cUm/+hqFwf/9L2ZJf8H/++YXyb/6GoXB//vmF9x
/wf/7Y9RJv/oahcH/++YXyX/B//0vZkm/+hqFwf/+dnFIf8H//318Cb/6GoXC3/naBRf52YT
Jv/oahcH//nZxSH/B//99fAm/+hqFwf/8KFuJf8H//bHqCr/6GoXB//30LZp/wf/9L2ZKv/o
ahcH//fQtiX/B//vmF8m/+hqFwf//fXwIf8H//nZxSb/6GoXC1/nZhM/52UQJv/oahcH//S9
mSX/B//qfDQi/+hqFwf/6XMlKf8H/+lzJSb/6GoXC//pcyX//OziYf8L//nZxf/pcyUm/+hq
Fwf/6nw0Kf8H/+lzJSL/6GoXB//qfDQl/wf/9L2ZJv/oahcLP+dlEA/dVQAm/+hqFwf/8qt8
Jf8H//Chbib/6GoXB//649Ml/wf/87SLKv/oahcL/+yFQv/99fBZ/wv/+uPT/+lzJSr/6GoX
B//2x6gl/wf/99C2Jv/oahcH//ChbiX/B//yq3wm/+hqFw8P3VUAAAAAAO/maRUi/+hqFwf/
7IVCJf8H//bHqCb/6GoXB//yq3wl/wv//fXw/+lzJSr/6GoXC//shUL/+uPTUf8L//bHqP/p
cyUq/+hqFwf/6nw0Kf8H//Chbib/6GoXB//2x6gl/wf/7IVCIv/oahcH7+ZpFQkAB7/laBcm
/+hqFwf//fXwIf8H//318Cb/6GoXB//pcyUp/wf/9seoLv/oahcL/+lzJf/2x6hJ/wf/9seo
Mv/oahcH//fQtiX/B//99fAq/+hqFwf//fXwIf8H//318Cb/6GoXB7/laBcJAAd/52gUJv/o
ahcH//fQtiX/B//shUIm/+hqFwf/9seoKf8H/+2PUTL/6GoXC//yq3z//OziOf8L//rj0//s
hUIy/+hqFwf/7Y9RKf8H//O0iyb/6GoXB//shUIl/wf/99C2Jv/oahcHf+doFAkABz/nZRAm
/+hqFwf/8qt8Jf8H//bHqCb/6GoXB//qfDQp/wv//Ozi/+lzJTL/6GoXD//pcyX/8KFu//rj
0yn/C//52cX/7Y9RNv/oahcL/+lzJf/99fAp/wf/6nw0Jv/oahcH//bHqCX/B//yq3wm/+hq
Fwc/52UQDQAm/+hqFwf/6nw0Jf8L//318P/pcyUm/+hqFwf/9seoKf8H//rj0z7/6GoXC//p
cyX/75hfGv/ztIsL//Chbv/qfDQ+/+hqFwf/+uPTKf8H//S9mSb/6GoXC//pcyX//fXwJf8H
/+p8NCb/6GoXEQAHv+VoFyb/6GoXB//649Ml/wf/8KFuJv/oahcH/+p8NC3/B//2x6ia/+hq
Fwf/9seoKf8L//318P/pcyUm/+hqFwf/8KFuJf8H//rj0yb/6GoXB7/laBcRAAdv5mcVJv/o
ahcH//KrfCX/B//87OIq/+hqFwf/87SLLf8L//bHqP/pcyWO/+hqFwf/99C2Lf8H//Chbir/
6GoXB//87OIl/wf/8qt8Jv/oahcHb+ZnFREABy/kYhYm/+hqFwf/6XMlKf8H/+2PUSb/6GoX
C//pcyX/+uPTLf8L//rj0//pcyWC/+hqFwv/6XMl//rj0y3/B//52cUq/+hqFwf/7Y9RKf8H
/+lzJSb/6GoXBy/kYhYVAAff5WgXJv/oahcH//nZxSX/B//52cUq/+hqFwf/7Y9RMf8L//rj
0//pcyV6/+hqFwv/7IVC//rj0y3/C//99fD/6XMlKv/oahcH//nZxSX/B//52cUm/+hqFwff
5WgXGQAHj+ZnFCb/6GoXB//vmF8p/wf/8KFuKv/oahcH//O0izH/C//99fD/8KFucv/oahcL
//Chbv/99fAx/wf/7Y9RKv/oahcH//Chbin/B//vmF8m/+hqFweP5mcUGQAHL+RiFir/6GoX
B//87OIl/wf//OziLv/oahcH//bHqDX/C//30Lb/6XMlYv/oahcL/+p8NP/30LY1/wf/8qt8
Lv/oahcH//zs4iX/B//87OIq/+hqFwcv5GIWHQAHz+ZpFSb/6GoXB//woW4p/wf/87SLKv/o
ahcL/+lzJf/52cU5/wv/87SL/+p8NFL/6GoXD//pcyX/87SL//318DX/B//2x6gu/+hqFwf/
87SLKf8H//Chbib/6GoXB8/maRUhAAdf52YTKv/oahcH//zs4in/B//shUIq/+hqFwv/6XMl
//rj0z3/C//0vZn/7Y9RQv/oahcP/+yFQv/2x6j//fXwOf8H//bHqC7/6GoXB//shUIp/wf/
/OziKv/oahcHX+dmEyEACw/dVQDv5mkVJv/oahcH//Chbin/B//649Mu/+hqFwv/6XMl//fQ
tkH/E//87OL/9L2Z/++YX//qfDQi/+hqFxP/7IVC//Chbv/0vZn//fXwQf8H//S9mTL/6GoX
B//649Mp/wf/8KFuJv/oahcL7+ZpFQ/dVQAlAAd/52gUKv/oahcH//rj0yn/B//0vZky/+hq
Fwf/9seouf8H//ChbjL/6GoXB//0vZkp/wf/+uPTKv/oahcHf+doFCkABx/mYwgq/+hqFwf/
7Y9RLf8H//ChbjL/6GoXB//2x6ix/wf/8KFuMv/oahcH//Chbi3/B//tj1Eq/+hqFwcf5mMI
LQAHn+doFSr/6GoXB//2x6gp/wv//fXw/+yFQjL/6GoXC//vmF///fXwof8L//rj0//vmF8y
/+hqFwv/7IVC//318Cn/B//2x6gq/+hqFwef52gVMQALD91VAO/maRUm/+hqFwv/6XMl//31
8Cn/C//99fD/6XMlMv/oahcL/+p8NP/649OZ/wv/99C2/+lzJTL/6GoXC//pcyX//fXwKf8L
//318P/pcyUm/+hqFwvv5mkVD91VADUAB3/naBQq/+hqFwf/75hfLf8L//rj0//pcyU2/+hq
Fwv/87SL//318In/C//99fD/8KFuNv/oahcL/+lzJf/649Mt/wf/75hfKv/oahcHf+doFDkA
Cw/dVQDv5mkVKv/oahcH//bHqC3/C//649P/6XMlNv/oahcL/+p8NP/30LZ9/w///fXw//bH
qP/pcyU2/+hqFwv/6XMl//rj0y3/B//2x6gq/+hqFwvv5mkVD91VAD0AB1/nZhMq/+hqFwv/
6XMl//rj0y3/C//87OL/7IVCOv/oahcL/+yFQv/2x6ht/w///fXw//S9mf/qfDQ6/+hqFwv/
7IVC//zs4i3/C//649P/6XMlKv/oahcHX+dmE0UAB8/maRUq/+hqFwv/7IVC//318C3/C//9
9fD/7IVCPv/oahcP/+p8NP/ztIv//OziWf8P//rj0//woW7/6nw0Pv/oahcL/+yFQv/99fAt
/wv//fXw/+yFQir/6GoXB8/maRVJAAcf5mMILv/oahcH/++YXzH/C//99fD/7IVCRv/oahcT
/+yFQv/yq3z/+dnF//318Dn/E//99fD/99C2//KrfP/shUJG/+hqFwv/7IVC//318DH/B//v
mF8u/+hqFwcf5mMITQAHf+doFC7/6GoXB//yq3wx/wv//fXw/++YX1L/6GoXC//shUL/75hf
Kv/ztIsL/++YX//qfDRS/+hqFwv/75hf//318DH/B//yq3wu/+hqFwd/52gUVQAHz+ZpFS7/
6GoXB//0vZk1/wv/8qt8/+lzJcr/6GoXC//pcyX/8qt8Nf8H//S9mS7/6GoXB8/maRVZAAsf
5mMI7+ZpFS7/6GoXB//2x6g1/wv/+uPT/+yFQsL/6GoXC//shUL/+uPTNf8H//bHqC7/6GoX
C+/maRUf5mMIXQAHT+VqFzL/6GoXB//2x6g1/wv//fXw//KrfLr/6GoXC//yq3z//fXwNf8H
//bHqDL/6GoXB0/lahdlAAeP5mcUMv/oahcH//Chbjn/C//649P/7IVCqv/oahcL/+yFQv/6
49M5/wf/8KFuMv/oahcHj+ZnFG0AB6/mZxYy/+hqFwf/8KFuPf8L//nZxf/qfDSa/+hqFwv/
6nw0//nZxT3/B//woW4y/+hqFwev5mcWcQALD91VAM/maRUy/+hqFwf/8KFuQf8L//nZxf/v
mF+K/+hqFwv/75hf//nZxUH/B//woW4y/+hqFwvP5mkVD91VAHUACw/dVQDf5WgXMv/oahcL
/++YX//87OJB/w///Ozi//O0i//qfDRy/+hqFw//6nw0//O0i//87OJB/wv//Ozi/++YXzL/
6GoXC9/laBcP3VUAfQALL+RiFu/maRUy/+hqFwv/6XMl//rj00n/D//649P/87SL/+yFQlr/
6GoXD//shUL/87SL//rj00n/C//649P/6XMlMv/oahcL7+ZpFS/kYhaFAAsv5GIW7+ZpFTb/
6GoXB//2x6hR/xf//fXw//nZxf/ztIv/8KFu/+2PUTL/6GoXF//tj1H/8KFu//O0i//52cX/
/fXwUf8H//bHqDb/6GoXC+/maRUv5GIWjQALL+RiFt/laBc2/+hqFwv/75hf//zs4uDp/wv/
/Ozi/++YXzb/6GoXC9/laBcv5GIWlQALD91VAM/maRU2/+hqFwv/6XMl//fQtuDh/wv/99C2
/+lzJTb/6GoXC8/maRUP3VUAnQALD91VAM/maRU6/+hqFwv/7IVC//rj09H/C//649P/7IVC
Ov/oahcLz+ZpFQ/dVQClAAsP3VUAz+ZpFT7/6GoXC//woW7//fXwwf8L//318P/woW4+/+hq
FwvP5mkVD91VAK0ACw/dVQCf52gVPv/oahcP/+lzJf/woW7//fXwsf8P//318P/woW7/6XMl
Pv/oahcLn+doFQ/dVQC5AAdf52YTRv/oahcL//Chbv/649Oh/wv/+uPT//Chbkb/6GoXB1/n
ZhPFAAs/52UQ7+ZpFUb/6GoXD//shUL/9seo//zs4on/D//87OL/9seo/+yFQkb/6GoXC+/m
aRU/52UQzQALH+ZjCL/laBdO/+hqFw//7Y9R//S9mf/87OJx/w///Ozi//S9mf/tj1FO/+hq
Fwu/5WgXH+ZjCNkAB2/mZxVW/+hqFxP/6nw0//Chbv/0vZn/+dnFUf8T//nZxf/0vZn/8KFu
/+p8NFb/6GoXB2/mZxXg5QALL+RiFq/mZxZi/+hqFw//6XMl/+2PUf/woW4y//O0iw//8KFu
/+2PUf/pcyVi/+hqFwuv5mcWL+RiFuDxAAtv5mcV3+VoF+D6/+hqFwvf5WgXb+ZnFeD9AAsP
3VUAj+ZnFODy/+hqFwuP5mcUD91VAOEJAA8P3VUAn+doFe/maRXa/+hqFw/v5mkVn+doFQ/d
VQDhGQAPH+ZjCJ/naBXv5mkVyv/oahcP7+ZpFZ/naBUf5mMI4SkADw/dVQBv5mcV3+VoF7r/
6GoXD9/laBdv5mcVD91VAOE9AAs/52UQn+doFar/6GoXC5/naBU/52UQ4VUAD0/lahef52gV
3+VoF4r/6GoXD9/laBef52gVT+VqF+FtABMv5GIWX+dmE5/naBXf5WgXav/oahcT3+VoF5/n
aBVf52YTL+RiFuGJABMP3VUAP+dlEG/mZxV/52gUCr/laBc6/+hqFwq/5WgXE3/naBRv5mcV
P+dlEA/dVQDNAA==' base64Decoded asByteArray)! !

!BouncingBall methodsFor: 'as yet unclassified' stamp: 'spfa 11/26/2017 17:47'!
topContact

	^ self arena submorphs detect: [:m |
		({self . self valueOfProperty: #lastContact} identityIncludes: m) not
			and: [self hasTopContactWith: m]] ifNone: [nil]! !

!DiffusingPolygon methodsFor: 'as yet unclassified' stamp: 'spfa 11/26/2017 01:12'!
vertices

	^ "vertices" nil ifNil: [self computeVertices]! !

!BreakOutTile class methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 18:15'!
violet

	^ self new form: self violetTile! !

!BBSprite class methodsFor: 'forms library' stamp: 'spfa 3/7/2017 18:00'!
violetTile

	^ Form new readResourceFrom: 
		(ReadStream on: 
			'Rk9STQAAAEAAAAAgAAAAIAAAAunoAAs/WTxlr1c6ZODy/1g9ZQ+vVzpkP1k8Zc9XPGXg+v9Y
PWUHz1c8ZQr/WD1lB/+OaJ/g6v+bdawH/45onxL/WD1lC/95U4r/jmif4OL/m3WsC/+OaJ//
eVOKEv9YPWUK/3lTigf/jmif2v+bdawH/45onwr/eVOKEv9YPWUO/3lTigf/jmif0v+bdawH
/45onw7/eVOKEv9YPWUS/3lTigf/jmifyv+bdawH/45onxL/eVOKEv9YPWUW/3lTigf/jmif
wv+bdawH/45onxb/eVOKEv9YPWUa/3lTisL/g1mVGv95U4oS/1g9ZRr/eVOKwv+DWZUa/3lT
ihL/WD1lGv95U4rC/4NZlRr/eVOKEv9YPWUa/3lTisL/g1mVGv95U4oS/1g9ZRr/eVOKwv+D
WZUa/3lTihL/WD1lGv95U4rC/4NZlRr/eVOKEv9YPWUa/3lTisL/g1mVGv95U4oS/1g9ZRr/
eVOKwv+DWZUa/3lTihL/WD1lGv95U4rC/4NZlRr/eVOKEv9YPWUa/3lTisL/g1mVGv95U4oS
/1g9ZRr/eVOKwv+DWZUa/3lTihL/WD1lGv95U4rC/4NZlRr/eVOKEv9YPWUa/3lTisL/g1mV
Gv95U4oS/1g9ZRr/eVOKwv+DWZUa/3lTihL/WD1lGv95U4rC/4NZlRr/eVOKEv9YPWUa/3lT
isL/g1mVGv95U4oS/1g9ZRb/eVOKB/9wTYDC/2JDcAf/cE2AFv95U4oS/1g9ZRL/eVOKB/9w
TYDK/2JDcAf/cE2AEv95U4oS/1g9ZQ7/eVOKB/9wTYDS/2JDcAf/cE2ADv95U4oS/1g9ZQr/
eVOKB/9wTYDa/2JDcAf/cE2ACv95U4oS/1g9ZQv/eVOK/3BNgODi/2JDcAv/cE2A/3lTihL/
WD1lB/9wTYDg6v9iQ3AH/3BNgAr/WD1lB99YO2Pg+v9YPWUP31g7Y29XO2XvVzpk4PL/WD1l
C+9XOmRvVztl' base64Decoded asByteArray)! !

!BreakOutTile class methodsFor: 'as yet unclassified' stamp: 'spfa 3/7/2017 18:15'!
yellow

	^ self new form: self yellowTile! !

!BBSprite class methodsFor: 'forms library' stamp: 'spfa 3/7/2017 18:03'!
yellowDiamond

	^ Form new readResourceFrom: 
		(ReadStream on: 
			'Rk9STQAAADAAAAAwAAAAIAAACWnpAFkAB0+nhAAKr6aEAQdPp4QArQAHX6aDAhL/p4UDB1+m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=' base64Decoded asByteArray)! !

!BBSprite class methodsFor: 'forms library' stamp: 'spfa 3/7/2017 18:03'!
yellowPentagon

	^ Form new readResourceFrom: 
		(ReadStream on: 
			'Rk9STQAAADAAAAAuAAAAIAAACcDooFkAEy+oggCfpoUBv6WEAT+lhQCtAAdvp4UCEv+nhQMH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' base64Decoded asByteArray)! !

!BBSprite class methodsFor: 'forms library' stamp: 'spfa 3/7/2017 18:11'!
yellowSquare

	^ Form new readResourceFrom: 
		(ReadStream on: 
			'Rk9STQAAACAAAAAgAAAAIAAAAuHkAAs/pYUAr6aEAXL/p4UDD6+mhAE/pYUAz6aFAnr/p4UD
B8+mhQIK/6eFAwf/880xav/+204H//PNMRL/p4UDC//jtgL/880xYv/+204L//PNMf/jtgIS
/6eFAwr/47YCB//zzTFa//7bTgf/880xCv/jtgIS/6eFAw7/47YCB//zzTFS//7bTgf/880x
Dv/jtgIS/6eFAxL/47YCB//zzTFK//7bTgf/880xEv/jtgIS/6eFAxb/47YCB//zzTFC//7b
Tgf/880xFv/jtgIS/6eFAxr/47YCQv//zAAa/+O2AhL/p4UDGv/jtgJC///MABr/47YCEv+n
hQMa/+O2AkL//8wAGv/jtgIS/6eFAxr/47YCQv//zAAa/+O2AhL/p4UDGv/jtgJC///MABr/
47YCEv+nhQMa/+O2AkL//8wAGv/jtgIS/6eFAxr/47YCQv//zAAa/+O2AhL/p4UDGv/jtgJC
///MABr/47YCEv+nhQMa/+O2AkL//8wAGv/jtgIS/6eFAxr/47YCQv//zAAa/+O2AhL/p4UD
Gv/jtgJC///MABr/47YCEv+nhQMa/+O2AkL//8wAGv/jtgIS/6eFAxr/47YCQv//zAAa/+O2
AhL/p4UDGv/jtgJC///MABr/47YCEv+nhQMa/+O2AkL//8wAGv/jtgIS/6eFAxr/47YCQv//
zAAa/+O2AhL/p4UDFv/jtgIH/9muAkL/yqICB//ZrgIW/+O2AhL/p4UDEv/jtgIH/9muAkr/
yqICB//ZrgIS/+O2AhL/p4UDDv/jtgIH/9muAlL/yqICB//ZrgIO/+O2AhL/p4UDCv/jtgIH
/9muAlr/yqICB//ZrgIK/+O2AhL/p4UDC//jtgL/2a4CYv/KogIL/9muAv/jtgIS/6eFAwf/
2a4Cav/KogIH/9muAgr/p4UDB9+kgwJ6/6eFAw/fpIMCb6eFAu+mhAJy/6eFAwvvpoQCb6eF
Ag==' base64Decoded asByteArray)! !

!BBSprite class methodsFor: 'forms library' stamp: 'spfa 3/7/2017 18:01'!
yellowTile

	^ Form new readResourceFrom: 
		(ReadStream on: 
			'Rk9STQAAAEAAAAAgAAAAIAAAAunoAAs/pYUAr6aEAeDy/6eFAw+vpoQBP6WFAM+mhQLg+v+n
hQMHz6aFAgr/p4UDB//zzTHg6v/+204H//PNMRL/p4UDC//jtgL/880x4OL//ttOC//zzTH/
47YCEv+nhQMK/+O2Agf/880x2v/+204H//PNMQr/47YCEv+nhQMO/+O2Agf/880x0v/+204H
//PNMQ7/47YCEv+nhQMS/+O2Agf/880xyv/+204H//PNMRL/47YCEv+nhQMW/+O2Agf/880x
wv/+204H//PNMRb/47YCEv+nhQMa/+O2AsL//8wAGv/jtgIS/6eFAxr/47YCwv//zAAa/+O2
AhL/p4UDGv/jtgLC///MABr/47YCEv+nhQMa/+O2AsL//8wAGv/jtgIS/6eFAxr/47YCwv//
zAAa/+O2AhL/p4UDGv/jtgLC///MABr/47YCEv+nhQMa/+O2AsL//8wAGv/jtgIS/6eFAxr/
47YCwv//zAAa/+O2AhL/p4UDGv/jtgLC///MABr/47YCEv+nhQMa/+O2AsL//8wAGv/jtgIS
/6eFAxr/47YCwv//zAAa/+O2AhL/p4UDGv/jtgLC///MABr/47YCEv+nhQMa/+O2AsL//8wA
Gv/jtgIS/6eFAxr/47YCwv//zAAa/+O2AhL/p4UDGv/jtgLC///MABr/47YCEv+nhQMa/+O2
AsL//8wAGv/jtgIS/6eFAxb/47YCB//ZrgLC/8qiAgf/2a4CFv/jtgIS/6eFAxL/47YCB//Z
rgLK/8qiAgf/2a4CEv/jtgIS/6eFAw7/47YCB//ZrgLS/8qiAgf/2a4CDv/jtgIS/6eFAwr/
47YCB//ZrgLa/8qiAgf/2a4CCv/jtgIS/6eFAwv/47YC/9muAuDi/8qiAgv/2a4C/+O2AhL/
p4UDB//ZrgLg6v/KogIH/9muAgr/p4UDB9+kgwLg+v+nhQMP36SDAm+nhQLvpoQC4PL/p4UD
C++mhAJvp4UC' base64Decoded asByteArray)! !
