


!MenuMorph methodsFor: '*People-spfa-fixes' stamp: 'spfa 2/3/2016 22:12'!
addFrontTo: aWorld

	| cp dy downItems lastVisibleItem itemsCache |

	dy := 10.

	downItems := self submorphs select: [:ea | ea bottom > World bottom].
	downItems ifEmpty: [^ aWorld addMorphFront: self].

	lastVisibleItem := (self submorphs identityIndexOf: downItems first) - 1.

	itemsCache := self submorphs.
	self removeAllMorphs.

	cp := self veryDeepCopy.
	cp thenAction: self thenAction.

	self addAllMorphs: (itemsCache copyFrom: 1 to: lastVisibleItem - 1).
	cp addAllMorphs: (itemsCache copyFrom: lastVisibleItem to: itemsCache size).

	self add: ' ' subMenu: cp.

	aWorld addMorphFront: self.
! !

!ProportionalSplitterMorph methodsFor: '*People-spfa-fixes' stamp: 'spfa 5/21/2018 15:43'!
balanceOffsets

	| fdx fdy |

	(self hasProperty: #fullDelta) ifFalse: [^ self].

	fdx := (self valueOfProperty: #fullDelta) x.
	fdy := (self valueOfProperty: #fullDelta) y.

	self layoutFrame hasFixedHeight ifTrue: [
		| otop obot ctop cbot topf |

		otop := (owner submorphs detect: [:m | 
					m layoutFrame topFraction isZero] ifNone: [^ self]) in: [:tm | 
						tm top - (tm layoutFrame topOffset ifNil: [0])].

		obot := (owner submorphs detect: [:m | 
					m layoutFrame bottomFraction = 1] ifNone: [^ self]) in: [:tm | 
						tm bottom - (tm layoutFrame bottomOffset ifNil: [0])].

		ctop := (self layoutFrame topFraction * (obot - otop)) rounded 
					+ otop + (self layoutFrame topOffset ifNil: [0]).
		cbot := (self layoutFrame bottomFraction * (obot - otop)) rounded 
					+ otop + (self layoutFrame bottomOffset ifNil: [0]).

		topf := self layoutFrame topFraction.
		self layoutFrame topFraction:  ((ctop + cbot) * 0.5 - otop) / (obot - otop) asFloat.
		self layoutFrame bottomFraction: self layoutFrame topFraction.
		self layoutFrame topOffset: self layoutFrame topOffset - fdy.
		self layoutFrame bottomOffset: self layoutFrame bottomOffset - fdy.

		(leftOrTop copy union: rightOrBottom) do: [:m |
			(m layoutFrame topFraction closeTo: topf) ifTrue: [
				m layoutFrame topFraction: self layoutFrame topFraction.
				m layoutFrame topOffset: m layoutFrame topOffset - fdy].
			(m layoutFrame bottomFraction closeTo: topf) ifTrue: [
				m layoutFrame bottomFraction: self layoutFrame topFraction.
				m layoutFrame bottomOffset: m layoutFrame bottomOffset - fdy]]] .

	self layoutFrame hasFixedWidth ifTrue: [
		| oleft oright cleft cright leftf |

		oleft := (owner submorphs detect: [:m | 
			m layoutFrame leftFraction isZero] ifNone: [^ self]) in: [:tm | 
				tm left - (tm layoutFrame leftOffset ifNil: [0])].

		oright := (owner submorphs detect: [:m | 
			m layoutFrame rightFraction = 1] ifNone: [^ self]) in: [:tm | 
				tm right - (tm layoutFrame rightOffset ifNil: [0])].

		cleft := (self layoutFrame leftFraction * (oright - oleft)) rounded 
					+ oleft + (self layoutFrame leftOffset ifNil: [0]).
		cright := (self layoutFrame rightFraction * (oright - oleft)) rounded 
					+ oleft + (self layoutFrame rightOffset ifNil: [0]).

		leftf := self layoutFrame leftFraction.
		self layoutFrame leftFraction: ((cleft + cright) * 0.5 - oleft) / (oright - oleft) asFloat.
		self layoutFrame rightFraction: self layoutFrame leftFraction.


		self layoutFrame leftOffset: self layoutFrame leftOffset - fdx.
		self layoutFrame rightOffset: self layoutFrame rightOffset - fdx.

		(leftOrTop copy union: rightOrBottom) do: [:m |
			(m layoutFrame leftFraction closeTo: leftf) ifTrue: [
				m layoutFrame leftFraction: self layoutFrame leftFraction.
				m layoutFrame leftOffset: m layoutFrame leftOffset - fdx].
			(m layoutFrame rightFraction closeTo: leftf) ifTrue: [
				m layoutFrame rightFraction: self layoutFrame leftFraction.
				m layoutFrame rightOffset: 	m layoutFrame rightOffset - fdx.]]] .
		
	self removeProperty: #fullDelta.
	owner layoutChanged
! !

!TextMorph methodsFor: '*People-spfa-fixes' stamp: 'spfa 7/22/2022 01:22'!
beAllFont: aFont

	textStyle := TextStyle fontArray: (Array with: aFont).
	text ifNotNil: [text addAttribute: (TextFontReference toFont: aFont)].
	self releaseCachedState; changed! !

!ObjectExplorer methodsFor: '*People-spfa-fixes' stamp: 'spfa 12/1/2016 14:09'!
browseClass

	^ self browseFull! !

!SimpleMIDIPort methodsFor: '*People-spfa-fixes' stamp: 'spfa 11/21/2013 11:25'!
bufferTimeStampFrom: aByteArray
	"Return the timestamp from the given MIDI input buffer. Assume the given buffer is at least 4 bytes long."


	^ ((aByteArray at: 4) bitShift: 24) +
	  ((aByteArray at: 3) bitShift: 16) +
	  ((aByteArray at: 2) bitShift: 8) +
	   (aByteArray at: 1)
! !

!Inspector methodsFor: '*People-spfa-fixes' stamp: 'spfa 7/2/2019 10:32'!
buildCodePaneWith: builder
	| textSpec |
	textSpec := builder pluggableCodePaneSpec new.
	textSpec 
		model: self;
		getText: #expression; 
		editText: #expression:;
		setText: #expression:; "else accidental alt-s erase contents, with no possible undo"
		help: #helpText;
		selection: #contentsSelection; 
		menu: #codePaneMenu:shifted:;
		askBeforeDiscardingEdits: false.
	^textSpec! !

!TestBrowser methodsFor: '*People-spfa-fixes' stamp: 'spfa 5/11/2017 13:49'!
buildDetailsTextMorph
	| row |
	detailsText _ PluggableTextMorph
				on: self
				text: #details
				accept: nil.
	detailsText 
		hideScrollBarsIndefinitely;
		borderWidth: 1;
		hResizing: #spaceFill;
		vResizing: #spaceFill.

	row _ AlignmentMorph newRow
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutInset: 0;
		borderWidth: 0;
		addMorphBack: detailsText.

	^ row! !

!TestBrowser methodsFor: '*People-spfa-fixes' stamp: 'spfa 5/11/2017 13:49'!
buildPassFailTextMorph
	| row |
	passFailText _ PluggableTextMorph
				on: self
				text: #passFail
				accept: nil.
	passFailText 
		hideScrollBarsIndefinitely;
		borderWidth: 1;
		hResizing: #spaceFill;
		vResizing: #spaceFill.

	row _ AlignmentMorph newRow
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutInset: 0;
		borderWidth: 0;
		addMorphBack: passFailText.

	^ row! !

!TestBrowser methodsFor: '*People-spfa-fixes' stamp: 'spfa 5/11/2017 13:49'!
buildRefreshButtonMorph

	| refreshButton row |
	refreshButton := PluggableButtonMorph
				on: self
				getState: #refreshButtonState
				action: #refreshTests
				label: #refreshButtonLabel.
	refreshButton
		onColor: self runButtonColor offColor: self runButtonColor;
		borderWidth: 1;
		hResizing: #spaceFill;
		vResizing: #spaceFill.

	row := AlignmentMorph newRow
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutInset: 0;
		borderWidth: 0;
		addMorphBack: refreshButton.

	^row! !

!ObjectExplorer methodsFor: '*People-spfa-fixes' stamp: 'spfa 7/2/2019 10:33'!
buildWith: builder

	| windowSpec treeSpec textSpec buttonSpec buttonOffset tool |
	windowSpec := builder pluggableWindowSpec new.
	windowSpec
		model: self;
		children: OrderedCollection new;
		label: #label;
		extent: self initialExtent.
	
	treeSpec := builder pluggableTreeSpec new.
	treeSpec
		model: self;
		nodeClass: self class nodeClass;
		roots: #getList;
		keyPress: #explorerKey:from:event:;
		getSelected: #currentSelection;
		setSelected: #currentSelection:;
		setSelectedParent: #currentParent:;
		menu: #genericMenu:;
		autoDeselect: false;
		columns: (ObjectExplorerWrapper showContentsInColumns
			ifTrue: [{
				[:listMorph | (listMorph filteredItems collect: [:item |
					item preferredWidthOfColumn: 1]) max].
				nil "take all the space"}]);
		frame: (0@0 corner: 1@0.71).
	windowSpec children add: treeSpec.

	buttonOffset := (Preferences standardButtonFont widthOfString: 'inspect') * 3/2.

	textSpec := builder pluggableCodePaneSpec new.
	textSpec
		model: self;
		getText: #expression;
		editText: #expression:;
		setText: #expression:; "else accidental alt-s erase contents, with no possible undo"
		menu: #codePaneMenu:shifted:;
		help: 'Evaluate expressions for the current tree selection...' translated;
		frame: (LayoutFrame fractions: (0@0.71 corner: 1@1) offsets: (0@0 corner: buttonOffset negated@0)).
	windowSpec children add: textSpec.

	buttonSpec := builder pluggableButtonSpec new
		model: self;
		label: 'inspect';
		action: #inspectObject;
		help: 'Switch to an inspector tool';
		frame: (LayoutFrame fractions: (1@0.71 corner: 1@1) offsets: (buttonOffset negated@0 corner: 0 @ 0)).
	windowSpec children add: buttonSpec.
	
	tool := builder build: windowSpec.
	self changed: #expandRootsRequested.
	^ tool! !

!TestBrowser methodsFor: '*People-spfa-fixes' stamp: 'spfa 10/15/2017 16:14'!
classList

	^ super classList! !

!Interval methodsFor: '*People-spfa-fixes' stamp: 'spfa 4/16/2018 14:32'!
collect: aBlock
	| result |
	result := self species new: self size.
	0 to: self size - 1 do:
		[:index |
			result at: index + 1 put: (aBlock value: start + (index * step))].
	^ result! !

!Color class methodsFor: '*People-spfa-fixes-override' stamp: 'spfa 10/3/2011 21:59'!
colorFromPixelValue: p depth: d
    "Convert a pixel value for the given display depth into a color."
    "Details: For depths of 8 or less, the pixel value is simply looked 
up in a table. For greater depths, the color components are extracted 
and converted into a color."
    "Warning: In BitBlt, a pixel with pixelValue = 0 is transparent.
    Squeak usually assumes that r=g=b=0 => transparent. But this is 
false if we have alpha (opacity).
    A color with r=g=b=0 and opacity = 255 is BLACK, not TRANSPARENT.
    Squeak also answers darkest possible blue when asked for black. 
Again, this is not needed in 32 bits (with alpha).
    The real rule is that pixelValue=0 means transparent.
    And that darkest blue must be used instead of black, but only for 
depths >8 and < 32 (no indexed colors, no alpha)
    This method is updated to reflect that."

    | r g b alpha |
    d = 8 ifTrue: [^ IndexedColors at: (p bitAnd: 16rFF) + 1].
    d = 4 ifTrue: [^ IndexedColors at: (p bitAnd: 16r0F) + 1].
    d = 2 ifTrue: [^ IndexedColors at: (p bitAnd: 16r03) + 1].
    d = 1 ifTrue: [^ IndexedColors at: (p bitAnd: 16r01) + 1].

    d = 32 ifTrue: [
        "eight bits per component; 8 bits of alpha"
        alpha := p bitShift: -24.
        alpha = 0 ifTrue: [ ^Color transparent ].
        r := (p bitShift: -16) bitAnd: 16rFF.
        g := (p bitShift: -8) bitAnd: 16rFF.
        b := p bitAnd: 16rFF.
        ^alpha < 255
            ifTrue: [ (Color r: r g: g b: b range: 255) alpha: alpha 
asFloat / 255.0 ]
            ifFalse: [ Color r: r g: g b: b range: 255 ]].

    "For the rest of the depths, pixelValue = 0 means transparent, and 
darkest blue is considered to be black."
    p = 0 ifTrue: [ ^Color transparent ].

    (d = 16) | (d = 15) ifTrue: [
        "five bits per component"
        r := (p bitShift: -10) bitAnd: 16r1F.
        g := (p bitShift: -5) bitAnd: 16r1F.
        b := p bitAnd: 16r1F.
        (r = 0 and: [ g = 0 and: [ b = 1]]) ifTrue: [
            ^Color black ].
        ^ Color r: r g: g b: b range: 31].

    d = 12 ifTrue: [
        "four bits per component"
        r := (p bitShift: -8) bitAnd: 16rF.
        g := (p bitShift: -4) bitAnd: 16rF.
        b := p bitAnd: 16rF.
        (r = 0 and: [ g = 0 and: [ b = 1]]) ifTrue: [
            ^Color black ].
        ^ Color r: r g: g b: b range: 15].

    d = 9 ifTrue: [
        "three bits per component"
        r := (p bitShift: -6) bitAnd: 16r7.
        g := (p bitShift: -3) bitAnd: 16r7.
        b := p bitAnd: 16r7.
        (r = 0 and: [ g = 0 and: [ b = 1]]) ifTrue: [
            ^Color black ].
        ^ Color r: r g: g b: b range: 7].

    self error: 'unknown pixel depth: ', d printString! !

!Morph methodsFor: '*People-spfa-fixes' stamp: 'spfa 8/11/2010 18:02'!
containingWindow
	"Answer a window or window-with-mvc that contains the receiver"

	| component |
	component := self.
	component model isNil ifTrue: [component := self firstOwnerSuchThat: [:m| m model notNil]].
	^ ((component isNil or: [component isWindowForModel: component model])
		ifTrue: [component]
		ifFalse: [component firstOwnerSuchThat:[:m| m isWindowForModel: component model]])
		ifNil: [self firstOwnerSuchThat: [:m| m isSystemWindow]].! !

!PolygonMorph methodsFor: '*People-spfa-fixes' stamp: 'spfa 2/25/2020 15:12'!
containsPoint: aPoint
	(super containsPoint: aPoint) ifFalse: [^ false].

	closed & color isTransparent not ifTrue:
		[^ (self filledForm pixelValueAt: aPoint - self topLeft) > 0].

	self lineSegmentsDo:
		[:p1 :p2 |
		(aPoint onLineFrom: p1 to: p2 within: (3 max: self borderWidth+1//2) asFloat)
				ifTrue: [^ true]].

	self arrowForms do:
		[:f | (f pixelValueAt: aPoint - f offset) > 0 ifTrue: [^ true]].

	^ false! !

!HelpTopicListItemWrapper methodsFor: '*People-spfa-fixes' stamp: 'spfa 12/9/2016 12:22'!
contents
	
	^self item subtopics collect: [ :each | 
		HelpTopicListItemWrapper with: each model: self model parent: self]
! !

!ProportionalSplitterMorph methodsFor: '*People-spfa-fixes' stamp: 'spfa 1/27/2023 11:36'!
correctLayoutOffsets

	| do layoutFrame |

	layoutFrame := self layoutFrame.

	self splitsTopAndBottom ifTrue: [
		do := leftOrTop anyOne layoutFrame bottomOffset.
		layoutFrame bottomOffset: layoutFrame bottomOffset + do.
		layoutFrame topOffset: layoutFrame topOffset + do.
		^ self].

	do := rightOrBottom anyOne layoutFrame leftOffset.
	layoutFrame rightOffset: layoutFrame rightOffset + do.
	layoutFrame leftOffset: layoutFrame leftOffset + do.! !

!Duration class methodsFor: '*People-spfa-fixes-override' stamp: 'brp 1/7/2004 15:38'!
days: days hours: hours minutes: minutes seconds: seconds nanoSeconds: nanos

 	^ self nanoSeconds: 
			( ( (days * SecondsInDay) 
				+ (hours * SecondsInHour)
					+ (minutes * SecondsInMinute) 
						+ seconds ) * NanosInSecond )
							+ nanos.
! !

!MethodNode methodsFor: '*People-spfa-fixes' stamp: 'spfa 4/4/2012 11:29'!
decompileString 
	"Answer a string description of the parse tree whose root is the receiver."

	^self fullPrintString
! !

!TestBrowser methodsFor: '*People-spfa-fixes' stamp: 'spfa 11/25/2016 13:33'!
defaultBackgroundColor
	"Returns the receivers default background color"
	
	^ Color blue blacker veryMuchLighter! !

!PolygonMorph methodsFor: '*People-spfa-fixes' stamp: 'dgd 2/14/2003 22:35'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	^ Color
		r: 0.0
		g: 0.419
		b: 0.935! !

!TestBrowser methodsFor: '*People-spfa-fixes' stamp: 'spfa 11/18/2009 18:17'!
defaultBrowserTitle
	"Returns the receivers default browser title"
	
	^self asString! !

!NCAAConnectorMorph class methodsFor: '*People-spfa-fixes' stamp: 'spfa 11/18/2009 18:14'!
defaultFSM

	^ nil! !

!MorphicEventDispatcher methodsFor: '*People-spfa-fixes' stamp: 'spfa 3/23/2017 07:58'!
dispatchDefault: anEvent with: aMorph
	"Dispatch the given event. The event will be passed to the front-most visible submorph that contains the position wrt. to the event."

	"Try to get out quickly"
	anEvent wasIgnored ifTrue: [^anEvent "propagate the ignored event"].
	((aMorph fullBounds "it happens" ifNil: [self flag: #WTF. ^#rejected]) 
		containsPoint: anEvent position) ifFalse:[^#rejected].

	^ self
		dispatchEvent: anEvent
		withHandler: aMorph
		withMorph: aMorph! !

!TextEditor methodsFor: '*People-spfa-fixes' stamp: 'spfa 5/22/2018 13:44'!
dispatchOnKeyboardEvent: aKeyboardEvent 
	"Carry out the action associated with this character, if any. Type-ahead is passed so some routines can flush or use it."
	
	"SPFA (note): the fix here is not needed for newest Squeak, only 5.1"

	| honorCommandKeys typedChar |
	typedChar := aKeyboardEvent keyCharacter.
	
	"Handle one-line input fields."
	(typedChar == Character cr and: [morph acceptOnCR])
		ifTrue: [^ true].
	
	"Clear highlight for last opened parenthesis."
	self clearParens.
	
	"Handle line breaks and auto indent."
	typedChar == Character cr ifTrue: [
		aKeyboardEvent controlKeyPressed
			ifTrue: [^ self normalCharacter: aKeyboardEvent].
		aKeyboardEvent shiftPressed
			ifTrue: [^ self lf: aKeyboardEvent].
		aKeyboardEvent commandKeyPressed
			ifTrue: [^ self crlf: aKeyboardEvent].
		^ self crWithIndent: aKeyboardEvent].

	"Handle indent/outdent with selected text block."
	typedChar == Character tab ifTrue: [
		aKeyboardEvent shiftPressed
			ifTrue: [self outdent: aKeyboardEvent. ^ true]
			ifFalse: [self hasMultipleLinesSelected
				ifTrue: [self indent: aKeyboardEvent. ^ true]]].

	honorCommandKeys := Preferences cmdKeysInText.

	(honorCommandKeys and: [typedChar == Character enter])
		ifTrue: [^ self dispatchOnEnterWith: aKeyboardEvent].
	
	"Special keys overwrite crtl+key combinations - at least on Windows. To resolve this
	conflict, assume that keys other than cursor keys aren't used together with Crtl."
	((self class specialShiftCmdKeys includes: aKeyboardEvent keyValue)
		and: [aKeyboardEvent keyValue < 27])
			ifTrue: [^ aKeyboardEvent controlKeyPressed
				ifTrue: [self
							perform: (self class shiftCmdActions at: aKeyboardEvent keyValue + 1)
							with: aKeyboardEvent]
				ifFalse: [self
							perform: (self class cmdActions at: aKeyboardEvent keyValue + 1)
							with: aKeyboardEvent]].
			
	"backspace, and escape keys (ascii 8 and 27) are command keys"
	((honorCommandKeys and: [aKeyboardEvent commandKeyPressed])
		or: [self class specialShiftCmdKeys includes: aKeyboardEvent keyValue])
			ifTrue: [ ^ aKeyboardEvent shiftPressed
				ifTrue: [self
							perform: (self class shiftCmdActions at: aKeyboardEvent keyValue + 1)
							with: aKeyboardEvent]
				ifFalse: [self
							perform: (self class cmdActions at: aKeyboardEvent keyValue + 1)
							with: aKeyboardEvent]].

	"the control key can be used to invoke shift-cmd shortcuts"
	(honorCommandKeys and: [ aKeyboardEvent controlKeyPressed ])
		ifTrue: [^ self
					perform: (self class shiftCmdActions at: aKeyboardEvent keyValue + 1)
					with: aKeyboardEvent].

	"Enclose selection with brackets etc."
	((self class encloseSelection and: [self hasSelection]) and: [self enclose: aKeyboardEvent])
		ifTrue: [^ true].

	"Automatically enclose paired characters such as brackets."
	(self class autoEnclose and: [self autoEncloseFor: typedChar])
		ifTrue: [^ true].

	self flag: #hack. "the code below in in Squeak 6 already"
	(')]}' includes: typedChar) ifTrue: [self blinkPrevParen: typedChar].
					
	self normalCharacter: aKeyboardEvent.
	^ false! !

!NewParagraph methodsFor: '*People-spfa-fixes' stamp: 'spfa 2/18/2020 15:09'!
displayOn: aCanvas using: displayScanner at: somePosition
	"Send all visible lines to the displayScanner for display"
	| visibleRectangle offset leftInRun line |
	visibleRectangle := aCanvas clipRect.
	offset := (somePosition - positionWhenComposed) truncated.
	leftInRun := 0.

	lines ifNil: [^ self changed].

	(self lineIndexForPoint: visibleRectangle topLeft)
		to: (self lineIndexForPoint: visibleRectangle bottomRight)
		do: [:i | line := lines at: i.
			self displaySelectionInLine: line on: aCanvas.
			line first <= line last ifTrue:
				[leftInRun := displayScanner displayLine: line
								offset: offset leftInRun: leftInRun]].
! !

!ObjectExplorer methodsFor: '*People-spfa-fixes' stamp: 'spfa 3/21/2017 11:33'!
doItReceiver
	"Answer the object that should be informed of the result of evaluating a
	text selection."

	self flag: #backwardCompatibility.
	"for compatibility before/after 4.6"
	currentSelection ifNil: [^ self rootObject].
	^ self object
! !

!PolygonMorph methodsFor: '*People-spfa-fixes' stamp: 'spfa 2/25/2020 15:12'!
drawOnFormCanvas: aCanvas 
	"Display the receiver, a spline curve, approximated by straight line segments."

	| |
	vertices size < 1 ifTrue: [self error: 'a polygon must have at least one point'].
	closed & color isTransparent not
		ifTrue: [aCanvas stencil: self filledForm at: self bounds topLeft color: self color].
	(self borderColor isColor and: [self borderColor isTranslucentColor])
		ifTrue: [aCanvas stencil: self borderForm at: self bounds topLeft
						color: self borderColor]
		ifFalse: [self drawBorderOn: aCanvas].
	self arrowForms do:
		[:f | aCanvas stencil: f at: f offset
			color: (self borderColor isColor ifTrue: [self borderColor] ifFalse: [self color])]! !

!Browser methodsFor: '*People-spfa-fixes' stamp: 'ar 8/8/2009 10:16'!
dropOnSystemCategories: aClass at: index
	| category |
	(aClass isBehavior) ifFalse:[^self inform: 'Can only drop classes'].
	category := self systemCategoryList at: index.
	self selectedEnvironment organization classify: aClass instanceSide name  under: category.
	^true! !

!MorphicUIManager methodsFor: '*People-spfa-fixes' stamp: 'spfa 2/2/2012 11:51'!
edit: aText label: labelString accept: anAction
	"Open an editor on the given string/text"
	| window holder text |
	holder := Workspace  new.
	holder contents: aText.
	text := PluggableTextMorphPlus 
		on: holder 
		text: #contents 
		accept: #acceptContents: 
		readSelection: nil 
		menu: nil.
	text acceptAction: anAction.
	window := SystemWindow new.
	labelString ifNotNil:[window setLabel: labelString].
	window model: holder .
	window addMorph: text frame: (0@0 extent: 1@1).
	window openInWorld.
	^window! !

!TextFontChange methodsFor: '*People-spfa-fixes' stamp: 'spfa 7/22/2022 00:53'!
emphasizeScanner: scanner
	"Set the font for text display"
	fontNumber ifNotNil: [scanner setFont: fontNumber]! !

!TestBrowser methodsFor: '*People-spfa-fixes' stamp: 'spfa 11/25/2016 13:52'!
errorColor

	^  Color r: 1 g: 0.678 b: 0.004! !

!StrikeFont class methodsFor: '*People-spfa-fixes' stamp: 'spfa 9/24/2018 18:58'!
familyName: aName pointSize: aSize emphasis: code
	"Answer a font (or the default font if the name is unknown) in the specified size."

	^ (((TextStyle named: aName asSymbol) ifNil: [TextStyle default]) fontOfPointSize: aSize)
		emphasis: code.! !

!TTCFontSet class methodsFor: '*People-spfa-fixes' stamp: 'spfa 9/24/2018 18:57'!
familyName: n pointSize: s emphasis: code

	^ self familyName: n pointSize: s emphasized: code! !

!PolygonMorph methodsFor: '*People-spfa-fixes' stamp: 'spfa 2/25/2020 15:24'!
filledForm

	"The filledForm, computed on demand and cached, is actually the #shadowForm - this is better then the previous implementation because it takes into accounts the holes that can appear in self-intersecting polygons."

	closed ifFalse: [^ filledForm := nil].
	filledForm ifNotNil: [^ filledForm].
	^ filledForm := self shadowForm.
! !

!Morph methodsFor: '*People-spfa-fixes' stamp: 'spfa 3/14/2018 14:24'!
findDeeplyA: aClass
	"Return a morph in the submorph tree of the receiver that is descended from the given class. Return nil if there is no such morph. Clients of this code should always check for a nil return value so that the code will be robust if the user takes the morph apart."

	self allMorphsDo: [:p | ((p isKindOf: aClass) and: [p ~~ self]) ifTrue: [^p]].
	^ nil! !

!DeepCopier methodsFor: '*people-spfa-fixes' stamp: 'spfa 10/6/2019 17:28'!
fixDependents
	"They are not used much, but need to be right"

	DependentsFields associationsDo: [:pair |
		pair key ifNotNil: [
			pair value do: [:dep | 
				| newDep newModel |
				newDep := references at: dep ifAbsent: [nil].
				newDep ifNotNil: [
					newModel := references at: pair key ifAbsent: [pair key].
					newModel addDependent: newDep]]]].
	
	"This is an extra step for object-specific structural check-up"
	references keysAndValuesDo: [:k :v | v wakeUpAsFreshCopyOf: k]
! !

!SmalltalkImage methodsFor: '*People-spfa-fixes' stamp: 'spfa 11/25/2016 16:02'!
forgetDoIts	
	
"	self deprecated: 'This method does not have to be sent anymore!!'"

" kept for compatibility"
! !

!FormCanvas methodsFor: '*People-spfa-fixes' stamp: 'spfa 8/31/2019 18:37'!
frameAndFillRectangle: r fillColor: fillColor borderWidth: borderWidth borderColor: borderColor
	| rect |
	
	origin isZero ifTrue: [rect := r] ifFalse: [rect := r translateBy: origin].

	borderWidth isZero ifTrue: [
		^ fillColor isTransparent ifFalse:
			[self setFillColor: fillColor.
			port fillRect: rect offset: origin]].

	"draw the border of the rectangle"
	borderColor isTransparent ifFalse:[
		self setFillColor: borderColor.
		(r area > 10000 or: [fillColor isTranslucent]) ifTrue: [
			port frameRect: rect borderWidth: borderWidth.
		] ifFalse: ["for small rectangles, it's faster to fill the entire outer rectangle
					than to compute and fill the border rects"
					port fillRect: rect offset: origin]].

	"fill the inside"
	fillColor isTransparent ifFalse:
		[self setFillColor: fillColor.
		port fillRect: (rect insetBy: borderWidth) offset: origin].! !

!SystemProgressMorph methodsFor: '*People-spfa-fixes' stamp: 'spfa 7/9/2010 12:03'!
freeSlot: number
	number > 0 ifTrue: [
		lock critical: [
			(bars at: number) delete.
			(labels at: number) delete.
			activeSlots := activeSlots - 1.
			activeSlots <= 0
				ifTrue: [self delete]
				ifFalse: [self recenter]]]! !

!StringMorph methodsFor: '*People-spfa-fixes' stamp: 'spfa 11/7/2017 16:52'!
fullBounds
	self contents ifNil: [ self contents: '   '].
	^super fullBounds! !

!HandMorph methodsFor: '*People-spfa-fixes' stamp: 'spfa 11/3/2020 20:39'!
fullDrawOn: aCanvas 
	"A HandMorph has unusual drawing requirements:
		1. the hand itself (i.e., the cursor) appears in front of its submorphs
		2. morphs being held by the hand cast a shadow on the world/morphs below
	The illusion is that the hand plucks up morphs and carries them above the world."

	"Note: This version caches an image of the morphs being held by the hand for
	 better performance. This cache is invalidated if one of those morphs changes."

	| disableCaching subBnds |
	self visible ifFalse: [^self].
	(aCanvas isVisible: self fullBounds) ifFalse: [^self].
	(self hasProperty: #errorOnDraw) ifTrue:[^self drawErrorOn: aCanvas].
	disableCaching := false.
	disableCaching 
		ifTrue: 
			[self nonCachingFullDrawOn: aCanvas.
			^self].
	submorphs isEmpty 
		ifTrue: 
			[cacheCanvas := nil.
			^self drawOn: aCanvas].	"just draw the hand itself"

	"special handling of a single submorph that wants to do its own thing
	when being dragged"
	(submorphs size = 1
			and: [submorphs first handledOwnDraggingBy: self on: aCanvas])
		ifTrue: [^ self drawOn: aCanvas].

	subBnds := Rectangle merging: (submorphs collect: [:m | m fullBounds]).
	self updateCacheCanvas: aCanvas.
	(cacheCanvas isNil 
		or: [cachedCanvasHasHoles and: [cacheCanvas depth = 1]]) 
			ifTrue: 
				["could not use caching due to translucency; do full draw"

				self nonCachingFullDrawOn: aCanvas.
				^self].

	"draw the shadow"
	aCanvas asShadowDrawingCanvas translateBy: self shadowOffset
		during: 
			[:shadowCanvas | 
			cachedCanvasHasHoles 
				ifTrue: 
					["Have to draw the real shadow of the form"

					shadowCanvas paintImage: cacheCanvas form at: subBnds origin]
				ifFalse: 
					["Much faster if only have to shade the edge of a solid rectangle"

					(subBnds areasOutside: (subBnds translateBy: self shadowOffset negated)) 
						do: [:r | shadowCanvas fillRectangle: r color: Color black]]].

	"draw morphs in front of the shadow using the cached Form"
	cachedCanvasHasHoles 
		ifTrue: [aCanvas translucentImage: cacheCanvas form at: subBnds origin]
		ifFalse: 
			[aCanvas 
				translucentImage: cacheCanvas form
				at: subBnds origin
				sourceRect: cacheCanvas form boundingBox].
	self drawOn: aCanvas	"draw the hand itself in front of morphs"! !

!Duration methodsFor: '*People-spfa-fixes-override' stamp: 'spfa 11/18/2009 18:09'!
hash 	

	^ seconds asInteger bitXor: nanos asInteger
! !

!Morph methodsFor: '*People-spfa-fixes' stamp: 'spfa 6/1/2017 09:21'!
iconOrThumbnailOfSize: aNumberOrPoint 
	"Answer an appropiate form to represent the receiver"

	^ (self iconOrThumbnail ifNil: [^ nil]) scaledIntoFormOfSize: aNumberOrPoint! !

!String methodsFor: '*People-spfa-fixes-common' stamp: 'spfa 11/25/2016 16:01'!
includesSubString: subString

	"Deprecated, kept for compatibility"

	^ (self findString: subString startingAt: 1) > 0! !

!TestBrowser methodsFor: '*People-spfa-fixes' stamp: 'spfa 5/11/2015 14:05'!
initialExtent

	^  600@500! !

!FileList2 class methodsFor: '*People-spfa-fixes' stamp: 'spfa 11/18/2009 18:09'!
initialize
	Preferences
		addPreference: #useFileList2
		categories:  #(general)
		default: true
		balloonHelp: 'if true, then when you open a file list from the World menu, it''ll be an enhanced one'
		projectLocal:  false
		changeInformee:  self
		changeSelector: #useFileList2preferenceChanged
		viewRegistry: PreferenceViewRegistry ofBooleanPreferences ! !

!PasteUpMorph methodsFor: '*People-spfa-fixes' stamp: 'spfa 1/31/2020 18:11'!
invalidRect: damageRect from: aMorph
	"Clip damage reports to my bounds, since drawing is clipped to my bounds."
	self isWorldMorph
		ifTrue: [^ worldState recordDamagedRect: damageRect].
	^super invalidRect: damageRect from: aMorph! !

!FileContentsBrowser methodsFor: '*People-spfa-fixes' stamp: 'spfa 11/18/2009 18:09'!
isTestCase: aPseudoClass

	^ false! !

!TestBrowser methodsFor: '*People-spfa-fixes' stamp: 'spfa 11/25/2016 13:41'!
layoutWithTestPane

	topWindowMorph removePanes.

	topWindowMorph 
		addMorph: self buildSystemCategoryListMorph frame: (0.0 @ 0.0 extent: 0.25 @ 0.23);
		addMorph: self buildTemplateMorph frame: (0.0 @ 0.23 extent: 0.25 @ 0.07);
"		addMorph: self buildToggleFilteringButtonMorph frame: (0.0 @ 0.23 extent: 0.12 @ 0.07);
		addMorph: self buildToggleTestPaneButtonMorph frame: (0.12 @ 0.23 extent: 0.13 @ 0.07);"
		addMorph: self buildClassListMorph frame: (0.25 @ 0.0 extent: 0.25 @ 0.30);
		addMorph: self buildMessageCategoryListMorph frame: (0.5 @ 0.0 extent: 0.25 @ 0.30);
		addMorph: self buildMessageListMorph frame: (0.75 @ 0.0 extent: 0.25 @ 0.30).

	topWindowMorph 
		addMorph: self buildRefreshButtonMorph frame: (0.0 @ 0.30 extent: 0.17 @ 0.12 "0.08");
		addMorph: self buildRunButtonMorph frame: (0.0 @ 0.42 "0.33" extent: 0.17 @ 0.17 "0.08");
		"addMorph: self buildStopButtonMorph frame: (0.0 @ 0.41 extent: 0.17 @ 0.08);"
		addMorph: self buildFailureButtonMorph frame: (0.17 @ 0.30 extent: 0.33 @ 0.07);
		addMorph: self buildFailuresListMorph frame: (0.17 @ 0.37 extent: 0.33 @ 0.22);
		addMorph: self buildErrorButtonMorph frame: (0.50 @ 0.30 extent: 0.33 @ 0.07);
		addMorph: self buildErrorListMorph frame: (0.50 @ 0.37 extent: 0.33 @ 0.22);
		addMorph: self buildRunCategoryButtonMorph frame: (0.83 @ 0.30 extent: 0.17 @ 0.08);
		addMorph: self buildRunClassButtonMorph frame: (0.83 @ 0.38 extent: 0.17 @ 0.08);
		addMorph: self buildRunMethodButtonMorph frame: (0.83 @ 0.46 extent: 0.17 @ 0.13).

	topWindowMorph 
		addMorph: self buildPassFailTextMorph frame: (0.0 @ 0.59 extent: 0.30 @ 0.1);
		addMorph: self buildDetailsTextMorph frame: (0.30 @ 0.59 extent: 0.70 @ 0.1).
	
	topWindowMorph 
		addMorph: self buildBrowserCodeMorph frame: (0.0 @ 0.69 extent: 1 @ 0.31).

	topWindowMorph setUpdatablePanesFrom: #(systemCategoryList classList messageCategoryList messageList).
	self refreshWindow.

	self isEmptySuite ifFalse: [self updateWindow].

	^ topWindowMorph! !

!ZipArchiveMember methodsFor: '*People-spfa-fixes-common' stamp: 'spfa 11/18/2009 18:17'!
localFileName
	"Answer my fileName in terms of the local directory naming convention"
	| localName |
	localName :=  (fileName copyReplaceAll: '/' with: FileDirectory slash)
		copyReplaceAll: '\' with: FileDirectory slash.
	^(fileName first = $/)
		ifTrue: [ FileDirectory default class makeAbsolute: localName ]
		ifFalse: [ FileDirectory default class makeRelative: localName ]! !

!ExternalDropHandler methodsFor: '*People-spfa-fixes-override' stamp: 'spfa 11/18/2009 18:09'!
matchesExtension: aExtension
	(self extension isNil or: [aExtension isNil])
		ifTrue: [^false].
	FileDirectory activeDirectoryClass isCaseSensitive
		ifTrue: [^extension = aExtension]
		ifFalse: [^extension sameAs: aExtension]! !

!PolygonMorph methodsFor: '*People-spfa-fixes' stamp: 'spfa 7/24/2022 10:52'!
maybeBecomeNCLineMorph

	"for conversion from a connector v1.9 to a connector 2.2"

	| lw col o |

	(owner isNil or: [owner isConnector not]) ifTrue: [^ self].

	(owner isMGraphConnector and:
		[owner isTimeStamp]) ifTrue: [ lw := 1] ifFalse: [lw := 2].

	col := borderColor.
	o := owner.
	self privateOwner: nil.
	self becomeTransparently: ((NCLineMorph vertices: vertices lineWidth: lw lineColor: col borderWidth: 0 borderColor: col) privateOwner: o) 
		makeForwardArrow; fillStyle: col.

	owner beOrthogonal: false! !

!Duration class methodsFor: '*People-spfa-fixes-override' stamp: 'spfa 11/18/2009 18:09'!
milliSeconds: milliCount

	^ self nanoSeconds: milliCount * 1000000
! !

!MimeConverter class methodsFor: '*People-spfa-fixes' stamp: 'spfa 4/18/2010 22:04'!
mimeEncode: aCollectionOrStream to: outStream
	self new
		dataStream: (aCollectionOrStream isStream
			ifTrue: [aCollectionOrStream]
			ifFalse: [ReadStream on: aCollectionOrStream]);
		mimeStream: outStream;
		multiLine: true;
		mimeEncode! !

!PasteUpMorph methodsFor: '*People-spfa-fixes' stamp: 'spfa 5/29/2018 16:42'!
model
	"Return the model object for this world. If the world has no model, then create one."

	self isWorldMorph ifTrue: [self createCustomModel].
	^ model! !

!ProportionalSplitterMorph methodsFor: '*People-spfa-fixes' stamp: 'spfa 12/20/2019 17:17'!
mouseDown: anEvent 
	"If the user manually drags me, don't override him with auto positioning."

	self setProperty: #fullDelta toValue: 0@0.

	anEvent redButtonChanged
		ifTrue: [ self withSiblingSplittersDo: [ : each | each stopStepping ] ]
		ifFalse:
			[ anEvent shiftPressed
				ifTrue: [ self startStepping ]
				ifFalse:
					[ self startStepping.
					self withSiblingSplittersDo: [ : each | each startStepping ] ] ].

	^ super mouseDown: anEvent! !

!TextMorph methodsFor: '*People-spfa-fixes' stamp: 'spfa 5/11/2017 15:18'!
mouseDown: evt 
	"Make this TextMorph be the keyboard input focus, if it isn't  
	already, and repond to the text selection gesture."
	
	evt yellowButtonPressed ifTrue: [
		"First check for option (menu) click"
		^ self yellowButtonActivity: evt shiftPressed].

	"Show the caret immediately on mouse down to give user feedback."
	self resetBlinkCursor.

	"If focus does not follow the mouse cursor and we click below everything, just grab the focus to not destroy the selection."
	((self hasKeyboardFocus: evt hand) not and: [(self bounds containsPoint: evt position) not])
		ifTrue: [evt hand newKeyboardFocus: self]
		ifFalse: [
			evt hand newKeyboardFocus: self.
			self
				handleInteraction: [self editor mouseDown: evt]
				fromEvent: evt].! !

!TrashCanMorph methodsFor: '*People-spfa-fixes' stamp: 'spfa 9/23/2018 23:33'!
mouseDown: evt
	| paintBox |
	evt hand visible: true.
	"See if a stamp is being dropped into the trash. It is not held by the hand."
	(paintBox := self findActivePaintBox) ifNotNil: [
		paintBox getSpecial == #stamp: ifTrue: [
			paintBox deleteCurrentStamp: evt.  "throw away stamp..."
			self primaryHand showTemporaryCursor: nil.
			^ self]].	  "... and don't open trash"

	self isSticky ifTrue: [^self].
	evt hand waitForClicksOrDrag: self event: evt.
! !

!PluggableButtonMorph methodsFor: '*People-spfa-fixes' stamp: 'spfa 6/18/2013 11:17'!
mouseEnterDragging: evt

	self mouseEnter: evt! !

!PluggableListMorphPlus methodsFor: '*People-spfa-fixes' stamp: 'spfa 5/23/2018 12:20'!
mouseUp: evt

	"SPFA - do not select an item if click happened outside the list (very annoying in the case of attempting to grab a browser splitter morph and deselecting the current code because the event is send to the list above)"

	scroller hasSubmorphs ifTrue:[
		(scroller submorphs last containsPoint: 
			(evt transformedBy: (scroller transformFrom: self)) position) ifFalse: [^ self]].

	super mouseUp: evt! !

!ProportionalSplitterMorph methodsFor: '*People-spfa-fixes' stamp: 'spfa 12/20/2019 17:16'!
mouseUp: anEvent 
	(self bounds containsPoint: anEvent cursorPoint)
		ifFalse: [anEvent hand showTemporaryCursor: nil].
	self class fastSplitterResize
		ifTrue: [self updateFromEvent: anEvent].
	traceMorph ifNotNil: [traceMorph delete. traceMorph := nil].

	self balanceOffsets! !

!TextMorph methodsFor: '*People-spfa-fixes' stamp: 'spfa 5/11/2017 15:18'!
mouseUp: evt
	self handleInteraction: [self editor mouseUp: evt] fromEvent: evt! !

!Duration class methodsFor: '*People-spfa-fixes-override' stamp: 'spfa 11/18/2009 18:09'!
nanoSeconds: nanos

	| n s |

	n := nanos asInteger.
	^ self new
		seconds: (s := n quo: NanosInSecond) 
		nanoSeconds: (n - (s * NanosInSecond));
		yourself.
! !

!Browser methodsFor: '*People-spfa-fixes' stamp: 'spfa 9/3/2017 12:30'!
noCommentNagString

	^ Text string: 'This class has no class comment' attribute: TextColor red.
		! !

!TTCFontSet methodsFor: '*People-spfa-fixes' stamp: 'spfa 9/24/2018 18:52'!
objectForDataStream: refStrm
	| dp |
	"I am about to be written on an object file.  Write a
reference to a known FontSet in the other system instead."

	"a path to me"
	dp := DiskProxy global: #TTCFontSet selector: #familyName:pointSize:emphasis:
			args: {self familyName. self pointSize. self emphasis}.
	refStrm replace: self with: dp.
	^ dp.! !

!Object methodsFor: '*People-spfa-fixes' stamp: 'spfa 11/18/2009 18:15'!
perform: selector orSendTo: otherTarget
	"If I wish to intercept and handle selector myself, do it; else send it to otherTarget"
	(self respondsTo: selector)
		ifTrue: [^ self perform: selector]
		ifFalse: [^ otherTarget perform: selector]! !

!Color methodsFor: '*people-spfa-fixes-override' stamp: 'spfa 10/3/2011 21:59'!
pixelValueForDepth: d
    "Returns an integer representing the bits that appear in a single 
pixel of this color in a Form of the given depth. The depth must be one 
of 1, 2, 4, 8, 16, or 32. Contrast with pixelWordForDepth: and 
bitPatternForDepth:, which return either a 32-bit word packed with the 
given pixel value or a multiple-word Bitmap containing a pattern. The 
inverse is the class message colorFromPixelValue:depth:"
    "Details: For depths of 8 or less, the result is a colorMap index. 
For depths of 16 and 32, it is a direct color value with 5 or 8 bits per 
color component."
    "Transparency: The pixel value zero is reserved for transparent. For 
depths greater than 8 and less than 32 (no Indexed colors, no real 
alpha), black maps to the darkest possible blue.
    Note that
        Color transparent class = TranslucentColor
    this special case is handled in TranslucentColor >> #pixelValueForDepth:
    "

    | bitBltFakeBlack val |
    d = 8 ifTrue: [^ self closestPixelValue8].  "common case"
    d < 8 ifTrue: [
        d = 4 ifTrue: [^ self closestPixelValue4].
        d = 2 ifTrue: [^ self closestPixelValue2].
        d = 1 ifTrue: [^ self closestPixelValue1]].

    d = 32 ifTrue: [
        "eight bits per component; top 8 bits set to all ones (opaque 
alpha)"
        val := LargePositiveInteger new: 4.
        val at: 3 put: ((rgb bitShift: -22) bitAnd: 16rFF).
        val at: 2 put: ((rgb bitShift: -12) bitAnd: 16rFF).
        val at: 1 put: ((rgb bitShift: -2) bitAnd: 16rFF).
        val at: 4 put: 16rFF.  "opaque alpha"
        ^ val normalize].

    "For the rest of the depths, pixelValue = 0 means transparent, and 
darkest blue is considered to be black."
    bitBltFakeBlack := 1.  "closest black that is not transparent in RGB 
- Not for depths <=8 (Indexed) or = 32 (RGBA)"

    d = 16 ifTrue: [
        "five bits per component; top bits ignored"
        val := (((rgb bitShift: -15) bitAnd: 16r7C00) bitOr:
             ((rgb bitShift: -10) bitAnd: 16r03E0)) bitOr:
             ((rgb bitShift: -5) bitAnd: 16r001F).
        ^ val = 0 ifTrue: [bitBltFakeBlack] ifFalse: [val]].

    d = 12 ifTrue: [  "for indexing a color map with 4 bits per color 
component"
        val := (((rgb bitShift: -18) bitAnd: 16r0F00) bitOr:
             ((rgb bitShift: -12) bitAnd: 16r00F0)) bitOr:
             ((rgb bitShift: -6) bitAnd: 16r000F).
        ^ val = 0 ifTrue: [bitBltFakeBlack] ifFalse: [val]].

    d = 9 ifTrue: [  "for indexing a color map with 3 bits per color 
component"
        val := (((rgb bitShift: -21) bitAnd: 16r01C0) bitOr:
             ((rgb bitShift: -14) bitAnd: 16r0038)) bitOr:
             ((rgb bitShift: -7) bitAnd: 16r0007).
        ^ val = 0 ifTrue: [bitBltFakeBlack] ifFalse: [val]].

    self error: 'unknown pixel depth: ', d printString

! !

!SimpleMIDIPort class methodsFor: '*People-spfa-fixes' stamp: 'spfa 11/25/2013 10:29'!
portDescription: portNum
	"Answer a string indicating the directionality of the given MIDI port."
	"(0 to: SimpleMIDIPort primPortCount - 1) collect:
		[:i | SimpleMIDIPort portDescription: i]"

	| portName dir |
	portName := (self primPortNameOf: portNum) "convertFromSystemString".
	dir := self primPortDirectionalityOf: portNum.
	dir = 1 ifTrue: [^ portName, ' (in)'].
	dir = 2 ifTrue: [^ portName, ' (out)'].
	dir = 3 ifTrue: [^ portName, ' (in/out)'].
	^ self error: 'unknown MIDI port directionality'
! !

!TestBrowser methodsFor: '*People-spfa-fixes' stamp: 'spfa 5/11/2017 13:50'!
privBuildButtonMorphOn: anObject getState: stateSymbol action: actionSymbol label: labelSymbol color: aColor

	| button row |
	button := PluggableButtonMorph
				on: anObject
				getState: stateSymbol
				action: actionSymbol
				label: labelSymbol.
	button 
		onColor: aColor offColor: aColor;
		borderWidth: 1;
		hResizing: #spaceFill;
		vResizing: #spaceFill.

	row := AlignmentMorph newRow
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutInset: 0;
		borderWidth: 0;
		addMorphBack: button.

	^row! !

!TestBrowser methodsFor: '*People-spfa-fixes' stamp: 'spfa 5/11/2017 13:50'!
privBuildLabelMorph: aSymbol

	| labelMorph row |
	labelMorph := PluggableButtonMorph
				on: nil
				getState: nil
				action: nil.
	labelMorph
		label: (self perform: aSymbol);
		onColor: self defaultLabelColor offColor: self defaultLabelColor;
		borderWidth: 1;
		feedbackColor: Color transparent;
		hResizing: #spaceFill;
		vResizing: #spaceFill.

	row := AlignmentMorph newRow
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutInset: 0;
		borderWidth: 0;
		addMorphBack: labelMorph.

	^row! !

!MIDIInputParser methodsFor: '*People-spfa-fixes' stamp: 'spfa 7/17/2017 18:59'!
processMIDIData
	"Process all MIDI data that has arrived since the last time this method was executed. This method should be called frequently to process, filter, and timestamp MIDI data as it arrives."

	| bytesRead |
	[(bytesRead := self midiPort readInto: rawDataBuffer) > 0] whileTrue: [
		timeNow := (midiPort bufferTimeStampFrom: rawDataBuffer)" - startTime".
		5 to: bytesRead do: [:i | self processByte: (rawDataBuffer at: i)]].
! !

!PolygonMorph methodsFor: '*People-spfa-fixes' stamp: 'spfa 11/18/2009 18:15'!
removeShortEndSegmentsStepping: something

	"used as a hook for on-the-fly conversion from a connector v1.9 to a connector 2.2"

	self maybeBecomeNCLineMorph.
	self removeShortEndSegmentsStepping: something! !

!ProportionalSplitterMorph methodsFor: '*People-spfa-fixes' stamp: 'spfa 3/31/2018 10:38'!
repositionBy: delta
	| selfTop selfBottom selfLeft selfRight |

	self setProperty: #fullDelta toValue: ((self valueOfProperty: #fullDelta) ifNil: [0@0]) + delta.

	leftOrTop do:
		[ : each | | firstRight firstBottom firstLeft firstTop |
		firstRight := each layoutFrame rightOffset ifNil: [ 0 ].
		firstBottom := each layoutFrame bottomOffset ifNil: [ 0 ].
		each layoutFrame rightOffset: firstRight + delta x.
		each layoutFrame bottomOffset: firstBottom + delta y.
		each layoutFrame hasFixedHeight ifTrue: [
			firstTop := each layoutFrame topOffset ifNil: [ 0 ].
			each layoutFrame topOffset: firstTop + delta y ].
		each layoutFrame hasFixedWidth ifTrue: [
			firstLeft := each layoutFrame leftOffset ifNil: [ 0 ].
			each layoutFrame leftOffset: firstLeft + delta x. ] ].
	rightOrBottom do:
		[ : each | | secondLeft secondTop secondRight secondBottom |
		secondLeft := each layoutFrame leftOffset ifNil: [ 0 ].
		secondTop := each layoutFrame topOffset ifNil: [ 0 ].
		each layoutFrame leftOffset: secondLeft + delta x.
		each layoutFrame topOffset: secondTop + delta y.
		each layoutFrame hasFixedHeight ifTrue: [
			secondBottom := each layoutFrame bottomOffset ifNil: [ 0 ].
			each layoutFrame bottomOffset: secondBottom + delta y. ].
		each layoutFrame hasFixedWidth ifTrue: [
			secondRight := each layoutFrame rightOffset ifNil: [ 0 ].
			each layoutFrame rightOffset: secondRight + delta x. ] ].

	selfTop := self layoutFrame topOffset ifNil: [ 0 ].
	selfBottom := self layoutFrame bottomOffset ifNil: [ 0 ].
	selfLeft := self layoutFrame leftOffset ifNil: [ 0 ].
	selfRight := self layoutFrame rightOffset ifNil: [ 0 ].
	self layoutFrame
		 topOffset: selfTop + delta y ;
		 bottomOffset: selfBottom + delta y ;
		 leftOffset: selfLeft + delta x ;
		 rightOffset: selfRight + delta x.
	self owner layoutChanged.
	self movements removeFirst; add: (splitsTopAndBottom ifTrue: [ delta y sign ] ifFalse: [ delta x sign ])! !

!FormCanvas methodsFor: '*People-spfa-fixes' stamp: 'spfa 4/30/2011 22:51'!
reset

	origin := 0@0.							"origin of the top-left corner of this cavas"
	clipRect := (0@0 corner: 100000@100000).		"default clipping rectangle"
	self shadowColor: nil.! !

!TestBrowser methodsFor: '*People-spfa-fixes' stamp: 'spfa 11/25/2016 13:34'!
runButtonColor

	^ Color blue duller muchLighter! !

!SmalltalkImage methodsFor: '*People-spfa-fixes' stamp: 'spfa 9/6/2012 21:08'!
saveAs
	"Put up the 'saveAs' prompt, obtain a name, and save the image  under that new name."
	
	self saveAs: (self getFileNameFromUser ifNil: [^ self])
! !

!ScrollPane methodsFor: '*People-spfa-fixes' stamp: 'spfa 5/11/2017 14:13'!
scrollBarThickness
	"Includes border"
	
	^ scrollBarThickness ifNil: [self class scrollBarThickness]! !

!MIDIFileReader class methodsFor: '*People-spfa-fixes' stamp: 'spfa 8/31/2013 16:38'!
standardMIDIInstrumentNames
	"Answer an array of Standard MIDI instrument names."

	^ #(
		'Grand Piano'
		'Bright Piano'
		'Electric Grand Piano'
		'Honky-tonk Piano'
		'Electric Piano 1'
		'Electric Piano 2'
		'Harpsichord'
		'Clavichord'
		'Celesta'
		'Glockenspiel'
		'Music Box'
		'Vibraphone'
		'Marimba'
		'Xylophone'
		'Tubular Bells'
		'Dulcimer'
		'Drawbar Organ'
		'Percussive Organ'
		'Rock Organ'
		'Church Organ'
		'Reed Organ'
		'Accordion'
		'Harmonica'
		'Tango Accordion'
		'Nylon Guitar'
		'Steel Guitar'
		'Electric Guitar 1'
		'Electric Guitar 2'
		'Electric Guitar 3'
		'Overdrive Guitar'
		'Distorted Guitar'
		'Guitar Harmonics'
		'Acoustic Bass'
		'Electric Bass 1'
		'Electric Bass 2'
		'Fretless Bass'
		'Slap Bass 1'
		'Slap Bass 2'
		'Synth Bass 1'
		'Synth Bass 2'
		'Violin'
		'Viola'
		'Cello'
		'Contrabass'
		'Tremolo Strings'
		'Pizzicato Strings'
		'Orchestral Harp'
		'Timpani'
		'String Ensemble 1'
		'String Ensemble 2'
		'Synth Strings 1'
		'Synth Strings 2'
		'Choir Ahhs'
		'Choir Oohs'
		'Synth Voice'
		'Orchestra Hit'
		'Trumpet'
		'Trombone'
		'Tuba'
		'Muted Trumpet'
		'French Horn'
		'Brass Section'
		'Synth Brass 1'
		'Synth Brass 2'
		'Soprano Sax'
		'Alto Sax'
		'Tenor Sax'
		'Baritone Sax'
		'Oboe'
		'English Horn'
		'Bassoon'
		'Clarinet'
		'Piccolo'
		'Flute'
		'Recorder'
		'Pan Flute'
		'Blown Bottle'
		'Shakuhachi'
		'Whistle'
		'Ocarina'
		'Lead 1 (square)'
		'Lead 2 (sawtooth)'
		'Lead 3 (calliope)'
		'Lead 4 (chiff)'
		'Lead 5 (charang)'
		'Lead 6 (voice)'
		'Lead 7 (fifths)'
		'Lead 8 (bass+lead)'
		'Pad 1 (new age)'
		'Pad 2 (warm)'
		'Pad 3 (polysynth)'
		'Pad 4 (choir)'
		'Pad 5 (bowed)'
		'Pad 6 (metallic)'
		'Pad 7 (halo)'
		'Pad 8 (sweep)'
		'FX 1 (rain)'
		'FX 2 (soundtrack)'
		'FX 3 (crystals)'
		'FX 4 (atmosphere)'
		'FX 5 (brightness)'
		'FX 6 (goblins)'
		'FX 7 (echoes)'
		'FX 8 (sci-fi)'
		'Sitar'
		'Banjo'
		'Shamisen'
		'Koto'
		'Kalimba'
		'Bagpipe'
		'Fiddle'
		'Shanai'
		'Tinkle Bell'
		'Agogo'
		'Steel Drum'
		'Woodblock'
		'Taiko Drum'
		'Melodic Tom'
		'Synth Drum'
		'Reverse Cymbal'
		'Guitar Fret Noise'
		'Breath Noise'
		'Seashore'
		'Bird Tweet'
		'Telephone Ring'
		'Helicopter'
		'Applause'
		'Gunshot')
! !

!Morph methodsFor: '*People-spfa-fixes' stamp: 'spfa 6/21/2017 21:47'!
startDragTarget: event

	"see senders"! !

!TextEditor methodsFor: '*People-spfa-fixes' stamp: 'spfa 4/1/2020 18:16'!
stateArray
	^ {ChangeText.
		FindText.
		history ifNil: [TextEditorCommandHistory new]. "Convert old instances"
		self markIndex to: self pointIndex - 1.
		self startOfTyping.
		emphasisHere.
		lastParenLocation}! !

!TextEditor methodsFor: '*People-spfa-fixes' stamp: 'spfa 4/1/2020 18:16'!
stateArrayPut: stateArray
	| sel |
	ChangeText := stateArray at: 1.
	FindText := stateArray at: 2.
	history := stateArray at: 3.
	sel := stateArray at: 4.
	self selectFrom: sel first to: sel last.
	beginTypeInIndex := stateArray at: 5.
	emphasisHere := stateArray at: 6.
	lastParenLocation := stateArray at: 7! !

!ProportionalSplitterMorph methodsFor: '*People-spfa-fixes' stamp: 'spfa 5/10/2018 16:23'!
step

	splitsTopAndBottom
		ifTrue: [ self reduceTopBottomImbalance ]
		ifFalse:
			[ self reduceLeftRightImbalance abs > 1 ifTrue:
				[ self splittersLeftDo:
					[ : splitter | splitter reduceLeftRightImbalance ].
				self splittersRightDo:
					[ : splitter | splitter reduceLeftRightImbalance ] ] ].

	self balanceOffsets.
	self setProperty: #fullDelta toValue: 0@0.
! !

!Rectangle methodsFor: '*People-spfa-fixes' stamp: 'spfa 11/18/2009 18:16'!
storeOn: aStream 
	
	aStream nextPut: $(.
	self printOn: aStream.
	aStream nextPut: $)! !

!TestBrowser methodsFor: '*People-spfa-fixes' stamp: 'spfa 4/19/2010 14:07'!
systemCategoryList

	^filterMode 
		ifFalse: 
			[systemCategoryList := (systemOrganizer categories 
						select: [:each | self pattern match: each]) asArray]
		ifTrue: 
			[systemCategoryList ifNil: 
					[| testCategories |
					testCategories := self allTestCaseClasses collect: [:each | each category].
					systemCategoryList := (testCategories asSet
								select: [:each | self pattern match: each]) asArray]
				ifNotNil: [systemCategoryList]]! !

!PitchEnvelope methodsFor: '*People-spfa-fixes' stamp: 'spfa 11/14/2017 13:42'!
updateTargetAt: mSecs
	"Update the pitch for my target. Answer true if the value changed."
	"Details: Assume envelope range is 0.0..2.0, with 1 being the center pitch. Subtracting one yields the range -1.0..1.0. Raising two to this power yields pitches between half and double the center pitch; i.e. from an octave below to an octave about the center pitch."

	| newValue |
	newValue := self valueAtMSecs: mSecs.
	newValue ~= lastValue ifTrue: [
		target pitch: (2.0 raisedTo: (newValue - 1.0) * scale) * centerPitch.
		lastValue := newValue.
		^ true].

	^ false
! !

!Object methodsFor: '*People-spfa-fixes' stamp: 'spfa 10/3/2019 18:10'!
wakeUpAsFreshCopyOf: anObject

	"The receiver has just been conjured as a copy of anObject. If something needs to be done for the receiver to live its clone life fully, do it here."! !

!PolygonMorph methodsFor: '*People-spfa-fixes' stamp: 'spfa 11/29/2015 21:37'!
wantsSteps
	(self == self topRendererOrSelf) ifTrue: [self player wantsSteps ifTrue: [^ true]].

	"For crawling ants effect of dashed line."
	borderDashSpec ifNil: [^false].
	^borderDashSpec size = 5 and: [(borderDashSpec fifth) > 0]! !
