


!MenuItemMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 5/20/2010 20:24'!
aboutToBeGrabbedBy: aHand
	"Don't allow the receiver to act outside a Menu"

	(owner notNil and:[owner submorphs size = 1]) ifTrue:[
		"I am a lonely menuitem already; just grab my owner"
		owner stayUp: true.
		^owner aboutToBeGrabbedBy: aHand].
	^ self asMenu 

	! !

!MenuMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 11/29/2016 19:33'!
activeSubmenu: aSubmenu 
	activeSubMenu ifNotNil: [
		((activeSubMenu bounds expandBy: 1@0) 
			containsPoint: World currentHand position) ifTrue: [
				^ self "makes transition from menu to submenu and back robust
				by preventing the small gap between them to have an effect"].
		activeSubMenu delete ].
	activeSubMenu := aSubmenu.
	activeSubMenu ifNotNil: [
		activeSubMenu updateMenu ]! !

!MenuMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 4/16/2015 18:15'!
add: aString subMenu: aMenuMorph target: target selector: aSymbol argumentList: argList
	"Append the given submenu with the given label."

	| item |
	item := MenuItemMorph new.
	item 
		contents: aString;
		target: target;
		selector: aSymbol;
		arguments: argList asArray;
		subMenu: aMenuMorph.
	self addMorphBack: item.

	target isMessageSend ifTrue: [item noWeakTarget].

	^item! !

!MenuMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 4/16/2015 18:15'!
add: aString target: target selector: aSymbol argumentList: argList
	"Append a menu item with the given label. If the item is selected, it will send the given selector to the target object with the given arguments. If the selector takes one more argument than the number of arguments in the given list, then the triggering event is supplied as as the last argument."

	| item |
	item := MenuItemMorph new
		contents: aString;
		target: target;
		selector: aSymbol;
		arguments: argList asArray.
	self addMorphBack: item.

	target isMessageSend ifTrue: [item noWeakTarget].! !

!MenuMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 11/18/2009 18:13'!
addCustomMenuItems: aCustomMenu hand: aHandMorph

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu addLine.
	aCustomMenu add: 'add title...' translated action: #addTitle.
	aCustomMenu add: 'set target...' translated action: #setTarget:.
	defaultTarget ifNotNil: [
		aCustomMenu add: 'add item...' translated action: #addItem].
	aCustomMenu add: 'add line' translated action: #addLine.
	(self items count:[:any| any hasSubMenu]) > 0
		ifTrue:[aCustomMenu add: 'detach submenu' translated action: #detachSubMenu:].
		
	aCustomMenu addLine;
		add: 'detaching a submenu' translated target: self class selector: #howToDetach! !

!MenuItemMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 5/20/2010 20:25'!
asMenu

	| menu |

	menu := MenuMorph new defaultTarget: nil.
	menu addMorphFront: self.
	menu bounds: self bounds.
	menu stayUp: true.
	
	menu thenAction: (self valueOfProperty: #then).
	menu defaultTarget: (self valueOfProperty: #target).
	self removeProperty: #then; removeProperty: #target.
	
	self isSelected: false.
	^menu! !

!MenuMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 11/29/2016 20:43'!
blueButtonDown: anEvent
	
	(self fullContainsPoint: anEvent position) ifFalse: [^ self].

	super blueButtonDown: anEvent! !

!MenuItemMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 5/11/2017 11:02'!
deselect: evt
	self isSelected: false.

	self subMenu ifNotNil: [
		owner ifNotNil:[owner activeSubmenu: nil. self deleteSubMenu].
		self removeAlarm: #deselectTimeOut:].! !

!MenuItemMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 11/25/2016 11:13'!
detach

	self setProperty: #then toValue: owner thenAction.
	self setProperty: #target toValue: owner defaultTarget.
	(self hasProperty: #standAloneLabel) 
		ifTrue: [self contents: (self valueOfProperty: #standAloneLabel)].
	self delete; topLeft: ActiveHand position.
	self extent: 0@ self extent y.
	ActiveHand grabMorph: self.
	self isSelected: false! !

!MenuMorph methodsFor: '*People-spfa-strip-menu' stamp: 'spfa 12/26/2016 17:59'!
detach

	self stayUp ifTrue: [^ self].

	popUpOwner ifNil: [^ self].

	ActiveHand submorphs ifNotEmpty: [^ self]. 

	popUpOwner isSelected: false.
	popUpOwner subMenu: nil. 
	popUpOwner owner forgetActiveSubmenu.
	
	(popUpOwner notNil & self hasTitle not) ifTrue: [
		self addTitle: ' ', popUpOwner contents, ' '].
	self addStayUpIcons.
	self popUpOwner: nil.
	self selectItem: nil event: nil.
	self stayUp: true.	
	
	self removeProperty: #hasUsedKeyboard.

	self topLeft: ActiveHand position.
	ActiveHand grabMorph: self

		
! !

!MenuMorph class methodsFor: '*People-spfa-strip-menu' stamp: 'spfa 11/18/2009 18:13'!
detachExample

	| example subExample1 subSubExample subExample2 |

	example := MenuMorph new.
	
	(subExample1 := MenuMorph new)
		add: 'dummy' action: nil;
		add: 'void' action: nil.
	
	(subSubExample := MenuMorph new)
		add: 'nope' action: nil;
		add: 'nada' action: nil;
		add: 'niet' action: nil.
	
	(subExample2 := MenuMorph new)
		add: 'useless' action: nil;
		add: 'more of it' subMenu: subSubExample.
		
	example
		add: 'sub 1' subMenu: subExample1;
		add: 'sub 2' subMenu: subExample2;
		add: 'that''s it' action: nil.
		
	example popUpInWorld! !

!MenuMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 11/29/2016 20:39'!
forgetActiveSubmenu

	activeSubMenu := nil.! !

!MenuMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 12/20/2016 12:28'!
handlePageDownStroke: evt

	evt keyValue = 12 ifFalse: [ ^false ].
	self detach.
	^true! !

!MenuMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 12/20/2016 12:27'!
handlePageUpStroke: evt

	evt keyValue = 11 ifFalse: [ ^false ].
	self detach.
	^true! !

!MenuMorph class methodsFor: '*People-spfa-strip-menu' stamp: 'spfa 11/18/2009 18:13'!
howToDetach

	'
	examples:
	
		MenuMorph detachExample "doIt for each example below"
	
	
	
	to detach the ''sub 1'' submenu, yellow click ''sub 1'' and drag to the right.
	to detach the ''sub 1'' item, blue click it twice and use the black halo.
	to detach ''that''s it'', yellow click it
	to detach the ''more of it'' submenu, yellow click ''more of it'' and drag to the right.
	to detach the ''more of it'' item, blue click it twice and use the black halo.
		
	' displayWithLabel: 'how to detach a submenu'! !

!MenuMorph methodsFor: '*People-spfa-strip-menu' stamp: 'spfa 11/10/2010 22:15'!
lastItemStandAloneLabel: aString

	self submorphs last setProperty: #standAloneLabel toValue: aString! !

!PasteUpMorph methodsFor: '*People-spfa-strip-menu' stamp: 'spfa 6/27/2017 22:11'!
morphAtPoint: aPoint above: aMorph

	self submorphsDo: [:m | 
		m == aMorph ifTrue: [^ nil].
		(m fullContainsPoint: aPoint) ifTrue: [^ m]].
	^nil! !

!MenuItemMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 10/2/2017 23:28'!
mouseDown: evt
	"Handle a mouse down event. Menu items get activated when the mouse is over them."

	(evt whichButton = 82 "ctrl + alt") ifTrue: [
		self subMenu ifNotNil: [^ self subMenu explore].
		^ self messageSend explore].

	(Preferences enableMenuDestructuring & evt yellowButtonPressed 
		and: [owner isSticky not]) ifTrue: [
			self hasSubMenu 
				ifFalse: [self detach. owner beSticky]
				ifTrue: [self subMenu detach]].

	(evt yellowButtonPressed not 
		and: [self actualSubMenu notNil] 
		and: [owner activeSubmenu == self actualSubMenu])
	ifTrue: [^ self deselect: evt].

	evt shiftPressed ifTrue: [^ super mouseDown: evt].  "enable label editing" 
	evt hand newMouseFocus: owner. "Redirect to menu for valid transitions"
	owner selectItem: self event: evt. 
! !

!MenuMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 11/29/2016 21:42'!
mouseDown: evt
	"Handle a mouse down event."

	evt yellowButtonPressed ifTrue: [^ self].
	
	(stayUp or:[self fullContainsPoint: evt position]) 
		ifFalse:[^self deleteIfPopUp: evt]. "click outside"
	self isSticky ifTrue: [^self].
	(self fullContainsPoint: evt position) ifFalse: [
		evt wasHandled: false.
		^ self].

	self selectedItem ifNotNil: [
		((self selectedItem fullBounds expandBy: 0@2) containsPoint: evt position)
			ifTrue: [^ self selectedItem mouseUp: evt]].

	"Grab the menu and drag it to some other place"
	self hasDropShadow: false.
	evt hand grabMorph: self.! !

!MenuItemMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 12/13/2017 14:08'!
mouseEnterDragging: evt
	"The mouse entered the receiver. Do nothing if we're not in a 'valid menu transition', meaning that the current hand focus must be aimed at the owning menu."

	evt hand submorphs notEmpty ifTrue: [^ self].

	(Preferences enableMenuDestructuring
		& evt yellowButtonPressed) ifTrue: [^ owner detach].
	
	((evt hand mouseFocus == owner)
		or: [owner popUpOwner notNil]
		or: [World submorphs noneSatisfy: [:m | 
				m isMenu and: [m popUpOwner notNil]]])
	ifTrue:[owner selectItem: self event: evt]! !

!MenuItemMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 5/11/2017 11:03'!
mouseLeaveDragging: evt 
	"The mouse left the receiver. Do nothing if we're not in a 'valid menu transition', meaning that the current hand focus must be aimed at the owning menu."

	owner ifNil: [^self].
	evt hand mouseFocus == owner ifFalse: [ ^self ].

	owner selectItem: nil event: evt! !

!MenuMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 12/13/2017 14:09'!
mouseMove: evt

	evt hand submorphs notEmpty ifTrue: [^ self].

	"Do not allow items to be selected when they are hidden from view"
	(World morphAtPoint: evt position above: self) ifNotNil: [:m |
		(m isMenu or: [self hasOwner: m]) ifFalse: [
			^ World currentHand releaseMouseFocus]].

	" If the mouse moves over an item not selected, we try to set it as selected.
	If this happens depends on that the current selected item wants to release
	its selection. "

	self selectedItem ifNil: [
		self 
			selectItem: (
				self items 
					detect: [ :each | (each containsPoint: evt position)] 
					ifNone: [ nil ])
			event: evt].

	"Transfer control to *either* the currently active submenu or the pop up owner, if any. Since the active sub menu is always displayed upfront check it first."	
	self selectedItem ifNotNil: [
		(self selectedItem activateSubmenu: evt) 
			ifTrue: [ ^self ]
			ifFalse: [ 
				(self containsPoint: evt position) ifFalse: [ 
					self selectItem: nil event: evt ]] ].

	(self containsPoint: evt position) ifTrue: [^ self].

	"Note: The following does traverse upwards, see #activateOwnerMenu:"
	popUpOwner ifNotNil:[(popUpOwner activateOwnerMenu: evt) ifTrue: [^ self]].
! !

!MenuItemMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 8/12/2010 22:07'!
mouseUp: evt
	"Handle a mouse up event. Menu items get activated when the mouse is over them. Do nothing if we're not in a 'valid menu transition', meaning that the current hand focus must be aimed at the owning menu."
	evt hand mouseFocus == owner ifFalse:[^self].

	(self actualSubMenu notNil
		and: [owner activeSubmenu == self actualSubMenu]
		and: [owner stayUp]) ifTrue: [^ self].

	self contentString ifNotNil:[
		self contents: self contentString withMarkers: true inverse: true.
		self refreshWorld.
		(Delay forMilliseconds: 200) wait].
	self deselect: evt.
	self invokeWithEvent: evt.		
! !

!MenuMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 6/27/2017 22:58'!
popUpAdjacentTo: rightOrLeftPoint forHand: hand from: sourceItem 
	"Present this menu at the given point under control of the given  
	hand."
	| delta tryToPlace selectedOffset |
	hand world startSteppingSubmorphsOf: self.
	popUpOwner := sourceItem.
	self fullBounds.
	self updateColor.
	"ensure layout is current"
	selectedOffset := (selectedItem
				ifNil: [(self items ifEmpty: [^ self]) middle]) position - self position.
	tryToPlace := [:where :mustFit | 
			self position: where - selectedOffset.
			delta := self fullBoundsInWorld amountToTranslateWithin: World bounds.
			(delta x = 0
					or: [mustFit])
				ifTrue: [delta = (0 @ 0)
						ifFalse: [self position: self position + delta].
					self addFrontTo: World.
					^ self]].
	tryToPlace value: rightOrLeftPoint first value: false;
		 value: rightOrLeftPoint last - (self width - 20 @ 0) value: false;
		 value: rightOrLeftPoint first value: true! !

!MenuMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 1/28/2016 10:44'!
popUpAt: aPoint forHand: hand in: aWorld allowKeyboard: aBoolean 
	"Present this menu at the given point under control of the given 
	hand."
	| evt |
	aWorld submorphs
		select: [:each | (each isKindOf: MenuMorph)
				and: [each stayUp not]]
		thenCollect: [:menu | menu delete].
	self items isEmpty
		ifTrue: [^ self].
	MenuIcons decorateMenu: self.
	(self submorphs
		select: [:m | m isKindOf: UpdatingMenuItemMorph])
		do: [:m | m updateContents].
	"precompute width"
	self
		positionAt: aPoint + (1@3)
		relativeTo: (selectedItem
				ifNil: [self items first])
		inWorld: aWorld.
	self addFrontTo: aWorld.
	"Acquire focus for valid pop up behavior"
	hand newMouseFocus: self.
	aBoolean
		ifTrue: [hand newKeyboardFocus: self.
			self showKeyboardHelp].
	evt := hand lastEvent.
	(evt isKeyboard
			or: [evt isMouse
					and: [evt anyButtonPressed not]])
		ifTrue: ["Select first item if button not down"
			self moveSelectionDown: 1 event: evt
			"Select first item if button not down"].
	self updateColor.
	self changed! !

!MenuMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 8/12/2010 17:05'!
removeStayUpBox
	| box |
	submorphs isEmpty ifTrue: [^self].
	(submorphs first isAlignmentMorph) ifFalse: [^self].
	box := submorphs first submorphs last.
	(box isKindOf: IconicButton) 
		ifTrue: 
			[box delete]! !

!MenuItemMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 8/17/2012 14:41'!
topOwnerMenu

	(owner popUpOwner ifNil: [^ owner]) topOwnerMenu! !

!MenuItemMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 5/11/2017 11:01'!
veryDeepInner: deepCopier 
	"Copy all of my instance variables. Some need to be not copied  
	at all, but shared. Warning!!!! Every instance variable defined in  
	this class must be handled. We must also implement  
	veryDeepFixupWith:. See DeepCopier class comment."
	super veryDeepInner: deepCopier.
	isEnabled := isEnabled veryDeepCopyWith: deepCopier.
	subMenu := subMenu veryDeepCopyWith: deepCopier.
	isSelected := isSelected veryDeepCopyWith: deepCopier.
	icon := icon veryDeepCopyWith: deepCopier.
	"target := target.		Weakly copied"
	"selector := selector.		a Symbol"
	arguments := arguments veryDeepCopyWith: deepCopier.! !

!MenuMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 11/18/2009 18:13'!
wantsToBeDroppedInto: aMorph
	"Return true if it's okay to drop the receiver into aMorph.  A single-item MenuMorph is in effect a button rather than a menu, and as such should not be reluctant to be dropped into another object."

	^ (aMorph isWorldMorph or: [submorphs size == 1]) or:
		[Preferences systemWindowEmbedOK] or:
		[aMorph wantsDroppedMenu]
! !
