SystemOrganization addCategory: #PluggableMemory!
SystemOrganization addCategory: #'PluggableMemory-Tests'!


TestCase subclass: #PluggableMemoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PluggableMemory-Tests'!

BorderedMorph subclass: #WheelMorph
	instanceVariableNames: 'target actionSelector factor circular old angle maxAngle lastRedraw'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PluggableMemory'!

WheelMorph class
	instanceVariableNames: ''!

LegacyTextMorphEditor subclass: #PluggableMemory
	instanceVariableNames: 'environment bindings history'
	classVariableNames: 'Memories'
	poolDictionaries: ''
	category: 'PluggableMemory'!

OrderedCollection subclass: #InteractionHistory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PluggableMemory'!

InteractionHistory class
	instanceVariableNames: ''!

RectangleMorph subclass: #LegacyFillInTheBlankMorph
	instanceVariableNames: 'response done textPane responseUponCancel'
	classVariableNames: 'RoundedDialogCorners'
	poolDictionaries: ''
	category: 'PluggableMemory'!

LegacyFillInTheBlankMorph subclass: #MemoryInteractionMorph
	instanceVariableNames: 'memory dh'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PluggableMemory'!

LegacyFillInTheBlankMorph class
	instanceVariableNames: ''!

MemoryInteractionMorph class
	instanceVariableNames: ''!

PluggableMemory class
	instanceVariableNames: ''!

PluggableMemoryTest class
	instanceVariableNames: ''!


!WheelMorph commentStamp: '<historical>' prior: 0!
A thumb wheel widget control!
]style[(28)!

!LegacyFillInTheBlankMorph methodsFor: 'menu' stamp: 'spfa 11/28/2016 11:02'!
accept
	"Sent by the accept button."

	textPane accept.
! !

!WheelMorph methodsFor: 'accessing' stamp: 'ti 3/13/2000 12:56'!
actionSelector
	^ actionSelector
! !

!WheelMorph methodsFor: 'accessing' stamp: 'ti 3/13/2000 12:57'!
actionSelector: aSymbolOrString

	(nil = aSymbolOrString or:
	 ['nil' = aSymbolOrString or:
	 [aSymbolOrString isEmpty]])
		ifTrue: [^ actionSelector := nil].

	actionSelector := aSymbolOrString asSymbol.

! !

!WheelMorph methodsFor: 'private' stamp: 'ti 3/20/2000 15:58'!
addAngle: aNumber
	| new |
	new := self angle + aNumber.
	self isCircular ifTrue: [new := new \\ self maxAngle].
	self angle: new.
	lastRedraw := lastRedraw + aNumber.
	(lastRedraw abs > 2) ifTrue: [
		lastRedraw := 0.
		self changed]! !

!InteractionHistory methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
addFirst: aString

	| entry |

	entry := aString withBlanksTrimmed.

	(self includes: entry) ifFalse: [^ super addFirst: entry].

	^ false! !

!Object methodsFor: '*PluggableMemory' stamp: 'spfa 4/3/2010 18:09'!
addItemsToREPLMenu: aMenu

! !

!PluggableMemory methodsFor: 'REPL' stamp: 'spfa 10/18/2018 11:22'!
addItemsToREPLMenu: aMenu

	self bindingEnvironment addItemsToREPLMenu: aMenu
! !

!WheelMorph methodsFor: 'accessing' stamp: 'ti 3/19/2000 11:32'!
angle
	^angle! !

!WheelMorph methodsFor: 'accessing' stamp: 'ti 3/19/2000 11:33'!
angle: aNumber
	angle := aNumber! !

!InteractionHistory methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:10'!
atIndex: aNumber

	^ self at: (aNumber asInteger - 1 \\ self size) + 1! !

!WheelMorph methodsFor: 'properties' stamp: 'ti 3/20/2000 13:18'!
beCircular
	circular := true! !

!WheelMorph methodsFor: 'properties' stamp: 'bf 3/23/2000 18:34'!
beHorizontal
	self isHorizontal
		ifFalse: [self extent: self extent transposed] ! !

!WheelMorph methodsFor: 'properties' stamp: 'ti 3/20/2000 13:19'!
beLinear
	circular := false! !

!WheelMorph methodsFor: 'properties' stamp: 'bf 3/23/2000 18:34'!
beVertical
	self isHorizontal
		ifTrue: [self extent: self extent transposed] ! !

!PluggableMemory methodsFor: 'accessing' stamp: 'spfa 9/9/2019 21:50'!
bindingEnvironment

	^ (environment ifNil: [^ nil]) first! !

!PluggableMemory methodsFor: 'accessing' stamp: 'spfa 6/24/2019 18:36'!
bindingEnvironment: anObject

	environment := WeakArray with: anObject! !

!PluggableMemory methodsFor: 'as yet unclassified' stamp: 'spfa 9/12/2019 21:41'!
bindingOf: aString

	| b |

	b := [self bindingEnvironment bindingOf: aString] on: Error do: [nil].
	b ifNotNil: [^ b].

	(self bindings includesKey: aString) ifFalse: [
		"dynamic binding"
		b := self defineBindingWithKey: aString.
		(b isAssociation and: [b key = aString]) ifFalse: ["do not record". ^ aString -> b].
		self bindings add: b].

	^ self bindings associationAt: aString! !

!PluggableMemory methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:15'!
bindings

	^ bindings ifNil: [bindings := Dictionary new]! !

!PluggableMemory methodsFor: 'accessing' stamp: 'spfa 4/3/2010 18:44'!
bindings: aDictionary

	bindings := aDictionary ! !

!LegacyFillInTheBlankMorph methodsFor: 'MuO-PasteUps' stamp: 'spfa 1/17/2017 09:54'!
canBeDroppedInField: aZoomableField

	^ false! !

!LegacyFillInTheBlankMorph methodsFor: 'menu' stamp: 'spfa 11/28/2016 11:02'!
cancel
	"Sent by the cancel button."

	response := responseUponCancel.
	done := true.
! !

!LegacyFillInTheBlankMorph methodsFor: 'menu' stamp: 'spfa 11/28/2016 11:02'!
codePaneMenu: aMenu shifted: shifted

	^ StringHolder codePaneMenu: aMenu shifted: shifted.
! !

!PluggableMemory methodsFor: 'as yet unclassified' stamp: 'spfa 10/18/2018 11:23'!
compilationReceiver

	^ self isTransparent ifTrue: [self bindingEnvironment] ifFalse: [nil]
! !

!PluggableMemory methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:15'!
compile: aString onErrorDo: aBlock

	^ (self changeParagraph: aString asParagraph) compileOrFailWith: aBlock! !

!PluggableMemory methodsFor: 'as yet unclassified' stamp: 'spfa 11/7/2010 16:47'!
compileOrFailWith: aBlock

	^ Compiler new evaluate: paragraph string 
			in: "thisContext sender" nil 
			to: (self compilationReceiver)
			notifying: self 
			ifFail: aBlock logged: false.! !

!LegacyFillInTheBlankMorph methodsFor: 'object fileIn' stamp: 'spfa 11/28/2016 11:02'!
convertToCurrentVersion: varDict refStream: smartRefStrm
	
	varDict at: 'responseUponCancel' ifAbsent: [responseUponCancel := ''].
	^super convertToCurrentVersion: varDict refStream: smartRefStrm.

! !

!LegacyFillInTheBlankMorph methodsFor: 'initialization' stamp: 'spfa 8/3/2022 10:10'!
createAcceptButton
	"create the [accept] button"

	^ self createButton: 'Accept' 
		position: #right offset: -10 
		selector: #accept 
		color: ColorTheme current okColor
! !

!MemoryInteractionMorph methodsFor: 'as yet unclassified' stamp: 'spfa 8/3/2022 10:53'!
createAcceptButton

	^ self createButton: 'Accept' 
		position: #middleRight offset: -10 
		selector: #accept 
		color: ColorTheme current okColor
! !

!MemoryInteractionMorph methodsFor: 'as yet unclassified' stamp: 'spfa 8/3/2022 10:50'!
createBindingsButton

	^ self createButton: 'B' 
		position: #rightAsLeft offset: -18
		target: memory bindings
		selector: #explore 
		color: Color lightGreen
! !

!LegacyFillInTheBlankMorph methodsFor: 'initialization' stamp: 'spfa 8/3/2022 10:36'!
createButton: aString position: pSymbol offset: anInteger selector: aSymbol color: aColor

	^ self createButton: aString position: pSymbol offset: anInteger target: self selector: aSymbol color: aColor! !

!LegacyFillInTheBlankMorph methodsFor: 'initialization' stamp: 'spfa 8/3/2022 10:36'!
createButton: aString position: pSymbol offset: anInteger target: anObject selector: aSymbol color: aColor

	| result frame |

	result := SimpleButtonMorph newWithRoundedCorner target: anObject; color: aColor.
	result borderColor: (Preferences menuAppearance3d
				ifTrue: [#raised]
				ifFalse: [result color twiceDarker]).
	result label: aString translated; actionSelector: aSymbol.
	result setNameTo: aString.

	frame := LayoutFrame new.
	pSymbol caseOf: {
		[#middleRight] -> [frame rightFraction: 0.5; rightOffset: anInteger].
		[#middleLeft] -> [frame leftFraction: 0.5; leftOffset: anInteger].
		[#rightAsLeft] -> [frame leftFraction: 1.0; leftOffset: anInteger].
		[#left] -> [frame leftFraction: 0.0; leftOffset: anInteger].
		[#right] -> [frame rightFraction: 1.0; rightOffset: anInteger].
	}.
	frame topFraction: 1.0; topOffset: -22.
	result layoutFrame: frame.

	self addMorph: result.
	self updateColor: result color: result color intensity: 2.

	^ result! !

!LegacyFillInTheBlankMorph methodsFor: 'initialization' stamp: 'spfa 8/3/2022 10:30'!
createCancelButton
	"create the [cancel] button"

	^ self createButton: 'Cancel' 
		position: #middleLeft offset: 10 
		selector: #cancel 
		color: ColorTheme current cancelColor! !

!MemoryInteractionMorph methodsFor: 'as yet unclassified' stamp: 'spfa 8/3/2022 10:38'!
createHistoryButton

	^ self createButton: 'H' 
		position: #left offset: 2 
		target: memory history
		selector: #explore 
		color: Color lightGreen
! !

!MemoryInteractionMorph methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:13'!
createHistoryWheel

	| result frame |
	result := WheelMorph new beVertical.
	result extent: 20 @ 65.

	result target: self; actionSelector: #scrollHistoryBy:; factor: 0.2.

	frame := LayoutFrame new.
	frame topFraction: 0.15;
		leftFraction: 0.9;
		 rightFraction: 1;
"		 rightOffset: -2;"
		 bottomFraction: 0.75.
	result layoutFrame: frame.
	self addMorph: result.

	^ result! !

!LegacyFillInTheBlankMorph methodsFor: 'initialization' stamp: 'spfa 11/28/2016 11:02'!
createQueryTextMorph: queryString 
	"create the queryTextMorph"
	| result frame |
	result := TextMorph new contents: queryString.
	result setNameTo: 'query' translated.
	result lock.
	frame := LayoutFrame new.
	frame topFraction: 0.0;
		 topOffset: 2.
	frame leftFraction: 0.5;
		 leftOffset: (result width // 2) negated.
	result layoutFrame: frame.
	self addMorph: result.
	^ result! !

!LegacyFillInTheBlankMorph methodsFor: 'initialization' stamp: 'spfa 11/28/2016 11:02'!
createTextPaneExtent: answerExtent acceptBoolean: acceptBoolean topOffset: topOffset buttonAreaHeight: buttonAreaHeight 
	"create the textPane"
	| result frame |
	result := PluggableTextMorph
				on: self
				text: #response
				accept: #response:
				readSelection: #selectionInterval
				menu: #codePaneMenu:shifted:.
	result 
		extent: answerExtent;
		alwaysShowScrollBars: false;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		borderWidth: 1;
		hasUnacceptedEdits: true;
		acceptOnCR: acceptBoolean;
		setNameTo: 'textPane'.
	frame := LayoutFrame new
				leftFraction: 0.0;
		 		rightFraction: 1.0;
		 		topFraction: 0.0;
		 		topOffset: topOffset;
		 		bottomFraction: 1.0;
		 		bottomOffset: buttonAreaHeight negated;
				yourself.
	result layoutFrame: frame.
	self addMorph: result.
	^ result! !

!MemoryInteractionMorph methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:13'!
createTextPaneExtent: answerExtent acceptBoolean: acceptBoolean topOffset: topOffset buttonAreaHeight: buttonAreaHeight 
	"create the textPane"
	| result frame |
	result := PluggableTextMorph
				on: self
				text: #response
				accept: #response:
				readSelection: #selectionInterval
				menu: #codePaneMenu:shifted:.
	result extent: answerExtent.
	result hResizing: #spaceFill;
		 vResizing: #spaceFill.
	result borderWidth: 1.
	result hasUnacceptedEdits: true.
	result acceptOnCR: acceptBoolean.
	result setNameTo: 'textPane'.
	frame := LayoutFrame new.
	frame leftFraction: 0.0;
		 rightFraction: 0.9;
		 topFraction: 0.0;
		 topOffset: topOffset;
		 bottomFraction: 1.0;
		 bottomOffset: buttonAreaHeight negated.
	result layoutFrame: frame.
	self addMorph: result.
	^ result! !

!LegacyFillInTheBlankMorph class methodsFor: 'default constants' stamp: 'spfa 11/28/2016 11:02'!
defaultAnswerExtent
	^  (200@60 * (Preferences standardMenuFont height / 12)) rounded! !

!LegacyFillInTheBlankMorph methodsFor: 'initialization' stamp: 'spfa 11/28/2016 11:02'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color white! !

!PluggableMemory methodsFor: 'as yet unclassified' stamp: 'spfa 9/12/2019 21:46'!
defineBindingWithKey: aString

	"Dynamic binding: return either an associatio with aString as the key, which will then be stored as the permanent binding for aString, or return any other object; which will be considered as the value bound to aString just for this time."

	"Here we bind to nil any unbound symbol - this behavior is expected by many users of PluggableMemory. Subclasses may implement a different behavior"

	^ aString -> nil! !

!LegacyFillInTheBlankMorph methodsFor: 'initialization' stamp: 'spfa 11/28/2016 11:02'!
delete

	self breakDependents.
	super delete.! !

!PluggableMemory class methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:15'!
dictionary

	^ Memories! !

!WheelMorph methodsFor: 'event handling' stamp: 'ti 3/19/2000 17:03'!
doTargetAction: cursorPoint
	| new delta |
	self isHorizontal
		ifTrue: [new := cursorPoint x]
		ifFalse: [new := cursorPoint y].
	delta := new - old.
	delta isZero ifTrue: [^self].
	self addAngle: delta.
	(target ~~ nil and: [actionSelector ~~ nil]) ifTrue: [
		Cursor normal showWhile: [
			target perform: actionSelector withArguments: (Array with: (delta * self factor))]].
	old := new.
! !

!MemoryInteractionMorph class methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:13'!
editor: aPlugglableMemory

	^ self new memory:  aPlugglableMemory
! !

!TextMorph methodsFor: '*PluggableMemory' stamp: 'spfa 11/18/2009 18:17'!
editor: anObject
	editor := anObject! !

!TextMorphForEditView methodsFor: '*PluggableMemory' stamp: 'spfa 11/18/2009 18:17'!
editor: anObject

	(editor notNil and: [editor isPermanent]) ifTrue: [^ self].
	editor := anObject! !

!PluggableMemory methodsFor: 'REPL' stamp: 'spfa 10/18/2018 11:23'!
environmentName

	^ self bindingEnvironment knownName ifNil: [self bindingEnvironment name]! !

!PluggableMemory methodsFor: 'REPL' stamp: 'spfa 9/9/2019 21:50'!
evalString: aString

	(self bindingEnvironment notNil
			and: [self bindingEnvironment handlesEvalString]) 
		ifTrue: [^ self bindingEnvironment evalString: aString].

	^ self compile: aString onErrorDo: ['evaluation error']! !

!PluggableMemory methodsFor: 'REPL' stamp: 'spfa 4/2/2010 09:19'!
evalString: aString notifying: requestor
	^ self evalString: aString! !

!PluggableMemory methodsFor: 'REPL' stamp: 'spfa 11/18/2009 18:15'!
evalText: aText from: aPluggableTextMorph

	self evalString: aText asString.
	aPluggableTextMorph hasUnacceptedEdits: false.! !

!Object methodsFor: '*PluggableMemory' stamp: 'spfa 11/18/2009 18:15'!
evaluate: aString onError: aBlock

	^ (PluggableMemory for: self) compile: aString onErrorDo: aBlock! !

!WheelMorph class methodsFor: 'examples' stamp: 'ti 3/24/2000 17:33'!
example
	"See B3DSceneExplorerMorph>>initialize for usage."
	"WheelMorph example"

	B3DSceneExplorerMorph new openInWorld! !

!LegacyFillInTheBlankMorph methodsFor: 'geometry' stamp: 'spfa 11/28/2016 11:02'!
extent: aPoint 
	"change the receiver's extent"

	super extent: aPoint .
	self setDefaultParameters.
	self updateColor! !

!WheelMorph methodsFor: 'accessing' stamp: 'ti 3/19/2000 17:02'!
factor
	^factor! !

!WheelMorph methodsFor: 'accessing' stamp: 'ti 3/19/2000 17:03'!
factor: aFloat
	factor := aFloat! !

!PluggableMemory class methodsFor: 'as yet unclassified' stamp: 'spfa 10/18/2018 11:22'!
for: anObject

	(Memories includesKey: anObject) ifTrue: [^ Memories at: anObject].
	
	^ Memories at: anObject 
		put: (self allInstances detect: [:pm | pm bindingEnvironment == anObject]
			ifNone: [self new bindingEnvironment: anObject])
! !

!PluggableMemory methodsFor: 'accessing' stamp: 'spfa 2/6/2017 23:33'!
forget: anObject

	self bindings removeKeyAtValue: anObject! !

!PluggableTextMorph methodsFor: '*PluggableMemory' stamp: 'spfa 11/18/2009 18:15'!
getTextSelector: anObject
	getTextSelector := anObject! !

!LegacyFillInTheBlankMorph methodsFor: 'invoking' stamp: 'spfa 11/28/2016 11:02'!
getUserResponse
	"Wait for the user to accept or cancel, and answer the result string. Answers the empty string if the user cancels."
	"Details: This is invoked synchronously from the caller. In order to keep processing inputs and updating the screen while waiting for the user to respond, this method has its own version of the World's event loop."

	| w |
	w := self world.
	w ifNil: [^ response].
	
	(ProvideAnswerNotification signal:
		(self submorphOfClass: TextMorph) userString) ifNotNil:
		[:answer |
		self delete.
		w doOneCycle.
		^ response := (answer == #default) ifTrue: [response] ifFalse: [answer]].

	done := false.
	w activeHand newKeyboardFocus: textPane.
	[done] whileFalse: [w doOneCycle].
	self delete.
	w doOneCycle.
	^ response
! !

!MemoryInteractionMorph methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:13'!
getUserResponse

	memory changeParagraph: textPane textMorph paragraph.
	memory morph: textPane textMorph.
	textPane textMorph editor: memory. 

	^ super getUserResponse

! !

!Object methodsFor: '*PluggableMemory' stamp: 'spfa 4/2/2010 09:23'!
handlesEvalString

	"answer true if the receiver implements #evalString: and thus handles the evaluation process by itself, by passinf the Compiler"

	^ false
	! !

!LegacyFillInTheBlankMorph methodsFor: 'event handling' stamp: 'spfa 11/28/2016 11:02'!
handlesMouseDown: evt
	^true! !

!WheelMorph methodsFor: 'event handling' stamp: 'ti 3/19/2000 14:50'!
handlesMouseDown: evt
	^true
! !

!Object methodsFor: '*PluggableMemory' stamp: 'spfa 10/24/2017 00:44'!
hasPMBindingFor: anObject

	^ self pluggableMemory notNil
		and: [self pluggableMemory bindings values identityIncludes: anObject]! !

!PluggableMemory methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:15'!
history

	^ history ifNil: [history := InteractionHistory new]! !

!LegacyFillInTheBlankMorph methodsFor: 'initialization' stamp: 'spfa 11/28/2016 11:02'!
initialize

	super initialize.
	self setDefaultParameters.
	self extent: 400 @ 150.
	responseUponCancel := ''.
	self class roundedDialogCorners ifTrue: [self useRoundedCorners].
	! !

!PluggableMemory class methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:15'!
initialize

	"PluggableMemory initialize"

	Memories  := WeakKeyDictionary new.! !

!WheelMorph methodsFor: 'initialization' stamp: 'HilaireFernandes 1/27/2008 10:22'!
initialize
	super initialize.
	self target: nil.
	self actionSelector: #flash.
	self angle: 0.
	self maxAngle: 360.
	self factor: 1.0.
	self extent: 100@23.
	self beCircular.
	self borderColor: #raised.
	self borderWidth: 1.
	self color: Color lightGray.
	lastRedraw := 0.! !

!TextMorph methodsFor: '*PluggableMemory-override' stamp: 'spfa 11/18/2009 18:17'!
installEditorToReplace: priorEditor
	"Install an editor for my paragraph.  This constitutes 'hasFocus'.
	If priorEditor is not nil, then initialize the new editor from its state.
	We may want to rework this so it actually uses the prior editor."

	| stateArray |
	priorEditor ifNotNil: [stateArray := priorEditor stateArray].
	self editor: (self editorClass new morph: self).
	editor changeParagraph: self paragraph.
	priorEditor ifNotNil: [editor stateArrayPut: stateArray].
	self selectionChanged.
	^ editor! !

!WheelMorph methodsFor: 'properties' stamp: 'ti 3/20/2000 13:19'!
isCircular
	^circular! !

!WheelMorph methodsFor: 'properties' stamp: 'bf 3/23/2000 18:26'!
isHorizontal
	^ bounds isWide! !

!WheelMorph methodsFor: 'properties' stamp: 'ti 3/20/2000 13:19'!
isLinear
	^circular not! !

!ParagraphEditor methodsFor: '*PluggableMemory' stamp: 'spfa 11/18/2009 18:15'!
isPermanent

	^ false! !

!PluggableMemory methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:15'!
isPermanent

	^ true! !

!SmalltalkEditor methodsFor: '*PluggableMemory' stamp: 'spfa 4/15/2010 20:34'!
isPermanent

	^ false! !

!PluggableMemory methodsFor: 'as yet unclassified' stamp: 'spfa 9/9/2019 21:50'!
isTransparent

	^ (self bindingEnvironment ifNil: [^ false]) wantsTransparentPM! !

!WheelMorph methodsFor: 'properties' stamp: 'ti 3/22/2000 19:12'!
isVertical
	^self isHorizontal not! !

!WheelMorph methodsFor: 'accessing' stamp: 'ti 3/19/2000 11:35'!
maxAngle
	^maxAngle! !

!WheelMorph methodsFor: 'accessing' stamp: 'ti 3/19/2000 11:35'!
maxAngle: aNumber
	maxAngle := aNumber! !

!MemoryInteractionMorph methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:13'!
memory: anObject
	memory := anObject! !

!LegacyFillInTheBlankMorph methodsFor: 'invoking' stamp: 'spfa 11/28/2016 11:02'!
morphicLayerNumber

	^10.6! !

!LegacyFillInTheBlankMorph methodsFor: 'event handling' stamp: 'spfa 11/28/2016 11:02'!
mouseDown: evt
	(self containsPoint: evt position) ifFalse:[^ Beeper beep]. "sent in response to outside modal click"
	evt hand grabMorph: self. "allow repositioning"! !

!WheelMorph methodsFor: 'event handling' stamp: 'ti 3/19/2000 14:51'!
mouseMove: evt
	(evt anyButtonPressed)
		ifTrue: [self doTargetAction: evt cursorPoint]! !

!Object methodsFor: '*PluggableMemory' stamp: 'spfa 12/3/2017 11:25'!
openInteractionNotebook

	(PluggableMemory for: self) openInteractionNotebook
		setProperty: #oref toValue: self "needed if no other reference to the receiver exists"! !

!PluggableMemory methodsFor: 'REPL' stamp: 'spfa 12/3/2017 11:23'!
openInteractionNotebook

	^ ((Notebook on: self) 
		inSystemWindowLabelled: 'interaction with ', self environmentName)
	openInWorld! !

!PluggableMemory methodsFor: 'REPL' stamp: 'spfa 12/3/2017 15:19'!
openInteractionNotebookLabelled: aString contents: aText

	^ self openInteractionNotebookOfClass: Notebook labelled: aString contents: aText
! !

!PluggableMemory methodsFor: 'REPL' stamp: 'spfa 12/3/2017 15:18'!
openInteractionNotebookOfClass: aClass labelled: aString contents: aText

	^ self openInteractionNotebookOfClass: aClass labelled: aString contents: aText evaluate: false! !

!PluggableMemory methodsFor: 'REPL' stamp: 'spfa 12/3/2017 15:18'!
openInteractionNotebookOfClass: aClass labelled: aString contents: aText evaluate: aFlag

	| nb |

	(nb := aClass on: self) addStringContents: aText..
	aFlag ifTrue: [nb evaluate].
	^ (nb inSystemWindowLabelled: aString) openInWorld! !

!PluggableMemory methodsFor: 'REPL' stamp: 'spfa 12/3/2017 15:19'!
openInteractionNotebookWithContents: aText

	^ self openInteractionNotebookLabelled: 'interaction with ', self environmentName 
		contents: aText! !

!Object methodsFor: '*PluggableMemory' stamp: 'spfa 11/18/2009 18:15'!
openInteractionWindow

	(PluggableMemory for: self) openInteractionWindow! !

!PluggableMemory methodsFor: 'REPL' stamp: 'spfa 10/24/2017 14:06'!
openInteractionWindow

	| w |

	w := SystemWindow labelled: 'interaction with ', self environmentName.
	w paneColor: MuOGUI replColor.
	w addMorph: (REPLMorph on: self) frame: (0@0 corner: 1@1).
	w openInWorld! !

!PluggableMemory methodsFor: 'REPL' stamp: 'spfa 11/18/2009 18:15'!
outputStream

	"dummy"

	^ WriteStream on: ''! !

!PluggableMemory methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:15'!
paragraph

	^ paragraph! !

!TextMorph methodsFor: '*PluggableMemory' stamp: 'spfa 11/18/2009 18:17'!
paragraph: anObject
	paragraph := anObject! !

!Morph methodsFor: '*PluggableMemory' stamp: 'spfa 10/24/2017 00:41'!
pluggableMemory

	^ super pluggableMemory ifNil: [
		(self valueOfProperty: #pluggableMemory) in: [:pm |
			pm ifNotNil: [PluggableMemory registerMorph: self].
			^ super pluggableMemory]]! !

!Object methodsFor: '*PluggableMemory' stamp: 'spfa 11/18/2009 18:15'!
pluggableMemory

	(PluggableMemory dictionary includesKey: self)
		ifTrue: [^ PluggableMemory for: self].

	^ nil! !

!PluggableMemory methodsFor: 'REPL' stamp: 'spfa 11/29/2011 14:12'!
prompt

	^ '>'! !

!PluggableMemory methodsFor: 'as yet unclassified' stamp: 'spfa 6/21/2017 21:45'!
query: qString proposed: pString onCancelDo: cBlock

	| aFillInTheBlankMorph m answer |

	m := Morph new.

	aFillInTheBlankMorph := (MemoryInteractionMorph editor: self)
		setQuery: qString
		initialAnswer: pString
		answerExtent: LegacyFillInTheBlankMorph defaultAnswerExtent
		acceptOnCR: false.

	aFillInTheBlankMorph responseUponCancel: m.

	World addMorph: aFillInTheBlankMorph centeredNear: Display center.

	answer := aFillInTheBlankMorph getUserResponse.

	answer == m ifTrue: [^ cBlock value].

	^ answer
! !

!PluggableMemory methodsFor: 'as yet unclassified' stamp: 'spfa 9/12/2019 22:14'!
rebind: anObject

	|  oname nname |

	oname := bindings keyAtValue: anObject.
	nname := (FillInTheBlank request: 'binding name' initialAnswer: oname) ifEmpty: [^ self].
	
	bindings removeKey: oname.
	bindings add: (nname -> anObject).
	
	anObject isMorph ifTrue: [anObject name: nname]! !

!PluggableMemory class methodsFor: 'as yet unclassified' stamp: 'spfa 10/24/2017 00:42'!
registerMorph: aMorph

	Memories at: aMorph put: (aMorph valueOfProperty: #pluggableMemory) ! !

!TextMorph methodsFor: '*PluggableMemory-override' stamp: 'spfa 11/18/2009 18:17'!
releaseEditor 
	"Release the editor for my paragraph.  This morph no longer 'hasFocus'."
	editor ifNotNil:
		[self selectionChanged.
		self paragraph selectionStart: nil selectionStop: nil.
		self editor: nil].! !

!LegacyFillInTheBlankMorph class methodsFor: 'instance creation' stamp: 'spfa 11/28/2016 11:02'!
request: queryString
	"Create an instance of me whose question is queryString. Invoke it centered at the cursor, and answer the string the user accepts. Answer the empty string if the user cancels."
	"FillInTheBlankMorph request: 'What is your favorite color?'"

	^ self
		request: queryString
		initialAnswer: ''
		centerAt: (ActiveHand ifNil:[Sensor]) cursorPoint! !

!LegacyFillInTheBlankMorph class methodsFor: 'instance creation' stamp: 'spfa 11/28/2016 11:02'!
request: queryString initialAnswer: defaultAnswer 
	"Create an instance of me whose question is queryString with the given initial answer. Invoke it centered at the given point, and answer the string the user accepts. Answer the empty string if the user cancels."
	"FillInTheBlankMorph
		request: 'What is your favorite color?'
		initialAnswer: 'red, no blue. Ahhh!!'"

	^ self
		request: queryString
		initialAnswer: defaultAnswer
		centerAt: ActiveHand cursorPoint! !

!LegacyFillInTheBlankMorph class methodsFor: 'instance creation' stamp: 'spfa 11/28/2016 11:02'!
request: queryString initialAnswer: defaultAnswer centerAt: aPoint
	"Create an instance of me whose question is queryString with the given initial answer. Invoke it centered at the given point, and answer the string the user accepts. Answer the empty string if the user cancels.
	This variant is only for calling from within a Morphic project."
	"FillInTheBlankMorph
		request: 'Type something, then type CR.'
		initialAnswer: 'yo ho ho!!'
		centerAt: Display center"

	 ^ self 
		request: queryString 
		initialAnswer: defaultAnswer 
		centerAt: aPoint 
		inWorld: ActiveWorld
! !

!LegacyFillInTheBlankMorph class methodsFor: 'instance creation' stamp: 'spfa 11/28/2016 11:02'!
request: queryString initialAnswer: defaultAnswer centerAt: aPoint inWorld: aWorld
	"Create an instance of me whose question is queryString with the given initial answer. Invoke it centered at the given point, and answer the string the user accepts.  Answer the empty string if the user cancels."
	"FillInTheBlankMorph
		request: 'Type something, then type CR.'
		initialAnswer: 'yo ho ho!!'
		centerAt: Display center"

	^ self request: queryString initialAnswer: defaultAnswer centerAt: aPoint inWorld: aWorld onCancelReturn: ''! !

!LegacyFillInTheBlankMorph class methodsFor: 'instance creation' stamp: 'spfa 11/28/2016 11:02'!
request: queryString initialAnswer: defaultAnswer centerAt: aPoint inWorld: aWorld onCancelReturn: returnOnCancel
	"Create an instance of me whose question is queryString with the given initial answer. Invoke it centered at the given point, and answer the string the user accepts.   If the user cancels, answer returnOnCancel.  If user hits cr, treat it as a normal accept."

	"FillInTheBlankMorph
		request: 'Type something, then type CR.'
		initialAnswer: 'yo ho ho!!'
		centerAt: Display center"

	^ self request: queryString initialAnswer: defaultAnswer centerAt: aPoint inWorld: aWorld onCancelReturn: returnOnCancel acceptOnCR: true! !

!LegacyFillInTheBlankMorph class methodsFor: 'instance creation' stamp: 'spfa 11/28/2016 11:02'!
request: queryString initialAnswer: defaultAnswer centerAt: aPoint inWorld: aWorld onCancelReturn: returnOnCancel acceptOnCR: acceptBoolean
	"Create an instance of me whose question is queryString with the given initial answer. Invoke it centered at the given point, and answer the string the user accepts.   If the user cancels, answer returnOnCancel."

	^ self request: queryString initialAnswer: defaultAnswer centerAt: aPoint 
		inWorld: aWorld onCancelReturn: returnOnCancel 
		acceptOnCR: acceptBoolean answerExtent: self defaultAnswerExtent! !

!LegacyFillInTheBlankMorph class methodsFor: 'instance creation' stamp: 'spfa 11/28/2016 11:02'!
request: queryString initialAnswer: defaultAnswer centerAt: aPoint inWorld: aWorld onCancelReturn: returnOnCancel acceptOnCR: acceptBoolean answerExtent: answerExtent
	"Create an instance of me whose question is queryString with the given initial answer. Invoke it centered at the given point, and answer the string the user accepts.   If the user cancels, answer returnOnCancel."
	"FillInTheBlankMorph
		request: 'Type something, then type CR.'
		initialAnswer: 'yo ho ho!!'
		centerAt: Display center"

	| aFillInTheBlankMorph |
	aFillInTheBlankMorph := self new
		setQuery: queryString
		initialAnswer: defaultAnswer
		answerExtent: answerExtent
		acceptOnCR: acceptBoolean.
	aFillInTheBlankMorph responseUponCancel: returnOnCancel.
	aWorld addMorph: aFillInTheBlankMorph centeredNear: aPoint.
	^ aFillInTheBlankMorph getUserResponse
! !

!LegacyFillInTheBlankMorph class methodsFor: 'instance creation' stamp: 'spfa 11/28/2016 11:02'!
request: queryString initialAnswer: defaultAnswer centerAt: aPoint inWorld: aWorld onCancelReturn: returnOnCancel acceptOnCR: acceptBoolean answerHeight: answerHeight
	"Create an instance of me whose question is queryString with the given initial answer. Invoke it centered at the given point, and answer the string the user accepts.   If the user cancels, answer returnOnCancel."
	^ self request: queryString initialAnswer: defaultAnswer centerAt: aPoint 
		inWorld: aWorld onCancelReturn: returnOnCancel acceptOnCR: acceptBoolean 
		answerExtent: self defaultAnswerExtent x @ answerHeight! !

!LegacyFillInTheBlankMorph class methodsFor: 'instance creation' stamp: 'spfa 11/28/2016 11:02'!
requestPassword: queryString
	"Create an instance of me whose question is queryString. Invoke it centered at the cursor, and answer the string the user accepts. Answer the empty string if the user cancels."
	"use password font"
	"FillInTheBlankMorph requestPassword: 'Password?'"

	^ self
		requestPassword: queryString
		initialAnswer: ''
		centerAt: Sensor cursorPoint
		inWorld: World
		onCancelReturn: ''
		acceptOnCR: true
! !

!LegacyFillInTheBlankMorph class methodsFor: 'instance creation' stamp: 'spfa 11/28/2016 11:02'!
requestPassword: queryString initialAnswer: defaultAnswer centerAt: aPoint inWorld: aWorld onCancelReturn: returnOnCancel acceptOnCR: acceptBoolean
	"Create an instance of me whose question is queryString with the given initial answer. Invoke it centered at the given point, and answer the string the user accepts.   If the user cancels, answer returnOnCancel."
	"FillInTheBlankMorph
		request: 'Type something, then type CR.'
		initialAnswer: 'yo ho ho!!'
		centerAt: Display center"

	| aFillInTheBlankMorph |
	aFillInTheBlankMorph := self new
		setPasswordQuery: queryString
		initialAnswer: defaultAnswer
		answerHeight: 50
		acceptOnCR: acceptBoolean.
	aFillInTheBlankMorph responseUponCancel: returnOnCancel.
	aWorld addMorph: aFillInTheBlankMorph centeredNear: aPoint.
	^ aFillInTheBlankMorph getUserResponse
! !

!LegacyFillInTheBlankMorph methodsFor: 'accessing' stamp: 'spfa 11/28/2016 11:02'!
response

	^ response
! !

!LegacyFillInTheBlankMorph methodsFor: 'accessing' stamp: 'spfa 11/28/2016 11:02'!
response: aText
	"Sent when text pane accepts."

	response := aText asString.
	done := true.
	^ true
! !

!MemoryInteractionMorph methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:13'!
response: aText
	"Sent when text pane accepts."

	memory history addFirst: aText string.
	response := textPane textMorph editor compileOrFailWith: [^ false].
	textPane getTextSelector: #name. "dummy"
	done := true.
	^ true

! !

!LegacyFillInTheBlankMorph methodsFor: 'initialization' stamp: 'spfa 11/28/2016 11:02'!
responseUponCancel: anObject
	responseUponCancel := anObject
! !

!LegacyFillInTheBlankMorph class methodsFor: 'preferences' stamp: 'spfa 11/28/2016 11:02'!
roundedDialogCorners
	<preference: 'Rounded Dialog Corners'
		category: 'windows'
		description: 'Governs whether dialog windows should have rounded corners'
		type: #Boolean>
	^ RoundedDialogCorners ifNil: [ true ]! !

!LegacyFillInTheBlankMorph class methodsFor: 'preferences' stamp: 'spfa 11/28/2016 11:02'!
roundedDialogCorners: aBoolean
	
	RoundedDialogCorners := aBoolean.
	self allInstances do: [:instance | 
		aBoolean 
			ifTrue: [instance useRoundedCorners]
			ifFalse: [instance useSquareCorners]].! !

!MemoryInteractionMorph methodsFor: 'as yet unclassified' stamp: 'spfa 3/31/2011 12:21'!
scrollHistoryBy: aNumber

	| newText |

	dh := (dh ifNil: [0])+ aNumber.
	dh abs > 1 ifFalse: [^ self].
	memory history ifEmpty: [^ self].

	newText := memory history atIndex: dh.

"	textPane setText: newText."
	memory selectAll.
	memory zapSelectionWith: newText.
	textPane setText: memory paragraph text.
	memory morph: textPane textMorph.
	textPane textMorph editor: memory. 
	textPane hasUnacceptedEdits: true.

! !

!PluggableMemory methodsFor: 'hack' stamp: 'spfa 3/31/2011 12:43'!
selectFrom: start to: stop
	"Select the specified characters inclusive."
	self selectInvisiblyFrom: start to: stop.! !

!LegacyFillInTheBlankMorph methodsFor: 'accessing' stamp: 'spfa 11/28/2016 11:02'!
selectionInterval
	^ 1 to: response size
! !

!LegacyFillInTheBlankMorph methodsFor: 'People-spfa-fixes' stamp: 'spfa 2/7/2017 13:22'!
setDefaultParameters
	"change the receiver's appareance parameters"

	| colorFromMenu worldColor menuColor |

	colorFromMenu := Preferences menuColorFromWorld
									and: [Display depth > 4
									and: [(worldColor := self currentWorld color) isColor]].

	menuColor := colorFromMenu
						ifTrue: [worldColor luminance > 0.7
										ifTrue: [worldColor mixed: 0.85 with: Color black]
										ifFalse: [worldColor mixed: 0.4 with: Color white]]
						ifFalse: [Preferences menuColor].

	self color: menuColor.
	self borderWidth: MuOInfo menuBorderWidth.

	Preferences menuAppearance3d ifTrue: [
		self borderStyle: BorderStyle thinGray.
		self hasDropShadow: true.
		
		([self useSoftDropShadow] on: Error do: [false])
			ifFalse: [
				self
					shadowColor: (TranslucentColor r: 0.0 g: 0.0 b: 0.0 alpha: 0.666);
					shadowOffset: 1 @ 1]
			ifTrue: [
				self
					shadowColor: (TranslucentColor r: 0.0 g: 0.0 b: 0.0 alpha: 0.01);
					shadowOffset: (10@8 corner: 10@12) ]
	]
	ifFalse: [
		| menuBorderColor |
		menuBorderColor := colorFromMenu
										ifTrue: [worldColor muchDarker]
										ifFalse: [Preferences menuBorderColor].
		self borderColor: menuBorderColor.
	].


	self layoutInset: 3.
! !

!LegacyFillInTheBlankMorph methodsFor: 'initialization' stamp: 'spfa 11/28/2016 11:02'!
setPasswordQuery: queryString initialAnswer: initialAnswer answerHeight: answerHeight acceptOnCR: acceptBoolean
	| pane |
	self setQuery: queryString 
		initialAnswer: initialAnswer 
		answerHeight: answerHeight 
		acceptOnCR: acceptBoolean.
	pane := self submorphNamed: 'textPane'.
	pane font: (StrikeFont passwordFontSize: 12).! !

!LegacyFillInTheBlankMorph methodsFor: 'initialization' stamp: 'spfa 11/28/2016 11:02'!
setQuery: queryString initialAnswer: initialAnswer answerExtent: answerExtent acceptOnCR: acceptBoolean 
	| query topOffset accept cancel buttonAreaHeight |
	response := initialAnswer.
	done := false.
	self removeAllMorphs.
	self layoutPolicy: ProportionalLayout new.
	query := self createQueryTextMorph: queryString.
	topOffset := query height + 4.
	accept := self createAcceptButton.
	cancel := self createCancelButton.
	buttonAreaHeight := (accept height max: cancel height)
				+ 7.
	textPane := self
				createTextPaneExtent: answerExtent
				acceptBoolean: acceptBoolean
				topOffset: topOffset
				buttonAreaHeight: buttonAreaHeight.
	self extent: (query extent x max: answerExtent x)
			+ 4 @ (topOffset + answerExtent y + 4 + buttonAreaHeight).
	! !

!MemoryInteractionMorph methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:13'!
setQuery: queryString initialAnswer: initialAnswer answerExtent: answerExtent acceptOnCR: acceptBoolean 
	| query topOffset accept cancel buttonAreaHeight |
	response := initialAnswer.
	done := false.
	self removeAllMorphs.
	self layoutPolicy: ProportionalLayout new.
	query := self createQueryTextMorph: queryString.
	topOffset := query height + 4.
	accept := self createAcceptButton.
	cancel := self createCancelButton.

	self createBindingsButton.
	self createHistoryButton.
	self createHistoryWheel.

	buttonAreaHeight := (accept height max: cancel height)
				+ 4.
	textPane := self
				createTextPaneExtent: answerExtent
				acceptBoolean: acceptBoolean
				topOffset: topOffset
				buttonAreaHeight: buttonAreaHeight.
	self extent: (query extent x max: answerExtent x)
			+ 4 @ (topOffset + answerExtent y + 4 + buttonAreaHeight).
	! !

!LegacyFillInTheBlankMorph methodsFor: 'initialization' stamp: 'spfa 11/28/2016 11:02'!
setQuery: queryString initialAnswer: initialAnswer answerHeight: answerHeight acceptOnCR: acceptBoolean
	self setQuery: queryString initialAnswer: initialAnswer 
		answerExtent: (self class defaultAnswerExtent x @ answerHeight) 
		acceptOnCR: acceptBoolean
! !

!WheelMorph methodsFor: 'accessing' stamp: 'ti 3/13/2000 12:47'!
target
	^target! !

!WheelMorph methodsFor: 'accessing' stamp: 'ti 3/13/2000 12:48'!
target: aTargetObject
	target := aTargetObject! !

!PluggableMemoryTest methodsFor: 'as yet unclassified' stamp: 'spfa 12/21/2012 18:22'!
testEvaluate

	| o |

	o := Dictionary new.

	self assert: (o evaluate: 'self' onError: [nil]) == o.
	self assert: (o evaluate: 'self class' onError: [nil]) == Dictionary.

	o evaluate: 'yo := 42' onError: [nil].
	self assert: (o evaluate: '10 * yo' onError: [nil]) = 420.

	self assert: o pluggableMemory history isEmpty! !

!PluggableTextMorph methodsFor: '*PluggableMemory' stamp: 'spfa 11/18/2009 18:15'!
textMorph
	^textMorph! !

!LegacyFillInTheBlankMorph methodsFor: 'grabbing/dropping' stamp: 'spfa 11/28/2016 11:02'!
undoGrabCommand
	^nil! !

!LegacyFillInTheBlankMorph methodsFor: 'initialization' stamp: 'spfa 11/28/2016 11:02'!
updateColor
	"update the recevier's fillStyle"
	| textPaneBorderColor |
	self
		updateColor: self
		color: self color
		intensity: 1.
	textPane isNil
		ifTrue: [^ self].
	textPaneBorderColor := self borderColor == #raised
				ifTrue: [#inset]
				ifFalse: [self borderColor].
	textPane borderColor: textPaneBorderColor! !

!LegacyFillInTheBlankMorph methodsFor: 'initialization' stamp: 'spfa 11/28/2016 11:02'!
updateColor: aMorph color: aColor intensity: anInteger 
	"update the apareance of aMorph"
	| fill |
	Preferences gradientMenu
		ifFalse: [^ self].

	fill := GradientFillStyle ramp: {0.0 -> Color white. 1 -> aColor}.
	fill radial: false;
		origin: aMorph topLeft;
		direction: 0 @ aMorph height.
	aMorph fillStyle: fill! !

!PluggableMemory methodsFor: 'hack' stamp: 'spfa 11/18/2009 18:15'!
userHasEdited! !

!PluggableMemory methodsFor: 'as yet unclassified' stamp: 'spfa 4/16/2019 15:30'!
valueOf: aString

	^ (self bindingOf: aString) value! !

!Morph methodsFor: '*PluggableMemory' stamp: 'spfa 11/7/2010 17:02'!
wantsTransparentPM

	^ (self valueOfProperty: #transparentPluggableMemory) ~~ false! !

!Object methodsFor: '*PluggableMemory' stamp: 'spfa 11/7/2010 17:00'!
wantsTransparentPM

	^ true! !
PluggableMemory initialize!
